PRINT N'Altering Procedure [dbo].[GetNLUByAppId]...';


GO
--exec [GetNLU] NULL,'test2'
ALTER PROCEDURE [dbo].[GetNLUByAppId] (
	@VCC Varchar(50) = NULL, 
	@AppId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT 
			N.[VCC]							'vcc',
			N.[Name]						'name',
			N.[CognitiveEngine]				'cognitiveEngine',
			N.[Culture]						'culture',
			N.[Description]					'description',
			N.[AppId]						'appId',
			N.[SubscriptionKey]				'subscriptionKey',
			N.[IsSystemApp]					'isSystemApp',
			N.[NeedTrain]					'needTrain',
			N.[LastTrainedDate]				'lastTrainedDateTime',
			N.[LastPublishedDate]			'lastPublishedDateTime',
			N.[CreatedDate]					'createdDate',
			N.[CreatedByUserId]				'createdByUserId',
			N.[LastModifiedDate]			'lastModifiedDate',
			N.[LastModifiedByUserId]		'lastModifiedByUserId',
		    N.[Status]                      'status',
		    N.[StatusCode]                  'statusCode',
            N.[NeedPublish]                 'needPublish',
			N.[TrainId]						'trainId',
			N.[TrainVersion]				'trainVersion'
       
	FROM [dbo].[NLU] N (NOLOCK)
	WHERE N.[VCC] = CASE WHEN ISNULL(@VCC, '') = '' THEN N.[VCC] ELSE @VCC END 
		AND N.[AppId] = @AppId
	
	SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[GetNlusUsage]...';


GO
ALTER PROCEDURE [dbo].[GetNlusUsage]
(
	@VCC	    VARCHAR(50),
	@NluNames		VARCHAR(MAX)= NULL
)
AS
BEGIN
	SET NOCOUNT ON

	DECLARE @NLUS TABLE (
	  ID VARCHAR(200),
	  QueryId VARCHAR(200)
	)
	
		DECLARE @FOUND_IN_TTI BIT = 0
		
	    DECLARE @FOUND_IN_ABILITY BIT = 0
	    
	    DECLARE @IN_USE BIT =0
    
		INSERT INTO @NLUS SELECT CONCAT(N.[Name],'|',I.[Name]),I.[IntentId] FROM [NLU] N (NOLOCK) 
		JOIN [Intent] I (NOLOCK) ON (N.[AppId] = I.[AppId] AND N.[VCC] = I.[VCC]) 
		WHERE N.[VCC] = @VCC AND N.[Name] IN (SELECT [Value] FROM [dbo].[Split](@NluNames,','))

	

	   -- VALIDAR PARA ESTUDIOS
	   IF(EXISTS( SELECT TTI.[ID] FROM  [TemplateThemeItem] TTI (NOLOCK) 
				  INNER JOIN [Template] TT (NOLOCK) ON TTI.[TemplateId] = TT.[Name] AND TTI.[Vcc] = TT.[Vcc]
				  INNER JOIN [STUDY] S (NOLOCK) ON TT.[Name] = S.[TemplateId] AND TT.[Vcc] =S.[Vcc] AND S.[StatusDescription] = 'IN_PROGRESS'
	   WHERE TTI.VCC = @VCC AND TTI.[ID] IN (SELECT [ID] FROM @NLUS)))
	  				
	   BEGIN 
	        SET @FOUND_IN_TTI = 1
	   END


	   --VALIDAR PARA PLAN
	
		 IF(EXISTS( SELECT [QueryId] FROM AbilityQuery AQ (NOLOCK) 
					INNER JOIN AbilityEvaluationFormat AEF (NOLOCK) ON  AQ.AbilityId =  AEF.[IdAbility]
					INNER JOIN EvaluationPlan EP (NOLOCK) ON AEF.[IdEvaluationFormat] = EP.[IdEvaluationFormat] AND EP.StatusDescription = 'IN_PROGRESS'
		 WHERE [VCC] = @VCC AND [QueryId] IN (SELECT [QueryId] FROM @NLUS) )) 
		 BEGIN 
		 SET @FOUND_IN_ABILITY = 1
		 END 
		 
		  IF(@FOUND_IN_TTI=1 OR @FOUND_IN_ABILITY =1 )
		  BEGIN 
		  SET @IN_USE = 1
		  END 
		
	  SELECT @IN_USE AS 'inUse'
	
		SET NOCOUNT OFF
	END
GO
PRINT N'Altering Procedure [dbo].[UpdateNluAppId]...';


GO
ALTER PROCEDURE [dbo].[UpdateNluAppId]
(
	@VCC	    VARCHAR(50),
	@AppId      VARCHAR(50),
	@NewAppId   VARCHAR(50),
	@Culture    VARCHAR(10) = '',
	@CognitiveEngine  VARCHAR(50) = '',
    @UseRasaApi BIT = NULL
)
AS
BEGIN
	SET NOCOUNT ON
	
	--ACTUALIZAR LOS REGISTROS CON EL NUEVO APPID
	IF (@CognitiveEngine = 'NEW_RASA_ENGINE' AND @UseRasaApi = 1)
	SET @CognitiveEngine  = 'RASAAPI'
	
    IF (@CognitiveEngine = 'NEW_RASA_ENGINE' AND @UseRasaApi = 0)
	SET @CognitiveEngine  = 'RASA'

	--CONSULTAR SI AL MENOS TIENE UNA INTENCION Y FRASES PARA ENVIAR A ENTRENAR
	DECLARE @MinUtteranceNumber INT
	SELECT  @MinUtteranceNumber = COUNT(*) FROM dbo.[Utterance] U
	INNER JOIN dbo.[Intent] I ON 
	U.IntentId = I.IntentId
	AND U.VCC =I.VCC
	WHERE U.VCC = @VCC 
	AND U.AppId = @AppId
	
	UPDATE [dbo].[NLU] 
	SET [AppId] = @NewAppId,
	[Culture] = @Culture,
	[LastPublishedDate] = NULL,
	[LastTrainedDate] = NULL,
	[LastModifiedDate] = GETUTCDATE(),
	[IsPublished] = 0,
	[IsTrained] = 0,
	[NeedTrain] = IIF(@MinUtteranceNumber >= 1, 1, 0),
	[NeedPublish] = 0,
	[TrainVersion] = null,
	[TrainId]= null,
	[CognitiveEngine] = @CognitiveEngine
	WHERE [VCC] = @VCC AND [AppId] = @AppId

	UPDATE [dbo].[Intent] SET [AppId] = @NewAppId WHERE [VCC] = @VCC AND [AppId] = @AppId

	UPDATE [dbo].[Utterance] SET [AppId] = @NewAppId WHERE [VCC] = @VCC AND [AppId] = @AppId
	
	UPDATE [dbo].[Entity] SET [AppId] = @NewAppId WHERE [VCC] = @VCC AND [AppId] = @AppId

	SELECT 1 AS result

	SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[GetNluIntentUtteranceToExport]...';


GO

ALTER PROCEDURE [dbo].[GetNluIntentUtteranceToExport]
(
	@VCC	VARCHAR(50),
	@ListMode INT = 0,
    @UseRasaApi BIT = null
)
AS
BEGIN
	SET NOCOUNT ON
    --@ListMode = 0 resumen de nlus a exportar VCC A VCC solo los que no son de sistema
    --@ListMode = 1 listado de nlus a exportar VCC A VCC solo los que no son de sistema
    --@ListMode = 2 resumen de nlus a exportar RASA A RASAAPI O VICEVERSA todos los nlu de todo el sistema
    --@ListMode = 3 listado de nlus a exportar RASA A RASAAPI O VICEVERSA todos los nlu de todo el sistema
	
	DECLARE @NLU TABLE(
	 [Name] VARCHAR(50),
	 AppId VARCHAR(50)
	)
	DECLARE @Intent TABLE (
	ID VARCHAR(50)
	)

    IF (@ListMode = 0 OR @ListMode = 1)
    BEGIN
        INSERT INTO @NLU SELECT [Name],[AppId] FROM [NLU]  (NOLOCK) WHERE [VCC] = @VCC AND [IsSystemApp] = 0 AND [Status] <> 4
        INSERT INTO @Intent SELECT [IntentId] FROM [Intent] (NOLOCK) WHERE [VCC] = @VCC AND [AppId] IN (SELECT [AppId] FROM @NLU)
    END
    ELSE
    BEGIN
        INSERT INTO @NLU SELECT  [Name],[AppId] FROM [NLU]  (NOLOCK) WHERE [VCC] = @VCC  AND [Status] <> 4 AND [CognitiveEngine] = IIF(@UseRasaApi = 1,'RASA','RASAAPI')
			
    END
   

	IF(@ListMode = 0) -- CONTAR TOTAL DE REGISTROS
	   BEGIN

        DECLARE @TotalNlu INT = 0
        DECLARE @TotalIntent INT = 0
        DECLARE @TotalUtterance INT = 0
        DECLARE @TotalEntity INT = 0
        DECLARE @NluNames VARCHAR(MAX) = NULL
                
        SELECT @TotalNlu = COUNT([Name]) FROM [NLU] (NOLOCK) WHERE [VCC] = @VCC AND [Name] IN (SELECT [Name] FROM @NLU)

        SELECT @TotalIntent = COUNT([IntentId]) FROM [Intent] (NOLOCK) WHERE [VCC] = @VCC AND [IntentId] IN (SELECT ID FROM @Intent)

        SELECT @TotalUtterance = COUNT([Id]) FROM [Utterance] (NOLOCK) WHERE [VCC] = @VCC AND [IntentId] IN (SELECT ID FROM @Intent)
                
        SELECT @TotalEntity = COUNT([ID]) FROM [dbo].[Entity] WHERE [VCC] = @VCC AND [AppId] IN (SELECT [AppId] FROM @NLU)

        SELECT @TotalNlu AS TotalNlu,@TotalIntent AS TotalIntent,@TotalUtterance AS TotalUtterance, @TotalEntity AS TotalEntity
                
        SELECT @NluNames = STUFF(( SELECT ',' + [Name] FROM [NLU]  WHERE [VCC] = @VCC AND [IsSystemApp] = 0 FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, '')
            
       
		--SELECT 0 'InUse'
         EXEC [GetNlusUsage] @VCC,@NluNames

	   END
	   IF (@ListMode = 1)
	   BEGIN
	   --NLUS
	       SELECT 
	       [Name]                name,
	       [Name]                originalName,
	       [Culture]             culture, 
	       [Description]         description,
	       [AppId]               appId,
	       [CognitiveEngine]     cognitiveEngine,
	       0                     'status',
	       0                    'totalRetries'
	       FROM [NLU] (NOLOCK) WHERE [VCC] = @VCC AND [Name] IN (SELECT [Name] FROM @NLU)
					--INTENTS
					   SELECT
			[Name]     'name',
			[IntentId] 'intentId',
			[AppId]     'appId',
			CONCAT([AppId],'[::]',[IntentId]) 'key',
			0                     'status',
	        0                    'totalRetries'
			FROM [Intent] (NOLOCK) WHERE [VCC] = @VCC AND [IntentId] IN (SELECT ID FROM @Intent)
					--UTTERANCES  
					  
			 SELECT DISTINCT
			 U.[Id] 'id',
			 U.[AppId]       'appId',
			 I.[Name]    'intent',
			 U.[IntentId] 'intentId',
			 U.[Text] 'name',
			 (SELECT [EntityName] 'entityName',[Start] 'start',[End] 'end' 
			 FROM [UtteranceEntity] (NOLOCK) WHERE [VCC] = @VCC AND [UtteranceId] IN(U.[Id]) FOR JSON AUTO) 'rawEntityLabels',
			 CONCAT(U.[AppId],'[::]',U.[IntentId],'[::]',U.[Id]) 'key',
			 CONCAT(U.[AppId],'[::]',I.[IntentId]) 'intentKey',
			 0                     'status',
			 0                    'totalRetries'
			 
			 FROM [Utterance] U (NOLOCK) 
			 JOIN [Intent] I (NOLOCK)
			 ON (U.VCC = I.VCC AND U.IntentId = I.IntentId)
			 WHERE U.[VCC] = @VCC AND U.[IntentId] IN (SELECT ID FROM @Intent)
			 
			  --ENTITIES
			 SELECT 
			 [AppId] 'appId',
			 [ID] 'id',
			 [Name] 'name',
			 CONCAT([AppId],'[::]',[ID]) 'key',
			  0                     'status',
			 0                    'totalRetries'
			 FROM [dbo].[Entity] WHERE [VCC] = @VCC AND [AppId] IN (SELECT [AppId] FROM @NLU)
	   END
       IF (@ListMode = 2)
       BEGIN
        IF(@VCC ='ALL') --LISTAR RESUMEN PARA TODOS LOS VCCS RASA O RASAAPI
        BEGIN
                WITH ALL_NLUS AS (
                    SELECT   N.[VCC],N.[CognitiveEngine],
                    (SELECT COUNT(1) FROM [dbo].[Nlu] WHERE VCC = N.[VCC] AND appid = N.appid) 'totalNlu',
					0 'totalIntent',
                    0 'totalUtterance',
                    0 'totalEntity'


                    FROM [dbo].[Nlu] N WHERE 
                    N.[CognitiveEngine] = IIF(@UseRasaApi = 1,'RASA','RASAAPI')
                )

                SELECT TOP 1 
                    AN.[VCC]                'vcc',
                    AN.[CognitiveEngine]    'cognitiveEngine',
                    SUM(TotalNlu)               'totalNlu',
                    SUM(TotalIntent)            'totalIntent',
                    SUM(TotalUtterance)         'totalUtterance',
                    SUM(TotalEntity)            'totalEntity'
                FROM ALL_NLUS AN
                    INNER JOIN [dbo].[VCC] V ON V.[VCC] = AN.[VCC]
                WHERE V.[IsMigrating] = 0 
                    GROUP BY AN.[VCC],  AN.[CognitiveEngine]	
            		
        END
        SELECT 0 'InUse'
      END
     IF (@ListMode = 3)
	   BEGIN
	   --NLUS
	       SELECT 
	       [Name]                name,
	       [Name]                originalName,
	       [Culture]             culture, 
	       [Description]         description,
	       [AppId]               appId,
	       [CognitiveEngine]     cognitiveEngine,
	       0                     'status',
	       0                    'totalRetries'
	       FROM [NLU] (NOLOCK) WHERE [VCC] = @VCC AND [Name] IN (SELECT [Name] FROM @NLU)
		 --INTENTS
			SELECT
			[Name]     'name',
			[IntentId] 'intentId',
			[AppId]     'appId',
			CONCAT([AppId],'[::]',[IntentId]) 'key',
			0                     'status',
	        0                    'totalRetries'
			FROM [Intent] (NOLOCK) WHERE [VCC] = @VCC AND [IntentId] IN (SELECT ID FROM @Intent)

		-- UTTERANCES  
					  
			 SELECT  DISTINCT
			 U.[Id] 'id',
			 U.[AppId]       'appId',
			 I.[Name]    'intent',
			 U.[IntentId] 'intentId',
			 U.[Text] 'name',
			 (SELECT [EntityName] 'entityName',[Start] 'start',[End] 'end' 
			 FROM [UtteranceEntity] (NOLOCK) WHERE [VCC] = @VCC AND [UtteranceId] IN(U.[Id]) FOR JSON AUTO) 'rawEntityLabels',
			 CONCAT(U.[AppId],'[::]',U.[IntentId],'[::]',U.[Id]) 'key',
			 CONCAT(U.[AppId],'[::]',I.[IntentId]) 'intentKey',
			 0                     'status',
			 0                    'totalRetries'
			 
			 FROM [Utterance] U (NOLOCK) 
			 INNER JOIN [Intent] I (NOLOCK)
			 ON (U.VCC = I.VCC AND U.IntentId = I.IntentId)
			 WHERE U.[VCC] = @VCC  AND U.[IntentId] IN (SELECT ID FROM @Intent)
			 
		--ENTITIES
				 SELECT 
				 [AppId] 'appId',
				 [ID] 'id',
				 [Name] 'name',
				 CONCAT([AppId],'[::]',[ID]) 'key',
				  0                     'status',
				 0                    'totalRetries'
				 FROM [dbo].[Entity] WHERE [VCC] = @VCC AND [AppId] IN (SELECT ID FROM @Intent)
	   END

	SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[GetAgentsFromEvaluation]...';


GO
-- ESTE SP RETORNA LOS AGENTES ASOCIADOS A EVALUACIONES
ALTER PROCEDURE [dbo].[GetAgentsFromEvaluation] 
(
	@VCC					VARCHAR(50) = NULL,
	@UserId					VARCHAR(50) = NULL,
	@Campaigns				VARCHAR(MAX) = NULL,
	@SearchType				VARCHAR(50) = NULL,
	@EfectivityMode			BIT = 0 
) 
AS
BEGIN
	-- DECLARAMOS UN CADENA PARA EL QUERY FINAL
	DECLARE @SQL_SELECT VARCHAR(MAX) = '';
	DECLARE @SQL_FROM VARCHAR(MAX) = '';
	DECLARE @SQL_FROM_EFECTIVITY VARCHAR(MAX) = '';
	DECLARE @SQL_FILTER VARCHAR(MAX) = '';
	DECLARE @SQL_FILTER_EFECTIVITY VARCHAR(MAX) = '';
	DECLARE @SQL_EXTRA VARCHAR(MAX) = '';

	-- ARMAMOS EL QUERY PARA HACER LA CONSULTA
	SET @SQL_SELECT += '
		SELECT DISTINCT IEP.[Instance]							''vcc'', 
						IEP.[IdAgent]							''userId''
						-- IEP.[IdCampaign]						''campaignId'' -- NO SE USA APARENTEMENTE (PROBLEMA SAT V.3.7.0) '

	-- ARMAMOS LA PARTE DE TABLAS 
	SET @SQL_FROM += '
			FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) 
			INNER JOIN [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				ON IEP.[Instance] = AEP.[Instance]
					AND IEP.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
					AND IEP.[IdInteraction] = AEP.[IdInteraction] '
	SET @SQL_FROM_EFECTIVITY += '
			FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) 
			INNER JOIN [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				ON IEP.[Instance] = AEP.[Instance]
					AND IEP.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
					AND IEP.[IdInteraction] = AEP.[IdInteraction] 
			INNER JOIN (
				SELECT DISTINCT [VCC],
								[InteractionId],
								[AgentId],
								[EvaluationPlanId],
								[AuditorId] 
					FROM [dbo].[EvaluationResultEfectivity] (NOLOCK)
					WHERE [VCC] = ''' + @VCC + ' '' 
						AND [EfectivityStatus] IN (''' + 'CREATED' + '''' + ',' + '''' + 'DRAFT' + ''''+ ')' + '
			) AS ERE ON 
				(AEP.[Instance] = ERE.[VCC] 
					AND AEP.[IdEvaluationPlan] = ERE.[EvaluationPlanId]
					AND AEP.[IdInteraction] = ERE.[InteractionId])'	

	-- ARMAMOS LA PARTE DE FILTROS
	SET @SQL_FILTER += '
			WHERE AEP.[Instance] = ''' + @VCC + ''' AND LEN(IEP.[IdAgent]) > 0'
	SET @SQL_FILTER_EFECTIVITY += '
			WHERE AEP.[Instance] = ''' + @VCC + ''' AND LEN(IEP.[IdAgent]) > 0'

	-- ARMAMOS LA PARTE DE EXTRAS
	SET @SQL_EXTRA = '
			ORDER BY IEP.[IdAgent] ASC '

	-- FILTRAMOS SEGUN EL TIPO DE BUSQUEDA
	IF @SearchType = 'PENDING'
	BEGIN
		-- HACEMOS LA BUSQUEDA SOBRE LAS INTERACCIONES QUE NO HAN SIDO EVALUADAS
		SET @SQL_FILTER += '
			AND AEP.[Completed] = 0 '
	END
	ELSE IF @SearchType = 'HISTORY'
	BEGIN
		-- HACEMOS LA BUSQUEDA SOBRE LAS INTERACCIONES QUE YA HAN SIDO EVALUADAS
		SET @SQL_FILTER += '
			AND AEP.[Completed] = 1 '
	END

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR EL ROLE DEL USUARIO
	DECLARE @USER_ROLE VARCHAR(50) 
	SELECT TOP 1 @USER_ROLE = U.[Role] 
		FROM [dbo].[User] U (NOLOCK) 
		WHERE U.[VCC] = @VCC
			AND U.[ID] = @UserId

	-- FILTRAMOS SEGUN EL ROLE DEL USUARIO
	-- IF @RoleId = 'administrator, quality_admin'
	IF @USER_ROLE = 'quality_auditor'
	BEGIN
		-- HACEMOS LA BUSQUEDA SOBRE LAS INTERACCIONES AUDITADAS POR EL USUARIO
		SET @SQL_FILTER += '
			AND AEP.[IdAuditor] = ''' + @UserId + ''' '
		SET @SQL_FILTER_EFECTIVITY += '
			AND ERE.[AuditorId] = ''' + @UserId + ''' '
	END
	ELSE IF @USER_ROLE = 'quality_agent'
	BEGIN
		-- HACEMOS LA BUSQUEDA SOBRE LAS INTERACCIONES HECHAS POR EL USUARIO
		SET @SQL_FILTER += '
			AND AEP.[IdAgent] = ''' + @UserId + ''' '
	END

	-- FILTRAMOS SEGUN EL VALOR DE CAMPAIGNS
	IF @Campaigns IS NOT NULL AND @Campaigns <> ''
	BEGIN
		SET @SQL_FILTER += '
			AND AEP.[IdCampaign] IN (SELECT Value FROM [dbo].[split](''' + @Campaigns + ''','','')) '
        SET @SQL_FILTER_EFECTIVITY += '
			AND AEP.[IdCampaign] IN (SELECT Value FROM [dbo].[split](''' + @Campaigns + ''','','')) '
	END 

	-- UNIMOS LAS PARTES DEL QUERY
	IF (@EfectivityMode =1)
	SET @SQL_SELECT += @SQL_FROM_EFECTIVITY + @SQL_FILTER_EFECTIVITY + @SQL_EXTRA
	ELSE
	SET @SQL_SELECT += @SQL_FROM + @SQL_FILTER + @SQL_EXTRA
	
	-- EJECUTAMOS LA CONSULTA
	-- PRINT @SQL_SELECT
	EXEC (@SQL_SELECT)
	
END
GO
PRINT N'Altering Procedure [dbo].[GetEvaluationPlanInteractionByTypeAndId]...';


GO
ALTER PROCEDURE [dbo].[GetEvaluationPlanInteractionByTypeAndId] (
	@VCC VARCHAR(50) = NULL,
	@EvaluationPlanId VARCHAR(50) = NULL,
	@InteractionType VARCHAR(50) = NULL,
	@InteractionId VARCHAR(250) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- RECUPERAMOS EL PRIMER REGISTRO POR ID DE INTERACCION
	SELECT TOP 1 IEP.[Instance]											'vcc',
					IEP.[IdAgent]										'descriptionAgent',
					''													'descriptionAuditor',
					IEP.[IdCampaign]									'descriptionCampaign',
					EP.[Description]									'descriptionEvaluationPlan',
					IEP.[InteractionDateStart]							'dateIni',
					IEP.[InteractionDateEnd]							'dateFin',
					IEP.[IdInteraction]									'id',
					IEP.[IdAgent]										'idAgent',
					IEP.[AgentName]										'agentName',
					''													'idAuditorEvaluationPlan',
					IEP.[IdCampaign]									'idCampaign',
					IEP.[IdEvaluationPlan]								'idEvaluationPlan',
					IEP.[InteractionType]								'interactionType',
					IEP.[InteractionDuration]							'interactionTime',
					A.[DurationLinguisticTime]							'interactionValidTime',
					''													'origin',
					IEP.[InteractionMessages]							'totalMessages',
					CASE
						WHEN IEP.[InteractionType] = 'SMS'
							THEN ISNULL(IEP.[ContactId], IEP.[ContactName])
							ELSE ISNULL(A.[Number], IEP.[ContactId])
					END													'number',
					IEP.[NeedI6Update]									'needI6Update',
					IEP.[Ender]										    'ender',
					IEP.[ManagementResult]								'managementResult',
					IEP.[Ticket]                                        'ticket'
					/*
					IIF (
						E.[Type] = 'i6',
						ISNULL(
							A.[NeedI6Update], 
							CAST(1 AS BIT)	
						),
						CAST(0 AS BIT)
					)													'needI6Update'
					*/

		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK) 
			ON EP.[Instance] = IEP.[Instance]
				AND EP.[ID] = IEP.[IdEvaluationPlan]
		LEFT JOIN [dbo].[Environment] E (NOLOCK) 
			ON E.[VCC] = IEP.[Instance]
				AND E.[Name] = EP.[EnvironmentId]
		LEFT JOIN [dbo].[Audio] A (NOLOCK)
			ON A.[VCC] = IEP.[Instance]
				AND A.[ID] = IEP.[IdInteraction]
				AND A.[Section] = IEP.[InteractionSection]
				AND A.[Part] = IEP.[InteractionPart]
		WHERE IEP.[Instance] = @VCC
			AND IEP.[IdEvaluationPlan] = @EvaluationPlanId
			AND IEP.[InteractionType] = @InteractionType
			AND IEP.[IdInteraction] = @InteractionId

	SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[GetI6AlreadyRegisteredCallInteractions]...';


GO
ALTER PROCEDURE [dbo].[GetI6AlreadyRegisteredCallInteractions] (@VCC VARCHAR(50) = NULL)
AS
BEGIN
	-- CRUZAMOS LA TABLA TEMPORAL CON LAS INTERACCIONES DE LA API CON LA TABLA AUDIO
	SELECT DISTINCT A.[VCC]														'vcc',
					CONCAT(A.[ID], '_', A.[Section], '_', A.[Part])				'ID',
					A.[ID]														'InteractionId',
					A.[Section]													'Secction',
					A.[Part]													'Part',
					'CALL'														'Channel',
					A.[Number]													'Number',
					A.[ContactAddress]											'ContactAdress',
					A.[Gender]													'Gender',
					A.[SilenceTime]												'SilenceTime',
					A.[DurationTime]											'DurationTime',
					A.[DurationTime]											'AttentionTime',
					1															'TotalParts',
					A.[Category1]												'Category1',
					A.[Category2]												'Category2',
					A.[Category3]												'Category3',
					A.[Description]												'Description',
					A.[DispositionCode]											'DispositionCode',
					A.[Campaign]												'Campaign',
					A.[Agent]													'Agent',
					A.[AgentName]												'agentName',
					A.[Type]													'Type',
					A.[StartDate]												'StartDate',
					A.[EndDate]													'EndDate',
					A.[Format]													'Format',
					ISNULL(A.[NeedI6Update], CAST(1 AS BIT))					'needI6Update',
					A.[Ender]													'ender',
					A.[ticket]													'ticket'
		FROM [#InteractionsTemp] IT
		INNER JOIN [dbo].[Audio] A (NOLOCK)
			ON A.[VCC] = IT.[VCC]
				AND  A.[ID] = IT.[InteractionId]
		WHERE IT.[VCC] = @VCC
	

END
GO
PRINT N'Altering Procedure [dbo].[GetI6AlreadyRegisteredTextInteractions]...';


GO
ALTER PROCEDURE [dbo].[GetI6AlreadyRegisteredTextInteractions] (@VCC VARCHAR(50) = NULL)
AS
BEGIN
	-- CRUZAMOS LA TABLA TEMPORAL CON LAS INTERACCIONES DE LA API CON LA TABLA ASYNCINTERACTION
	SELECT DISTINCT AI.[VCC]													'vcc',
					AI.[ID]														'id',
					AI.[ID]														'InteractionId',
					AI.[Folder]													'folder',
					AI.[ExportedContent]										'exportedContent',
					AI.[Channel]												'channel',
					AI.[Campaign]												'campaign',
					AI.[StartDate]												'startDate',
					AI.[EndDate]												'endDate',
					AI.[Account]												'account',
					AI.[Initiative]												'initiative',
					AI.[ContactName]											'contactName',
					AI.[ContactAddress]											'contactAdress',
					AI.[ContactId]												'contactId',
					AI.[FirstTakedAgent]										'firstTakedAgent',
					AI.[LastTakedAgent]											'lastTakedAgent',
					AI.[TotalMessages]											'totalMessages',
					AI.[DurationTime]											'durationTime',
					AI.[AttentionTime]											'attentionTime',
					AI.[DispositionCode]										'dispositionCode',
					AI.[DispositionTreePath]									'dispositionTreePath',
					AI.[RawChar]												'rawChar',
					ISNULL(AI.[NeedI6Update], CAST(1 AS BIT))					'needI6Update',
					AI.[Ender]													'ender',
					AI.[ticket]													'ticket'
		FROM [#InteractionsTemp] IT
		INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
			ON AI.[VCC] = IT.[VCC]
				AND  AI.[ID] = IT.[InteractionId]
				AND AI.[Folder] = IT.[Folder]
		WHERE IT.[VCC] = @VCC
	
END
GO
PRINT N'Altering Procedure [dbo].[GetProcessInteractionsByProcessId]...';


GO
 ALTER PROCEDURE [dbo].[GetProcessInteractionsByProcessId]
(
	@VCC		VARCHAR(50) = NULL,
	@ProcessId	VARCHAR(50) = NULL,
	@ResultType VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- ESTA FUNCION RETORNA LAS INTERACCIONES DE TEXTO Y AUDIO RELACIONADA A UN PROCESS

	IF @ResultType = 'RAW' 
	BEGIN
		-- RESULTADO TIPO RAW GENERA UN RESULTADO CON LOS DATOS Y NOMBRES DE COLUMNAS COMO VIENEN DE HD

		SELECT CONCAT(A.[ID], '_', A.[Section], '_', A.[PArt])				'ID',
				A.[ID]														'InteractionId',
				A.[Section]													'Section',
				A.[Part]													'Part',
				'CALL'														'Channel',
				A.[Number]													'Number',
				A.[Gender]													'Gender',
				A.[SilenceTime]												'Silence',
				A.[DurationTime]											'DurationTime',
				A.[DurationTime]											'AtentionTime',
				A.[Category1]												'Category1',
				A.[Category2]												'Category2',
				A.[Category3]												'Category3',
				A.[Description]												'Description',
				A.[DispositionCode]											'DispositionCode',
				A.[Campaign]												'Campaign',
				A.[Agent]													'Agent',
				A.[Number]													'contactName',
				A.[Type]													'Type',
				A.[StartDate]												'StartDate',
				A.[EndDate]													'EndDate',
				NULL														'Format',
				A.[ValidChar]												'validChar',
				A.[TotalPhrases]											'totalPhrases',
				A.[ContactAddress]											'contactAddress',
				A.[NeedI6Update]											'needI6Update',
				A.[Ender]													'ender',
				A.[ticket]													'ticket'
			FROM [dbo].[ProcessAudio] PA (NOLOCK)
			INNER JOIN [dbo].[Audio] A (NOLOCK)
				ON A.[VCC] = PA.[VCC]
					AND A.[ID] = PA.[AudioId]
					AND A.[Section] = PA.[Section]
					AND A.[Part] = PA.[Part]
			WHERE PA.[VCC] = @VCC
				AND PA.[ProcessId] = @ProcessId
				

		SELECT PAI.[VCC]													'vcc', 
				PAI.[InteractionId]											'id', 
				PAI.[FormattedEndDate]										'folder',
				AI.[ExportedContent]										'exportedContent',
				PAI.[InteractionType]										'channel',
				PAI.[Campaign]												'campaign',
				AI.[StartDate]												'startDate',
				AI.[EndDate]												'endDate',
				AI.[Account]												'account',
				AI.[Initiative]												'initiative',
				AI.[ContactName]											'contactName',
				AI.[ContactAddress]											'contactAddress',
				AI.[FirstTakedAgent]										'firstTakedAgent',
				AI.[LastTakedAgent]											'lastTakedAgent', 
				AI.[IsTaken]												'isTaken',
				AI.[TotalMessages]											'totalMessages',
				AI.[DurationTime]											'durationTime',
				AI.[AttentionTime]											'attentionTime',
				AI.[DispositionCode]										'dispositionCode',
				AI.[DispositionTreePath]									'dispositionTreePath',
				CASE WHEN AI.[TotalPhrases] IS NULL 
					THEN AI.[RawChar] ELSE 0 END							'rawChar',
				ISNULL(AI.[TotalPhrases], 0)								'totalPhrases',
				AI.[NeedI6Update]											'needI6Update',
				AI.[Ender]													'ender',
				AI.[ticket]													'ticket'
			FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
			INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON AI.[VCC] = PAI.[VCC]
					AND AI.[ID] = PAI.[InteractionId]
					AND AI.[Channel] = PAI.[InteractionType]
					AND AI.[Folder] = PAI.[FormattedEndDate]
			WHERE PAI.[VCC] = @VCC
				AND PAI.[ProcessId] = @ProcessId
				
	END

	SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[SaveEvaluationFormat]...';


GO

ALTER PROCEDURE [dbo].[SaveEvaluationFormat] (
	@Instance Varchar(50) = NULL, 						
	@ID Varchar(50) = NULL,
	@Description Varchar(50) = NULL,
	@Type Varchar(50) = NULL,
	@EnvironmentType VARCHAR(50) = NULL,
	@CreatedDate Datetime = NULL,						
	@CreatedByUserId Varchar(50) = NULL,		
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId Varchar(50) = NULL,			
	@MinQualificationAcceptable numeric(5,2),	
	@MinAutomaticQualification NUMERIC(5, 2),
	@ManagementFormURL varchar(1000) = NULL,
	@Enabled bit = NULL, 
	@templateId Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- Danny Jhonston:
	-- Inicio:
	-- Validar si el formato tiene al menos un plan asignado.
	-- Validar si el formato tiene un plan de evaluacion que tiene evaluaciones pendientes.

	-- DECLARE @ID VARCHAR(50)
	-- SET @ID = '183fedb7-9dbf-4b1c-8efd-b1164f33c8ba'

	-- Tabla temporal para almacenar resultado de consulta.
	/*DECLARE @EvaluationsData TABLE (
		[ID]						VARCHAR(50),
		[totalEvaluations]			INT,
		[completedEvaluations]		INT
	)
	INSERT INTO @EvaluationsData
	SELECT
		EP.[ID]									'id',
		COUNT(AEP.[IdInteraction])				'totalEvaluations',
		SUM(CAST(AEP.[Completed] AS INT))		'completedEvaluations'
	FROM
		[dbo].[EvaluationPlan] EP
		INNER JOIN [dbo].[AuditorEvaluationPlan] AEP ON EP.[ID] = AEP.[IdEvaluationPlan]
	WHERE
		EP.[Instance] = @Instance
		AND EP.[IdEvaluationFormat] = @ID
	GROUP BY EP.[ID]

	-- Contiene las evaluaciones de un formato.
	DECLARE @TotalEvaluations INT
	SET @TotalEvaluations = (SELECT COUNT([ID]) FROM @EvaluationsData WHERE (CAST([completedEvaluations] AS NUMERIC(18, 2)) / CAST([totalEvaluations] AS NUMERIC(18, 2))) * 100 > 0)
	-- SET @TotalEvaluations = (SELECT COUNT([ID]) FROM @EvaluationsData WHERE [totalEvaluations] > [completedEvaluations])

	--PRINT @TotalEvaluations
	IF(@TotalEvaluations < 1)
	BEGIN
		BEGIN
			-- Tiene evaluaciones asociadas que en al menos se esta evaluando un plan de evaluacion.
			SELECT CAST(-1 AS INT) 'idEvaluationFormat'
			PRINT @@ROWCOUNT
		END
	END
	ELSE
	-- Danny Jhonston:
	-- Fin:
	*/
	BEGIN
		-- No tiene evaluaciones asociadas.
		-- Debe continuar con el guardado.

		UPDATE [EvaluationFormat] SET
			[Description] = @Description,
			[Type] = @Type,
			[EnvironmentType] = @EnvironmentType,
			[MinQualificationAcceptable] = @MinQualificationAcceptable,
			[MinAutomaticQualification] = @MinAutomaticQualification,
			[ManagementFormURL] = @ManagementFormURL,
			[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
			[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
			[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[Enabled] = CASE WHEN @Enabled IS NULL THEN 1 ELSE @Enabled END,
			[TimeStamp] = GETUTCDATE(),
			[templateId] = @templateId
		WHERE [Instance] = @Instance
		AND [ID] = @ID

		

		IF @@ROWCOUNT = 0
			INSERT INTO [EvaluationFormat] (
				[Instance],[ID], [Description], [Type], 
				[EnvironmentType], [MinQualificationAcceptable], [MinAutomaticQualification], [ManagementFormURL],
				[CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId],
				[Enabled], [TimeStamp], [templateId]
				)
			VALUES (
				@Instance, @ID, @Description, @Type, 
				@EnvironmentType, @MinQualificationAcceptable, @MinAutomaticQualification, @ManagementFormURL,
				@CreatedDate, @CreatedByUserId, @LastModifiedDate, @LastModifiedByUserId,
				@Enabled, GETUTCDATE(), @templateId
			)

		SELECT CAST(Scope_Identity() AS INT) as 'idEvaluationFormat';
	END

	

    SET NOCOUNT OFF
END
GO
PRINT N'Refreshing Procedure [dbo].[GetFiltersFromEvaluation]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetFiltersFromEvaluation]';


GO
PRINT N'Update complete.';
