--sche
PRINT N'Altering Procedure [dbo].[CreateVcc]...';


GO
ALTER PROCEDURE [dbo].[CreateVcc] (
	@VCC Varchar(50) = NULL, 
	@ID Varchar(50) = NULL,
	@Description Varchar(50) = NULL,
	@Type VARCHAR(50) = NULL,
	@TranscriptionDefaultLanguage VARCHAR(25) = NULL,
	@CognitiveEngine VARCHAR(25) = NULL,
	@Country Varchar(50) = NULL,
	@Language Varchar(50) = NULL,
	@TimeZone Varchar(50) = NULL,
	@CreatedDate Datetime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId   VARCHAR(50) = NULL,
	@DeleteDataDays         INT = 360,
	@UseRasaApi				BIT = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	BEGIN TRY
    BEGIN TRANSACTION


	INSERT INTO [dbo].[VCC] (
			[VCC], 
			[ID], 
			[Description], 
			[Type], 
			[Country], 
			[TranscriptionDefaultLanguage], 
			[CognitiveEngine], 
			[Language],
			[TimeZone], 
			[CreatedDate], 
			[CreatedByUserId], 
			[LastModifiedDate], 
			[LastModifiedByUserId], 
			[DeleteDataDays], 
			[TimeStamp]
			)
	VALUES (
			@VCC, 
			@ID, 
			@Description, 
			@Type, 
			@Country, 
			@TranscriptionDefaultLanguage, 
			@CognitiveEngine, 
			@Language, 
			@TimeZone, 
			@CreatedDate,  
			@CreatedByUserId, 
			@LastModifiedDate, 
			@LastModifiedByUserId, 
			@DeleteDataDays,
			GETUTCDATE()
		)
	
	DECLARE @VCC_SYSTEM       VARCHAR(50) = 'system'

    --INSERTAR ROLES
	
	DECLARE @ROLES TABLE(
    [ID]            VARCHAR(50),
    [Description]   VARCHAR(50),
	[CreatedDate]   DATETIME,
    [CreatedByUserId] VARCHAR(50),
    [LastModifiedDate] DATETIME,
    [LastModifiedByUserId] VARCHAR(50),
	[SystemRole]    BIT,
    [Type]                 VARCHAR(50)
	)
	INSERT INTO @ROLES EXEC [dbo].[GetRoles] @VCC_SYSTEM,'name',''

	IF(EXISTS(SELECT [ID] FROM @ROLES))
	BEGIN
			INSERT INTO [dbo].[Role] (
					[VCC],
					[ID], 
					[Description],
					[CreatedDate], 
					[CreatedByUserId], 
					[LastModifiedDate],
					[LastModifiedByUserId],
					[SystemRole],
					[Type],
					[TimeStamp]
					)
			SELECT @VCC,
				   [ID],
				   [Description],
				   GETUTCDATE(), 
				   [CreatedByUserId],
				   GETUTCDATE(),
				   [LastModifiedByUserId],
				   [SystemRole],
				   [Type],
				   GETUTCDATE()
			FROM @ROLES
     END
	 ELSE
	 BEGIN
	       RAISERROR('SERVER_ERROR_ROLES_NOT_FOUND', 16, 16)
	 END

	--INSERTAR PERMISOS PARA LOS ROLES

	DECLARE @CountLicense INT = 0
	DECLARE @License      VARCHAR(50)
	
	DECLARE @ROLE_PERMISSIONS TABLE(
	 [ID]      VARCHAR(50),
	 [GroupId] VARCHAR(200)
	)
	DECLARE @ROUTE_PERMISSIONS TABLE(
	 [ID]      VARCHAR(50),
	 [Route]   VARCHAR(250),
	 [Level]   VARCHAR(50),
	 [GroupId] VARCHAR(200)
	)

	SET @CountLicense = (SELECT COUNT(*) FROM [dbo].[VCCLicense] (NOLOCK) WHERE [VCC] = @VCC AND [Status] = 1)
	
	IF(@CountLicense>1)
	BEGIN
	    INSERT INTO @ROLE_PERMISSIONS EXEC [dbo].[GetRolePermission] @VCC_SYSTEM,''
		INSERT INTO @ROUTE_PERMISSIONS EXEC [dbo].[GetRoleRoutePermission] @VCC_SYSTEM
	END

	IF(@CountLicense=1)
	BEGIN
	    SET @License = (SELECT Product FROM [dbo].[VCCLicense] (NOLOCK) WHERE [VCC] = @VCC AND [Status] = 1)
	    INSERT INTO @ROLE_PERMISSIONS EXEC [dbo].[GetRolePermission] @VCC_SYSTEM,'', @License
		INSERT INTO @ROUTE_PERMISSIONS EXEC [dbo].[GetRoleRoutePermission] @VCC_SYSTEM,'', @License
	END
	
	INSERT INTO [dbo].[RolePermission] (
			    [VCC], 
				[RoleId], 
				[GroupId],
			    [TimeStamp]
			    ) 
				SELECT 
				@VCC,
				[ID],
				[GroupId],
			    GETUTCDATE()
				FROM @ROLE_PERMISSIONS

	INSERT INTO [dbo].[RoutePermission] (
			[VCC], 
			[ID], 
			[GroupId],
			[Route], 
			[Level], 
			[TimeStamp]
			)
			SELECT 
			@VCC,
			[ID],
			[GroupId],
			[Route],
			[Level],
			GETUTCDATE()
			FROM @ROUTE_PERMISSIONS


    --INSERTAR GRUPOS DE PERMISOS PARA LOS ROLES
	DECLARE @ROLE_PERMISSIONS_GROUP TABLE(
	 [Category] VARCHAR(50),
	 [GroupId]  VARCHAR(200),
	 [Type]     VARCHAR(50)
	)

	INSERT INTO @ROLE_PERMISSIONS_GROUP EXEC [dbo].[GetRolePermissionsGroups] @VCC_SYSTEM

	INSERT INTO [dbo].[RolePermissionsGroup] (
			                              [VCC], 
										  [GroupId], 
										  [Category], 
										  [Type], 
										  [TimeStamp]
										  )
		                                 SELECT 
										 @VCC, 
										 GroupId,
										 Category,
										 [Type], 
										 GETUTCDATE()	
										 FROM @ROLE_PERMISSIONS_GROUP

    --INSERTAR FEELINGS
	INSERT INTO [dbo].[Feeling] (
			                   [VCC], 
							   [Name], 
							   [Description],
							   [CreatedDate], 
							   [CreatedByUserId], 
							   [LastModifiedDate], 
							   [LastModifiedByUserId], 
							   [TimeStamp]
							   )
							   SELECT
							   @VCC,
							   [Name],
							   [Description],
							   GETUTCDATE(),
							   [CreatedByUserId],
							   GETUTCDATE(),
							   [LastModifiedByUserId],
							   GETUTCDATE()	
							   FROM [dbo].[Feeling] (NOLOCK)
							   WHERE [VCC] = @VCC_SYSTEM

    --INSERTAR PROGRAMACION NEUROLINGUISTICA
	INSERT INTO [dbo].[NeuroLinguisticProgramming] (
								[VCC],
								[Name],
								[Description],
								[CreatedDate],
								[CreatedByUserId],
								[LastModifiedDate], 
								[LastModifiedByUserId],
								[TimeStamp]
								)
								SELECT 
								@VCC,
								[Name],
								[Description],
								GETUTCDATE(),
								[CreatedByUserId],
								GETUTCDATE(),
								[LastModifiedByUserId],
								GETUTCDATE()
								FROM [dbo].[NeuroLinguisticProgramming] (NOLOCK)
								WHERE [VCC] = @VCC_SYSTEM
		
   --INSERTAR PALABRAS
   IF(EXISTS(SELECT [Name] FROM [dbo].[Word] (NOLOCK) WHERE [VCC] = @VCC_SYSTEM))
   BEGIN
		   INSERT INTO [dbo].[Word](
					[VCC],
					[NeuroLinguisticProgrammingId],
					[Name],
					[ProcessId],
					[Language],
					[Type],
					[CreatedDate],
					[CreatedByUserId],
					[LastModifiedDate],
					[LastModifiedByUserId],
					[TimeStamp]
					)
				SELECT
				@VCC,
				[NeuroLinguisticProgrammingId],
				[Name],
				[ProcessId],
				[Language],
				[Type],
				GETUTCDATE(),
				[CreatedByUserId],
				GETUTCDATE(),
				[LastModifiedByUserId],
				GETUTCDATE()
			   FROM [dbo].[Word] (NOLOCK)
			   WHERE [VCC] = @VCC_SYSTEM
   END
   ELSE
   BEGIN
	       RAISERROR('SERVER_ERROR_WORD_NOT_FOUND', 16, 16)
   END

   --INSERTAR CATEGORIAS
   INSERT INTO [dbo].[Category] (
			[VCC], 
			[Name], 
			[Description],
			[CreatedDate], 
			[CreatedByUserId], 
			[LastModifiedDate], 
			[LastModifiedByUserId], 
			[TimeStamp]
			)
		SELECT 
		@VCC,
		[Name],
		[Description],
		GETUTCDATE(),
		[CreatedByUserId],
		GETUTCDATE(),
		[LastModifiedByUserId],
		GETUTCDATE()
	FROM [dbo].[Category] (NOLOCK)
	WHERE [VCC] = @VCC_SYSTEM

	--INSERTAR AMBIENTES
	IF(@Type <> 'OTHER')
	BEGIN
		DECLARE @NAME VARCHAR(100)
		SELECT @NAME = [Word] FROM [dbo].[WordsByLanguage] (NOLOCK) WHERE [Language] = @Language AND [Label] = 'ENVIRONMENT' 
		
		-- DECLARAMOS UNA VARIABLE PARA SETTEAR EL TIPO DE AMBIENTE INTEGRADO PARA EL VCC
		DECLARE @VCC_TYPE VARCHAR(25) = NULL
		IF (@Type = 'ALLEGRO' OR @Type = 'OCC') SET @VCC_TYPE = 'allegro'
		ELSE IF @Type = 'I6' SET @VCC_TYPE = 'i6'
		
		INSERT INTO [dbo].[Environment] (
			[VCC], 
			[Name], 
			[Type],
			[Description],
			[FTPDirectory],
			[ApiHost],
			[ApiPort],
			[ApiUser],
			[DbDisabled],
			[DbServer],
			[DbPort],
			[DbUser], 
			[PbxDisabled],
			[PbxServer],
			[PbxPort],
			[PbxUser],
			[ApiPassword],
			[DbPassword],
			[PbxPassword],
			[CreatedDate],
			[CreatedByUserId],
			[TimeStamp]
		)
			SELECT @VCC,
					@NAME,
					[Type],
					@NAME,
					[FTPDirectory],
					[ApiHost],
					[ApiPort],
					[ApiUser],
					[DbDisabled],
					[DbServer],
					[DbPort],
					[DbUser],
					[PbxDisabled],
					[PbxServer]	,
					[PbxPort],
					[PbxUser],
					[ApiPassword],
					[DbPassword],
					[PbxPassword],
					GETUTCDATE(),
					[CreatedByUserId],
					GETUTCDATE()
				FROM [dbo].[Environment] (NOLOCK)
				WHERE [VCC] = @VCC_SYSTEM
					AND [Type] = @VCC_TYPE

	END


	--INSERTAR PERMISOS PARA CATEGORIAS
	INSERT INTO [dbo].[CategoryPermissions](
			[VCC], 
			[Category], 
			[Position], 
			[TimeStamp]
			)
			SELECT
			@VCC,
		    [Category],
			[Position],
			GETUTCDATE()
			FROM [dbo].[CategoryPermissions] (NOLOCK) 
			WHERE [VCC] = @VCC_SYSTEM
			GROUP BY [Category],[Position]
		  

   --INSERTAR TENANT
   DECLARE @TENANT TABLE(
    [TenantId]     VARCHAR(50),
    [ClientId]     VARCHAR(50),
    [ClientSecret] VARCHAR(50),
    [Resource]     VARCHAR(50)
	)
	
	INSERT INTO @TENANT EXEC [dbo].[GetTenantVCCByVCC] @VCC_SYSTEM
	IF(EXISTS(SELECT [TenantId] FROM @TENANT))
	BEGIN

		INSERT INTO [dbo].[TenantVCC](
		[VCC], 
		[TenantId], 
		[ClientId], 
		[ClientSecret], 
		[Resource], 
		[CreatedDate], 
		[CreatedByUserId], 
		[TimeStamp])
		SELECT 
		@VCC,
		[TenantId],
		[ClientId],
		[ClientSecret],
		[Resource],
		GETUTCDATE(),
		@CreatedByUserId,
		GETUTCDATE()
		FROM @TENANT

	END
	ELSE
	BEGIN
	   RAISERROR('SERVER_ERROR_TENANT_NOT_FOUND', 16, 16)
	END

	--INSERTAR NLU
	IF(EXISTS(SELECT [Name] FROM [dbo].[NLU] WHERE [IsSystemApp]=1 AND [VCC] = @VCC_SYSTEM))
	BEGIN
		INSERT INTO [dbo].[NLU] (
					[VCC], 
					[Name], 
					[Culture],
					[Description], 
					[AppId], 
					[NeedTrain],
					[SubscriptionKey],
					[IsSystemApp], 
					[CreatedDate], 
					[CreatedByUserId], 
					[LastModifiedDate], 
					[LastModifiedByUserId], 
					[TimeStamp],
					[CognitiveEngine]
		)
			SELECT @VCC,
					[Name], 
					[Culture],
					[Description], 
					CONCAT(@VCC,'::',[Name]), 
					0,
					[SubscriptionKey],
					[IsSystemApp], 
					GETUTCDATE(), 
					[CreatedByUserId], 
					GETUTCDATE(), 
					[LastModifiedByUserId], 
					GETUTCDATE(),
					CASE WHEN @UseRasaApi = 0 THEN 'RASA' ELSE 'RASAAPI' END
				FROM [dbo].[NLU] (NOLOCK)
				WHERE [IsSystemApp]=1 
					AND [VCC] = @VCC_SYSTEM
					AND [Name] NOT LIKE 'sentiment-%'
	    
		
		

		-- INSERTAMOS LOS REGISTROS DE MODELOS DE DIARIZACION
        INSERT INTO [dbo].[Intent](
			[VCC], 
			[Name],
			[IntentId],
			[AppId],
			[CreatedDate],
			[CreatedByUserId],
			[LastModifiedDate], 
			[LastModifiedByUserId], 
			[TimeStamp],
			[Status],
			[StatusCode]
		)
			SELECT @VCC,
					'Agent',
					'Agent',
					CONCAT(@VCC,'::',[Name]),
					GETUTCDATE(),
					@CreatedByUserId,
					GETUTCDATE(),
					@CreatedByUserId,
					GETUTCDATE(),
					1,
					'AVAILABLE'
			FROM [dbo].[NLU]
			WHERE [IsSystemApp]=1 
				AND [VCC] = @VCC_SYSTEM
				AND [Name] LIKE 'diarization-%'


		
	END
	ELSE
	BEGIN
	   RAISERROR('SERVER_ERROR_SYSTEM_APPS_SAVING_FAILED', 16, 16)
	END

	--INSERTAR DICCIONARIOS
	IF(EXISTS(SELECT [Name] FROM [dbo].[Dictionary] (NOLOCK) WHERE [VCC] = @VCC_SYSTEM))
	BEGIN 
	INSERT INTO [dbo].[Dictionary] (
			[VCC], 
			[Name], 
			[Description], 
			[Language], 
			[IsSystemDictionary], 
			[CreatedDate], 
			[CreatedByUserId], 
			[TimeStamp]
		)
		SELECT
		    @VCC,
		    [Name],
			[Description],
			[Language],
			[IsSystemDictionary],
			GETUTCDATE(),
			[CreatedByUserId],
			GETUTCDATE()
		FROM [dbo].[Dictionary] (NOLOCK)
		WHERE [VCC] = @VCC_SYSTEM
	END
	ELSE
	BEGIN
	    RAISERROR('SERVER_ERROR_SYSTEM_DICTIONARIES_SAVING_FAILED',16,16)
	END

	--INSERTAR TIPOS DE INTERACCIONES
	IF(EXISTS(SELECT [ID] FROM [dbo].[InteractionType] WHERE [Instance] = @VCC_SYSTEM ))
	BEGIN
	INSERT INTO [dbo].[InteractionType] (
			[Instance],
			[ID],
			[Description]
			)
			SELECT
			@VCC,
			[ID],
		    [Description]
			FROM InteractionType  (NOLOCK)
			WHERE [Instance] = @VCC_SYSTEM
	END
	ELSE
	BEGIN
	   RAISERROR('SERVER_ERROR_INTERACTION_TYPE_NOT_FOUND',16,16) 
	END

	--INSERTAR GENERIC QUERY
	IF(EXISTS(SELECT [Name] FROM [dbo].[GenericQuery] (NOLOCK) WHERE [VCC] = @VCC_SYSTEM))
	BEGIN
	INSERT INTO [dbo].[GenericQuery]
		(
			[VCC],
			[Name],
			[Description],
			[Query],
			[RawData],
			[CreatedDate],
			[CreatedByUserId],
			[LastModifiedDate], 
			[LastModifiedByUserId],
			[Version],
			[TimeStamp]
		)
		SELECT
		@VCC,
		[Name],--REPLACE([Name], @Language+'_', ''),
		[Description],
		[Query],
		[RawData],
		GETUTCDATE(),
		[CreatedByUserId],
		GETUTCDATE(),
		[LastModifiedByUserId],
		[Version],
		GETUTCDATE()
		FROM [dbo].[GenericQuery] (NOLOCK)
		WHERE [VCC] = @VCC_SYSTEM --AND [Name] LIKE @Language + '%'
	END
	ELSE
	BEGIN
	   RAISERROR('SERVER_ERROR_GENERIC_QUERY_NOT_FOUND',16,16) 
	END

	--INSERTAR  USUARIO AUDITOR SPEECH
	EXEC [dbo].[SaveSpeechAnalyticAuditorUser] @VCC

	--INSERTAR REPORTES
	IF(EXISTS(SELECT [ID] FROM  [dbo].[Report] (NOLOCK) WHERE [VCC] = @VCC_SYSTEM))
	BEGIN
	INSERT INTO [Report] (
			[VCC], 
			[ID], 
			[Description],
			[Type],
            [Procedure], 
			[StartDate],
			[EndDate],
            [Frecuency],
			[HourSpace],
			[ExactTime],
            [Weekday],
			[DayMonth],
			[Summary],
            [Filter], 
			[Email], 
			[CreatedDate],
            [CreatedByUserId],
			[LastModifiedDate],
			[LastModifiedByUserId],
            [TimeStamp]
        )
		SELECT
		        @VCC,
				[ID],
				[Description],
				[Type],
				[Procedure],
				[StartDate],
				[EndDate],
				[Frecuency],
				[HourSpace],
				[ExactTime],
				[Weekday],
				[DayMonth],
				[Summary],
				[Filter],
				[Email],
				GETUTCDATE(),
				@CreatedByUserId,
				GETUTCDATE(),
				@CreatedByUserId,
				GETUTCDATE()
			FROM [dbo].[Report] (NOLOCK)
			WHERE [VCC] = @VCC_SYSTEM

	END
	ELSE
	BEGIN
	   RAISERROR('SERVER_ERROR_REPORT_NOT_FOUND',16,16) 
	END

		-- INSERTAMOS LOS GRUPOS POR DEFECTO PARA COPC
		INSERT INTO [dbo].[Group] ([Instance], [ID], [Description], [CreatedDate], [CreatedByUserId], [TimeStamp], [Enabled])
			SELECT @VCC,
					G.[Description],
					WBL.[Word],
					GETUTCDATE(),
					'system',
					GETUTCDATE(),
					1
				FROM [dbo].[Group] G (NOLOCK)
				INNER JOIN [dbo].[WordsByLanguage] WBL (NOLOCK)
					ON WBL.[Label] = G.[Description]
				WHERE G.[Instance] = @VCC_SYSTEM
					AND WBL.[Language] = @Language

		-- INSERTAMOS LOS SUBGRUPOS POR DEFECTO PARA COPC
		INSERT INTO [dbo].[SubGroup] ([Instance], [ID], [Description], [CreatedDate], [CreatedByUserId], [TimeStamp], [Enabled])
			SELECT @VCC,
					SG.[Description],
					WBL.[Word],
					GETUTCDATE(),
					'system',
					GETUTCDATE(),
					1
				FROM [dbo].[SubGroup] SG (NOLOCK)
				INNER JOIN [dbo].[WordsByLanguage] WBL (NOLOCK)
					ON WBL.[Label] = SG.[Description]
				WHERE SG.[Instance] = @VCC_SYSTEM
					AND WBL.[Language] = @Language

	COMMIT TRANSACTION

    END TRY

    BEGIN CATCH

    IF @@TRANCOUNT > 0 
	BEGIN
		ROLLBACK TRANSACTION
		--ELIMINAR LOS REGISTROS SI HA FALLADO
		EXEC [dbo].[RollbackVcc] @VCC
	END

    DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
    DECLARE @Severity integer = ERROR_SEVERITY()
    DECLARE @State integer = ERROR_STATE()

    RAISERROR(@Message, @Severity, @State)
  
    END CATCH
    SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[GetNLUByAppId]...';


GO
--exec [GetNLU] NULL,'test2'
ALTER PROCEDURE [dbo].[GetNLUByAppId] (
	@VCC Varchar(50) = NULL, 
	@AppId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	DECLARE @VCC_NEW VARCHAR(50)
	SET @VCC_NEW = @VCC

	IF EXISTS(SELECT 1 FROM [NLU] WHERE [AppId] = @AppId AND [Name] LIKE 'sentiment-%')
	SELECT @VCC_NEW = VCC FROM [NLU] WHERE [AppId] = @AppId AND [Name] LIKE 'sentiment-%'


	SELECT 
			N.[VCC]							'vcc',
			N.[Name]						'name',
			N.[CognitiveEngine]				'cognitiveEngine',
			N.[Culture]						'culture',
			N.[Description]					'description',
			N.[AppId]						'appId',
			N.[SubscriptionKey]				'subscriptionKey',
			N.[IsSystemApp]					'isSystemApp',
			N.[NeedTrain]					'needTrain',
			N.[LastTrainedDate]				'lastTrainedDateTime',
			N.[LastPublishedDate]			'lastPublishedDateTime',
			N.[CreatedDate]					'createdDate',
			N.[CreatedByUserId]				'createdByUserId',
			N.[LastModifiedDate]			'lastModifiedDate',
			N.[LastModifiedByUserId]		'lastModifiedByUserId',
		    N.[Status]                      'status',
		    N.[StatusCode]                  'statusCode',
            N.[NeedPublish]                 'needPublish',
			N.[TrainId]						'trainId',
			N.[TrainVersion]				'trainVersion'
       
	FROM [dbo].[NLU] N (NOLOCK)
	WHERE N.[VCC] = CASE WHEN ISNULL(@VCC_NEW, '') = '' THEN N.[VCC] ELSE @VCC_NEW END 
		AND N.[AppId] = @AppId
	
	SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[GetNluIntentUtteranceToExport]...';


GO

ALTER PROCEDURE [dbo].[GetNluIntentUtteranceToExport]
(
	@VCC	VARCHAR(50),
	@ListMode INT = 0,
    @UseRasaApi BIT = NULL,
	@RatioRasaMigration INT
)
AS
BEGIN
	SET NOCOUNT ON
    --@ListMode = 0 resumen de nlus a exportar VCC A VCC solo los que no son de sistema
    --@ListMode = 1 listado de nlus a exportar VCC A VCC solo los que no son de sistema
    --@ListMode = 2 resumen de nlus a exportar RASA A RASAAPI O VICEVERSA todos los nlu de todo el sistema
    --@ListMode = 3 listado de nlus a exportar RASA A RASAAPI O VICEVERSA todos los nlu de todo el sistema
	
	DECLARE @NLU TABLE(
	
	 [Name] VARCHAR(50),
	 [AppId] VARCHAR(50),
	 [VCC] VARCHAR(50),
	 [CognitiveEngine] VARCHAR(50)
	)
	DECLARE @Intent TABLE (
	ID VARCHAR(50)
	)

    IF (@ListMode = 0 OR @ListMode = 1)
    BEGIN
        INSERT INTO @NLU SELECT [Name],[AppId],VCC,CognitiveEngine FROM [NLU]  (NOLOCK) WHERE [VCC] = @VCC AND [IsSystemApp] = 0 AND [Status] <> 4
        INSERT INTO @Intent SELECT [IntentId] FROM [Intent] (NOLOCK) WHERE [VCC] = @VCC AND [AppId] IN (SELECT [AppId] FROM @NLU)
    END
    ELSE
    BEGIN
        INSERT INTO @NLU SELECT TOP (@RatioRasaMigration)  [Name],[AppId],VCC,CognitiveEngine FROM [NLU]  (NOLOCK) WHERE [VCC] = @VCC  AND [Status] <> 2 AND [CognitiveEngine] = IIF(@UseRasaApi = 1,'RASA','RASAAPI')
			
    END
   

	IF(@ListMode = 0) -- CONTAR TOTAL DE REGISTROS
	   BEGIN

        DECLARE @TotalNlu INT = 0
        DECLARE @TotalIntent INT = 0
        DECLARE @TotalUtterance INT = 0
        DECLARE @TotalEntity INT = 0
        DECLARE @NluNames VARCHAR(MAX) = NULL
                
        SELECT @TotalNlu = COUNT([Name]) FROM [NLU] (NOLOCK) WHERE [VCC] = @VCC AND [Name] IN (SELECT [Name] FROM @NLU)

        SELECT @TotalIntent = COUNT([IntentId]) FROM [Intent] (NOLOCK) WHERE [VCC] = @VCC AND [IntentId] IN (SELECT ID FROM @Intent)

        SELECT @TotalUtterance = COUNT([Id]) FROM [Utterance] (NOLOCK) WHERE [VCC] = @VCC AND [IntentId] IN (SELECT ID FROM @Intent)
                
        SELECT @TotalEntity = COUNT([ID]) FROM [dbo].[Entity] WHERE [VCC] = @VCC AND [AppId] IN (SELECT [AppId] FROM @NLU)

        SELECT @TotalNlu AS TotalNlu,@TotalIntent AS TotalIntent,@TotalUtterance AS TotalUtterance, @TotalEntity AS TotalEntity
                
        SELECT @NluNames = STUFF(( SELECT ',' + [Name] FROM [NLU]  WHERE [VCC] = @VCC AND [IsSystemApp] = 0 FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, '')
            
       
		--SELECT 0 'InUse'
         EXEC [GetNlusUsage] @VCC,@NluNames

	   END
	   IF (@ListMode = 1)
	   BEGIN
	   --NLUS
	       SELECT 
	       [Name]                name,
	       [Name]                originalName,
	       [Culture]             culture, 
	       [Description]         description,
	       [AppId]               appId,
	       [CognitiveEngine]     cognitiveEngine,
	       0                     'status',
	       0                    'totalRetries'
	       FROM [NLU] (NOLOCK) WHERE [VCC] = @VCC AND [Name] IN (SELECT [Name] FROM @NLU)
					--INTENTS
					   SELECT
			[Name]     'name',
			[IntentId] 'intentId',
			[AppId]     'appId',
			CONCAT([AppId],'[::]',[IntentId]) 'key',
			0                     'status',
	        0                    'totalRetries'
			FROM [Intent] (NOLOCK) WHERE [VCC] = @VCC AND [IntentId] IN (SELECT ID FROM @Intent)
					--UTTERANCES  
					  
			 SELECT DISTINCT
			 U.[Id] 'id',
			 U.[AppId]       'appId',
			 I.[Name]    'intent',
			 U.[IntentId] 'intentId',
			 U.[Text] 'name',
			 (SELECT [EntityName] 'entityName',[Start] 'start',[End] 'end' 
			 FROM [UtteranceEntity] (NOLOCK) WHERE [VCC] = @VCC AND [UtteranceId] IN(U.[Id]) FOR JSON AUTO) 'rawEntityLabels',
			 CONCAT(U.[AppId],'[::]',U.[IntentId],'[::]',U.[Id]) 'key',
			 CONCAT(U.[AppId],'[::]',I.[IntentId]) 'intentKey',
			 0                     'status',
			 0                    'totalRetries'
			 
			 FROM [Utterance] U (NOLOCK) 
			 JOIN [Intent] I (NOLOCK)
			 ON (U.VCC = I.VCC AND U.IntentId = I.IntentId)
			 WHERE U.[VCC] = @VCC AND U.[IntentId] IN (SELECT ID FROM @Intent)
			 
			  --ENTITIES
			 SELECT 
			 [AppId] 'appId',
			 [ID] 'id',
			 [Name] 'name',
			 CONCAT([AppId],'[::]',[ID]) 'key',
			  0                     'status',
			 0                    'totalRetries'
			 FROM [dbo].[Entity] WHERE [VCC] = @VCC AND [AppId] IN (SELECT [AppId] FROM @NLU)
	   END
       IF (@ListMode = 2)
       BEGIN
        IF(@VCC ='ALL') --LISTAR RESUMEN PARA TODOS LOS VCCS RASA O RASAAPI
        BEGIN
					
				WITH ALL_NLUS AS (
                    SELECT   N.[VCC],
					N.[CognitiveEngine],
                    (SELECT COUNT(1) FROM NLU WHERE VCC = N.[VCC] AND appid = N.appid) 'totalNlu',
					0 'totalIntent',
                    0 'totalUtterance',
                    0 'totalEntity',
					[status] 'status'


                    FROM  NLU N WHERE 
                    N.[CognitiveEngine] = IIF(@UseRasaApi = 1,'RASA','RASAAPI')
                ),
				TOTAL_NLUS AS(
					SELECT TOP 1 
						AN.[VCC]                'vcc',
						AN.[CognitiveEngine]    'cognitiveEngine',
						SUM(TotalNlu)               'totalNlu',
						SUM(TotalIntent)            'totalIntent',
						SUM(TotalUtterance)         'totalUtterance',
						SUM(TotalEntity)            'totalEntity',
						AN.[status]					'status'
					FROM ALL_NLUS AN
						---INNER JOIN [dbo].[VCC] V ON V.[VCC] = AN.[VCC]
					--WHERE V.[IsMigrating] = 0 
						GROUP BY AN.[VCC],  AN.[CognitiveEngine],AN.[status] )
				SELECT 
					[vcc]				'vcc',
					[cognitiveEngine]	'cognitiveEngine',
					@RatioRasaMigration	'totalNlu',
					[totalIntent]		'totalIntent',
					[totalUtterance]	'totalUtterance',
					[totalEntity]		'totalEntity'
				
				FROM TOTAL_NLUS
				WHERE totalNlu >= @RatioRasaMigration 
					AND [status] <> 2
				UNION
				SELECT 
					[vcc]				'vcc',
					[cognitiveEngine]	'cognitiveEngine',
					[totalNlu]			'totalNlu',
					[totalIntent]		'totalIntent',
					[totalUtterance]	'totalUtterance',
					[totalEntity]		'totalEntity' 
				FROM TOTAL_NLUS
				WHERE totalNlu < @RatioRasaMigration
					AND [status] <> 2
				

            		
        END
        SELECT 0 'InUse'
      END
     IF (@ListMode = 3)
	   BEGIN
	   --NLUS
	       SELECT 
			   [Name]                name,
			   [Name]                originalName,
			   [Culture]             culture, 
			   [Description]         description,
			   [AppId]               appId,
			   [CognitiveEngine]     cognitiveEngine,
			   0                     'status',
			   0                    'totalRetries'
	       FROM [NLU] (NOLOCK) 
		   WHERE [VCC] = @VCC 
			AND [Name] IN (SELECT [Name] FROM @NLU)
		 -- EN LA MIGRACION SOLO ES NECESARIO MIGRAR NLUS
		 --INTENTS
			SELECT
				[Name]     'name',
				[IntentId] 'intentId',
				[AppId]     'appId',
				CONCAT([AppId],'[::]',[IntentId]) 'key',
				0                     'status',
				0                    'totalRetries'
			FROM [Intent] (NOLOCK) 
			WHERE [VCC] = @VCC 
				AND [IntentId] IN (SELECT ID FROM @Intent)

		-- UTTERANCES  
					  
			 SELECT  DISTINCT
				 U.[Id] 'id',
				 U.[AppId]       'appId',
				 I.[Name]    'intent',
				 U.[IntentId] 'intentId',
				 U.[Text] 'name',
				 (SELECT [EntityName] 'entityName',[Start] 'start',[End] 'end' 
				 FROM [UtteranceEntity] (NOLOCK) WHERE [VCC] = @VCC AND [UtteranceId] IN(U.[Id]) FOR JSON AUTO) 'rawEntityLabels',
				 CONCAT(U.[AppId],'[::]',U.[IntentId],'[::]',U.[Id]) 'key',
				 CONCAT(U.[AppId],'[::]',I.[IntentId]) 'intentKey',
				 0                     'status',
				 0                    'totalRetries'
			 
			 FROM [Utterance] U (NOLOCK) 
				INNER JOIN [Intent] I (NOLOCK)
				ON (U.VCC = I.VCC AND U.IntentId = I.IntentId)
			 WHERE U.[VCC] = @VCC  
				AND U.[IntentId] IN (SELECT ID FROM @Intent)
			 
		--ENTITIES
				 SELECT 
					 [AppId] 'appId',
					 [ID] 'id',
					 [Name] 'name',
					 CONCAT([AppId],'[::]',[ID]) 'key',
					 0                     'status',
					 0                    'totalRetries'
				 FROM [dbo].[Entity] 
				 WHERE [VCC] = @VCC 
					AND [AppId] IN (SELECT ID FROM @Intent)
	   END

	SET NOCOUNT OFF
END
GO

PRINT N'Altering Procedure [dbo].[GetVCCs]...';


GO
ALTER PROCEDURE [dbo].[GetVCCs] (
	@VCC Varchar(50) = NULL, @SearchCriteria Varchar(50) = NULL, @SearchExpression Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[ID]									'id',
		[Description]							'description',
		[Type]									'type',
		[TranscriptionDefaultLanguage]			'transcriptionDefaultLanguage',
		[CognitiveEngine]						'cognitiveEngine',
		[Country]								'country',
		[Language]								'language',
		[TimeZone]								'timeZone',
		[CreatedDate]							'createdDate',
		[CreatedByUserId]						'createdByUserId',
		[LastModifiedDate]						'lastModifiedDate',
		[LastModifiedByUserId]					'lastModifiedByUserId',
        [IsMigrating]                           'isMigrating'
	FROM [VCC] (NOLOCK)
	WHERE [VCC] <> 'system'
		AND [VCC] <> 'default'
		AND ISNULL([ID], '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
		AND ISNULL([Description], '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' ELSE '%' END
		AND ISNULL([Country], '') LIKE CASE WHEN @SearchCriteria = 'country' THEN '%' + @SearchExpression + '%' ELSE '%' END
        AND ISNULL([CognitiveEngine], '') LIKE CASE WHEN @SearchCriteria = 'cognitiveEngine' THEN '%' + @SearchExpression + '%' ELSE '%' END

	SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[SaveCognitiveEngineMigrateStatus]...';


GO


ALTER PROCEDURE [dbo].[SaveCognitiveEngineMigrateStatus]
(
	@VCC	          VARCHAR(50),
	@Model            VARCHAR(50),
	@Key              VARCHAR(100),
	@Status           INT,
	@StatusCode       VARCHAR(50),
	@NlusToMigrate	  VARCHAR(MAX) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	--ACTUALIZAR EL ESTADO DE MIGRACION
	DECLARE @SQL VARCHAR(MAX)
	SET @SQL = ''

    IF(@Model = '*')
    BEGIN 
          UPDATE [dbo].[NLU] SET [StatusCode] = @StatusCode,[Status] = @Status WHERE [VCC] = @VCC AND [IsSystemApp] = 0 AND [Status] <> 4
          UPDATE I SET I.[StatusCode] = @StatusCode, I.[Status] = @Status FROM [dbo].[Intent] I JOIN [dbo].[NLU] N 
          ON (I.[VCC] = N.[VCC] AND I.[AppId] = N.[AppId])  WHERE I.[VCC] = @VCC AND N.[IsSystemApp] = 0 AND I.[Status] <> 4
          UPDATE [dbo].[Entity] SET [StatusCode] = @StatusCode, [Status] = @Status WHERE [VCC] = @VCC AND [Status] <> 4
          
          UPDATE U SET U.[StatusCode] = @StatusCode, U.[Status] = @Status FROM [dbo].[Utterance] U JOIN [dbo].[NLU] N 
          ON (U.[VCC] = N.[VCC] AND U.[AppId] = N.[AppId]) WHERE U.[VCC] = @VCC AND N.[IsSystemApp] = 0 AND U.[Status] <> 4
    END--END MODEL * 
    ELSE 
    BEGIN --NLU
    	 IF(@Model = 'nlu')
			  BEGIN
			  	-- STATUS 4 SIGNIFICA QUE ESTA CANCELADO POR VARIOS INTENTOS ERRONEOS
				 IF(@Key = '*')
				 UPDATE [dbo].[NLU] SET [StatusCode] = @StatusCode,[Status] = @Status WHERE [VCC] = @VCC AND [IsSystemApp] = 0 AND [Status] <> 4
				 ELSE
				 BEGIN 
				  IF(@Key = 'AVAILABLE')
				    --ACTUALIZA A DISPONIBLE TODOS LOS QUE MIGRARON
				    UPDATE [dbo].[NLU] SET [StatusCode] = @StatusCode,[Status] = @Status  WHERE [VCC] = @VCC AND [Status] = 8 AND [IsSystemApp] = 0
				  IF(@Key = 'AVAILABLE_TM')
				    --ACTUALIZA A DISPONIBLE TODOS LOS QUE MIGRARON
				    UPDATE [dbo].[NLU] SET [StatusCode] = @StatusCode,[Status] = @Status  WHERE [VCC] = @VCC
				   IF(@Key = 'TOTAL_MIGRATION')
				   BEGIN
				    --ACTUALIZA A DISPONIBLE TODOS LOS QUE MIGRARON
					SET @SQL= ' UPDATE [dbo].[NLU] SET [StatusCode] = ' + '''' + @StatusCode + '''' + ',[Status] = '
					+ CAST(@Status AS VARCHAR) + '  WHERE [VCC] = ' + '''' +@VCC+ '''' + 'AND CognitiveEngine IN (' + '''' +'RASA' + '''' +',' + ''''+'RASAAPI'+ ''''+ ')'
					+ 'AND [AppId] In (' + '''' + @NlusToMigrate +'''' +')'
					--PRINT @SQL
					EXEC (@SQL)
				   -- UPDATE [dbo].[NLU] SET [StatusCode] = @StatusCode,[Status] = @Status  WHERE [VCC] = @VCC AND CognitiveEngine IN ('RASA','RASAAPI')
				   END
				  ELSE
				    UPDATE [dbo].[NLU] SET [StatusCode] = @StatusCode,[Status] = @Status  WHERE [VCC] = @VCC AND [Name] = @key AND [IsSystemApp] = 0
				 END
				 
			  END
		  ELSE 
		   BEGIN --INTENT
		   
			  IF(@Model = 'intent')
			    BEGIN 
			    
			     IF(@Key = '*')
				  UPDATE I SET I.[StatusCode] = @StatusCode, I.[Status] = @Status FROM [dbo].[Intent] I JOIN [dbo].[NLU] N 
                  ON (I.[VCC] = N.[VCC] AND I.[AppId] = N.[AppId])  WHERE I.[VCC] = @VCC AND N.[IsSystemApp] = 0 AND I.[Status] <> 4
				 ELSE
				 UPDATE [dbo].[Intent] SET [StatusCode] = @StatusCode, [Status] = @Status  WHERE [VCC] = @VCC AND [IntentId] = @key 
				 
			     END
			   ELSE
			     BEGIN --ENTITY
			       
				    IF(@Model = 'entity')
				    BEGIN 
				    
					     IF(@Key = '*')
						 UPDATE [dbo].[Entity] SET [StatusCode] = @StatusCode, [Status] = @Status WHERE [VCC] = @VCC AND [Status] <> 4
						 ELSE
						 UPDATE [dbo].[Entity] SET [StatusCode] = @StatusCode, [Status] = @Status  WHERE [VCC] = @VCC AND [ID] = @key 
						 
			        END--END ENTITY
			        ELSE 
                        BEGIN --UTTERANCE
	                        IF(@Model = 'utterance')
	                        BEGIN
	                         IF(@Key = '*')
							  UPDATE U SET U.[StatusCode] = @StatusCode, U.[Status] = @Status FROM [dbo].[Utterance] U JOIN [dbo].[NLU] N 
							  ON (U.[VCC] = N.[VCC] AND U.[AppId] = N.[AppId]) WHERE U.[VCC] = @VCC AND N.[IsSystemApp] = 0 AND U.[Status] <> 4
							 ELSE
							 UPDATE [dbo].[Utterance] SET [StatusCode] = @StatusCode, [Status] = @Status  WHERE [VCC] = @VCC AND [Id] = @key 
	                       
	                         END 
                      
						 
	
			             END--UTTERANCE
			       
			         
			    END--ENTITY
			    
		  
		  END -- INTENT
    END--NLU

	SELECT 1 AS result

	SET NOCOUNT OFF
END
GO


PRINT N'Altering Procedure [dbo].[SaveVcc]...';


GO
ALTER PROCEDURE [dbo].[SaveVcc] (
	@VCC Varchar(50) = NULL, 
	@ID Varchar(50) = NULL,
	@Description Varchar(50) = NULL,
	@Type VARCHAR(50) = NULL,
	@TranscriptionDefaultLanguage VARCHAR(25) = NULL,
	@CognitiveEngine VARCHAR(25) = NULL,
	@Country Varchar(50) = NULL,
	@Language Varchar(50) = NULL,
	@TimeZone Varchar(50) = NULL,
	@CreatedDate Datetime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId   VARCHAR(50) = NULL,
	@DeleteDataDays         INT = 360,
	@ChangedCognitiveEngine BIT = 0,
	@UseRasaApi				BIT = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	DECLARE @IsMigrating BIT = 0
	IF(@ChangedCognitiveEngine IS NOT NULL AND @ChangedCognitiveEngine = 1)
	   SET @IsMigrating = 1
	   
	IF(EXISTS(SELECT [ID] FROM [dbo].[VCC] (NOLOCK) WHERE [VCC] = @VCC))
	BEGIN
			UPDATE [VCC]
				SET [Description] = @Description,
					[Type] = @Type,
					[Country] = @Country,
					[TranscriptionDefaultLanguage] = @TranscriptionDefaultLanguage,
					[CognitiveEngine] = @CognitiveEngine,
					[Language] = @Language,
					[TimeZone] = @TimeZone,
					[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
					[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
					[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
					[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
					[IsMigrating] = IIF(@IsMigrating = 1,1,0),
					[DeleteDataDays] = @DeleteDataDays,
					[TimeStamp] = GETUTCDATE()
				WHERE [VCC] = @VCC
					AND [ID] = @ID

   END
   ELSE
   BEGIN
   			   EXEC [dbo].[CreateVcc] @VCC,
									  @ID, 
									  @Description, 
									  @Type, 
									  @TranscriptionDefaultLanguage,
									  @CognitiveEngine, 
									  @Country, 
									  @Language, 
									  @TimeZone, 
									  @CreatedDate,  
									  @CreatedByUserId, 
									  @LastModifiedDate, 
									  @LastModifiedByUserId, 
									  @DeleteDataDays,
									  @UseRasaApi
   END

		
		
	--SI HA CAMBIADO LOS NLUS ACTUALIZAR EL ESTADO DE LOS MODELOS A NO DISPONIBLE
	IF(@IsMigrating = 1)
	BEGIN 
	  EXEC SaveCognitiveEngineMigrateStatus @VCC,'*','*',0,'NOT_AVAILABLE'
	END



    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[GetIntents]...';


GO
ALTER PROCEDURE [dbo].[GetIntents] (
	@VCC Varchar(50) = NULL, 
	@AppId VARCHAR(100) = NULL,
	@SearchCriteria Varchar(50) = NULL, 
	@SearchExpression Varchar(50) = NULL,
	@Intents NVARCHAR(MAX)
	)
AS
BEGIN
	IF NOT EXISTS(SELECT 1 FROM dbo.[Intent] WHERE [VCC] = @VCC AND [AppId] = @AppId)
	SET @VCC = 'system'

	DECLARE @COGNITIVE_ENGINE VARCHAR(5) = NULL
	DECLARE @SQL NVARCHAR(MAX)

	-- DETERMINAMOS EL MOTOR COGNITIVO DEL VCC
	SELECT @COGNITIVE_ENGINE = N.[CognitiveEngine]
		FROM [dbo].[NLU] N (NOLOCK)
		WHERE N.[VCC] = @VCC
			AND N.[AppId] = @AppId
	
	SET @SQL = '
	SET NOCOUNT ON
	SELECT  IT.[Name]						    ''name'',
	        IT.[AppId]                          ''appId'',
			IT.[IntentId]						''intentId'',
			IT.[Color]							''color'',
			IT.[CreatedDate]					''createdDate'',
			IT.[CreatedByUserId]				''createdByUserId'',
			IT.[LastModifiedDate]				''lastModifiedDate'',
			IT.[LastModifiedByUserId]			''lastModifiedByUserId'',
			IT.[Status]                         ''status'',
			IT.[StatusCode]                     ''statusCode'',
			COUNT(U.[IntentId])				    ''totalUtterances''
		FROM [dbo].[Intent] IT (NOLOCK) 
		LEFT JOIN [dbo].[Utterance] U (NOLOCK) 
			ON IT.[VCC] = U.[VCC]
				AND IT.[IntentId] = U.[IntentId]
		WHERE IT.[VCC] = ''' + @VCC + '''
			AND IT.[AppId] = ''' + @AppId + ''' '

	-- PARA NLUS DE LUIS, FILTRAMOS SEGUN EL INPUT
	IF @COGNITIVE_ENGINE = 'LUIS'
	BEGIN
		SET @SQL +=	'
			AND IT.[IntentId] IN (''' + @Intents + ''') '
	END

	IF @SearchCriteria IS NOT NULL AND @SearchExpression IS NOT NULL
	BEGIN
		SET @SQL +=	'
			AND ISNULL(IT.[Name], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''name'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END '
	END

	SET @SQL +=	'
		GROUP BY IT.[IntentId]
				,IT.[Name]
				,IT.[AppId]
				,IT.[Color]
				,IT.[CreatedDate]
				,IT.[CreatedByUserId]
				,IT.[LastModifiedDate]
				,IT.[LastModifiedByUserId]
				,IT.[Status]  
				,IT.[StatusCode] 
		ORDER BY IT.[LastModifiedDate] ASC, IT.[Name] DESC '

	SET @SQL += ' 
	SET NOCOUNT OFF'
	--print @SQL
	EXEC(@SQL)
END
GO
PRINT N'Altering Procedure [dbo].[GetNLU]...';


GO
--exec [GetNLU] NULL,'test2'
ALTER PROCEDURE [dbo].[GetNLU] (
	@VCC Varchar(50) = NULL, @Name Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	IF EXISTS (SELECT 1 FROM [NLU]
	WHERE [VCC] = CASE WHEN ISNULL(@VCC, '') = '' THEN [VCC] ELSE @VCC END 
	AND [Name] = @Name )
	
	BEGIN 
		SELECT
			[VCC]							'vcc',
			[Name]						    'name',
			[CognitiveEngine]				'cognitiveEngine',
			[Culture]						'culture',
			[Description]					'description',
			[AppId]							'appId',
			[SubscriptionKey]				'subscriptionKey',
			[IsSystemApp]					'isSystemApp',
			[NeedTrain]						'needTrain',
			[LastTrainedDate]				'lastTrainedDateTime',
			[LastPublishedDate]				'lastPublishedDateTime',
			[CreatedDate]					'createdDate',
			[CreatedByUserId]				'createdByUserId',
			[LastModifiedDate]				'lastModifiedDate',
			[LastModifiedByUserId]			'lastModifiedByUserId'
		FROM [NLU] (NOLOCK)
		WHERE [VCC] = CASE WHEN ISNULL(@VCC, '') = '' THEN [VCC] ELSE @VCC END 
		AND [Name] = @Name
	END
	ELSE
	BEGIN
		SELECT
				[VCC]							'vcc',
				[Name]						    'name',
				[CognitiveEngine]				'cognitiveEngine',
				[Culture]						'culture',
				[Description]					'description',
				[AppId]							'appId',
				[SubscriptionKey]				'subscriptionKey',
				[IsSystemApp]					'isSystemApp',
				[NeedTrain]						'needTrain',
				[LastTrainedDate]				'lastTrainedDateTime',
				[LastPublishedDate]				'lastPublishedDateTime',
				[CreatedDate]					'createdDate',
				[CreatedByUserId]				'createdByUserId',
				[LastModifiedDate]				'lastModifiedDate',
				[LastModifiedByUserId]			'lastModifiedByUserId'
			FROM [NLU] (NOLOCK)
			WHERE [VCC] = 'system'
			AND [Name] = @Name
			AND [Name] LIKE 'sentiment-%'
		
	END
	
	SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[GetNLUs]...';


GO
ALTER PROCEDURE [dbo].[GetNLUs] (
    @VCC Varchar(50) = NULL,
    @SearchCriteria Varchar(50) = NULL,
    @SearchExpression Varchar(50) = NULL,
    @Apps NVARCHAR(MAX),
    @IsSystemApp BIT = NULL,
    @ShowInMigrationProcess BIT = 0,
	@UseRasaApi BIT = NULL
)
AS
BEGIN
    -- EN CASO EL FLAG LLEGUE NULL LO SETTEAMOS COMO 0

    DECLARE  @SQL              NVARCHAR(MAX)
	DECLARE  @SQL_VCC            NVARCHAR(MAX)
    DECLARE  @FILTER           VARCHAR(MAX) = ''
    DECLARE  @UNION_SQL        VARCHAR(MAX) = ''
    DECLARE  @APPS_FILTER      VARCHAR(MAX) = ''
    DECLARE  @STATUS_FILTER    VARCHAR(MAX) = ''
    DECLARE  @ORDER_BY         VARCHAR(MAX) = ''
	DECLARE  @FILTER_COGNITIVEENGINE VARCHAR(MAX) = ''
    SET NOCOUNT ON
    --Status va ha cambiar a 9 o 10 de acuerdo a LastPublishedDate
    --0 PENDIENTE DE MIGRACION
    --1 ESTA DISPONIBLE EN EL MOTOR
    --2 MIGRANDO
    --3 CON ERROR ( EL ERROR LO INDICA STATUSCODE)
    --4 CANCELADO POR DEMASIADOS INTENTOS ERRONEOS
    --8 MIGRADO EL NLU PERO FALTA LOS INTENT, UTTERANCES,ETC
    --9 ESTA DISPONILBE EL MODELO EN EL MOTOR PERO NO ESTA ENTRENADO(RASA) O LUIS(PUBLICADO)
    --10 ESTA DISPONIBLE EN EL MOTOR Y ENTRENADO
    --11 EN PROCESO DE ENTRENAMIENTO (PROCESO INTERNO DE LUIS)
    --12 EN PROCESO DE PUBLICACION (PROCESO INTERNO DE LUIS)
    --13 ENTRENAMIENTO FALLIDO (LUIS RETORNO ESTADO DE ERROR LUEGO DE VARIAS CONSULTAS)
	--14 FINALIZO LA MIGRACION DE RASA CORRECTAMENTE
    --Se establece estos valores porque actualmente Status puede tener valores de 0 a 4, sin embargo puede ampliarse en futuros requerimientos.
    SET @SQL = '
    SELECT [VCC]                  ''vcc'',
       [Name]                 ''name'',
       [CognitiveEngine]      ''cognitiveEngine'',
       [Culture]              ''culture'',
       [Description]          ''description'',
       [AppId]                ''appId'',
       [SubscriptionKey]      ''subscriptionKey'',
       [IsSystemApp]          ''isSystemApp'',
       [NeedTrain]            ''needTrain'',
       [IsTrained]            ''isTrained'',
       [LastTrainedDate]      ''lastTrainedDateTime'',
       [IsPublished]          ''isPublished'',
       [LastPublishedDate]    ''lastPublishedDateTime'',
       [CreatedDate]          ''createdDate'',
       [CreatedByUserId]      ''createdByUserId'',
       [LastModifiedDate]     ''lastModifiedDate'',
       [LastModifiedByUserId] ''lastModifiedByUserId'',
       [TrainVersion]         ''trainVersion'',
       [NeedPublish]          ''needPublish'',
       [TrainId]              ''trainId'',
       CASE
           WHEN [Status] = 0 THEN
               ''PENDING''
           WHEN [Status] = 1 THEN
               CASE
                   WHEN [NeedTrain] = 1 OR [LastTrainedDate] IS NULL THEN
                       ''NEED_TRAIN''
                   WHEN [NeedTrain] = 0 AND ([NeedPublish] = 1 OR [LastPublishedDate] IS NULL) THEN
                       IIF([CognitiveEngine] = ''LUIS'' OR [CognitiveEngine] =''RASAAPI'', ''NEED_PUBLISH'', ''NEED_TRAIN'')
                   ELSE
                       ''AVAILABLE''
                END
           WHEN [Status] = 2 THEN
                ''MIGRATING''
           WHEN [Status] = 3 THEN
               ''FAILED''
           WHEN [Status] = 4 THEN
               ''CANCELLED''
           WHEN [Status] = 8 THEN
               ''INCOMPLETE''
           WHEN [Status] = 9 THEN
                IIF([CognitiveEngine] = ''LUIS'', ''NEED_PUBLISH'', ''NEED_TRAIN'')
           WHEN [Status] = 10 THEN
                ''AVAILABLE''
           WHEN [Status] = 11 THEN
               ''TRAINING''
           WHEN [Status] = 12 THEN
               ''PUBLISHING''
           WHEN [Status] = 13 THEN
               ''TRAINING_FAILED''
           ELSE
                ''UNKNOWN''
        END ''statusCode''
    FROM [NLU] (NOLOCK)
    WHERE '

	-- EN CASO SE ESTE USANDO RASA API 
	IF(@UseRasaApi = 1)
	BEGIN
		SET @FILTER_COGNITIVEENGINE += ' AND [CognitiveEngine] = ''RASAAPI'' '
	END
	IF (@UseRasaApi = 0)
	BEGIN
		SET @FILTER_COGNITIVEENGINE += ' AND [CognitiveEngine] = ''RASA'' '
	END


    -- EN CASO BUSQUEMOS MODELOS DE TODOS LOS VCC
    IF (@VCC = 'ALL')
        SET @SQL_VCC = '
            [VCC] IS NOT NULL '
    ELSE
	BEGIN

		SET @SQL_VCC = '
		[VCC] = ''' + @VCC + ''' '
	END


    -- EN CASO BUSQUEMOS MODELOS DEL SISTEMA NO FILTRAMOS POR NOMBRES
    IF @IsSystemApp = 0 AND @Apps IS NOT NULL AND @Apps <> '' 
       SET @APPS_FILTER  += ' AND [AppId] IN (''' + @Apps + ''') '

	

   
    IF (@IsSystemApp IS NULL)
     SET @FILTER += ''
    ELSE
     SET @FILTER += ' AND [IsSystemApp] = ' + CASE WHEN @IsSystemApp = 1 THEN '1' ELSE '0' END + ' '


    IF(@SearchCriteria IS NOT NULL AND @SearchCriteria <> '' AND @SearchExpression IS NOT NULL AND @SearchExpression <> '')
        BEGIN
            SET @FILTER += '
        AND ISNULL([Name], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''name'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
        AND ISNULL([Description], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''description'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
        AND ISNULL([LastModifiedByUserId], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''LastModifiedByUserId'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END'
        END


    SET @ORDER_BY = ' ORDER BY [LastModifiedDate] ASC, [Name] DESC'
	SET @STATUS_FILTER = ' AND [Status] = 1 '

    IF(@ShowInMigrationProcess IS NOT NULL AND @ShowInMigrationProcess = 1)
        BEGIN
            SET @UNION_SQL = ' UNION ' + @SQL + @SQL_VCC + @FILTER + @FILTER_COGNITIVEENGINE + ' AND [Status] <> 1 '
        END
	IF(@SearchCriteria = 'Description' AND @SearchExpression = 'SENTIMENT_LANGUAGE_')
		BEGIN
			DECLARE @SQL_VCC_SYSTEM VARCHAR(MAX)
			SET @SQL_VCC_SYSTEM = '
			[VCC] = ''' + 'system' + ''' '
            SET @UNION_SQL = ' UNION ' + @SQL + @SQL_VCC_SYSTEM + @FILTER + @FILTER_COGNITIVEENGINE + ' AND [Name] NOT IN (SELECT [Name] FROM NLU WHERE VCC =' +''''+@VCC+''''+ 'AND [Name] LIKE' + ''''+'sentiment-'+'%'+''''+')'
        END
	

	SET @SQL +=  @SQL_VCC
    SET @SQL  +=   @FILTER + @APPS_FILTER + @STATUS_FILTER + @FILTER_COGNITIVEENGINE + @UNION_SQL +  @ORDER_BY
    SET NOCOUNT OFF
	--select @SQL
    EXEC(@SQL)
END
GO
PRINT N'Altering Procedure [dbo].[SaveNLU]...';


GO
ALTER PROCEDURE [dbo].[SaveNLU] (
    @VCC Varchar(50) = NULL,
    @Name Varchar(50) = NULL,
    @Culture Varchar(50) = NULL,
    @Description Varchar(50) = NULL,
    @AppId Varchar(100) = NULL,
    @SubscriptionKey Varchar(50) = NULL,
    @IsSystemApp BIT = 0,
    @IsPublished BIT = NULL,
    @LastPublishedDate DATETIME = NULL,
    @IsTrained BIT = NULL,
    @NeedTrain BIT = NULL,
    @NeedPublish BIT = NULL,
    @LastTrainedDate DATETIME = NULL,
    @CreatedDate Datetime = NULL,
    @CreatedByUserId Varchar(50) = NULL,
    @LastModifiedDate Datetime = NULL,
    @LastModifiedByUserId Varchar(50) = NULL,
    @TrainVersion Varchar(250) = NULL,
    @TrainId Varchar(250) = NULL,
    @UseRasaApi Bit = NULL
)
AS
BEGIN
    SET NOCOUNT ON
	DECLARE @NeedReplicateNlu BIT = 0
	DECLARE @SystemAppId VARCHAR(50)
   

	-- VERIFICAMOS SI ES PARA UN NLU DE SENTIMIENTO PERSONALIZADO
	IF NOT EXISTS( SELECT 1 FROM [NLU] WHERE [Name] LIKE 'sentiment-%' AND AppId = @AppId AND VCC =@VCC)
	BEGIN
	SET @NeedReplicateNlu = 1
	SELECT @SystemAppId = AppId FROM [NLU] WHERE [VCC] = 'system' AND [Name] = @Name
	END
		
    -- SI LA VARIABLE LLEGA NULL, LA SETTEAMOS COMO 0
    IF @IsSystemApp IS NULL
        SET @IsSystemApp = 0

    UPDATE [NLU]
    SET [Culture] = @Culture,
        [Description] = @Description,
        [AppId] = @AppId,
        [IsPublished] = CASE WHEN @IsPublished IS NULL THEN [IsPublished] ELSE @IsPublished END,
        [LastPublishedDate] = CASE WHEN @LastPublishedDate IS NULL THEN [LastPublishedDate] ELSE @LastPublishedDate END,
        [IsSystemApp] = CASE WHEN @IsSystemApp IS NULL THEN [IsSystemApp] ELSE @IsSystemApp END,
        [SubscriptionKey] = CASE WHEN @SubscriptionKey IS NULL THEN [SubscriptionKey] ELSE @SubscriptionKey END,
        [IsTrained] = CASE WHEN @IsTrained IS NULL THEN [IsTrained] ELSE @IsTrained END,
        [NeedTrain] = CASE WHEN @NeedTrain IS NULL THEN [NeedTrain] ELSE @NeedTrain END,
        [NeedPublish] = CASE WHEN @NeedPublish IS NULL THEN [NeedPublish] ELSE @NeedPublish END,
        [LastTrainedDate] = CASE WHEN @LastTrainedDate IS NULL THEN [LastTrainedDate] ELSE @LastTrainedDate END,
        -- [CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
        [LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
        [LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
        [TimeStamp] = GETUTCDATE(),
        [TrainVersion] = @TrainVersion,
        [TrainId] = @TrainId
    WHERE [VCC] = @VCC
      AND [Name] = @Name

    IF @@ROWCOUNT = 0
        BEGIN
			
            INSERT INTO [NLU] (
                [VCC], [Name], [Culture],
                [Description], [AppId], [SubscriptionKey],
                [IsSystemApp], [CreatedDate], [CreatedByUserId],
                [LastModifiedDate], [LastModifiedByUserId], [TimeStamp],[CognitiveEngine]
            )
            VALUES (
                       @VCC, @Name, @Culture,
                       @Description, @AppId, @SubscriptionKey,
                       @IsSystemApp, GETUTCDATE(), @CreatedByUserId,
                       @LastModifiedDate, @LastModifiedByUserId, GETUTCDATE(),
                       IIF(@IsSystemApp = 1, IIF(@UseRasaApi =1,'RASAAPI','RASA'), 
                       IIF(@UseRasaApi=1,'RASAAPI',(SELECT [CognitiveEngine] FROM [dbo].[VCC] WHERE [VCC] = @VCC)))
                   )

			IF(@NeedReplicateNlu = 1)
			BEGIN
				--GENERAMOS INTENCIONES DEL NUEVO NLU
                UPDATE NLU 
                SET NeedTrain = 1 
                WHERE AppId = @AppId
                
				INSERT INTO [Intent]([VCC],[Name],[IntentId],[AppId],[Color],[CreatedDate],[CreatedByUserId],
							[LastModifiedDate],[LastModifiedByUserId],[TimeStamp],[Status],[StatusCode])
				SELECT @VCC,[Name],[IntentId],@AppId,[Color],GETUTCDATE(),'system',GETUTCDATE(),'system',GETUTCDATE(),[Status],[StatusCode] 
					FROM Intent 
					WHERE [AppId] = @SystemAppId
				
				INSERT INTO [Utterance]([VCC],[AppId],[IntentId],[Id],[Text],[CreatedDate],[CreatedByUserId],
							[LastModifiedDate],[LastModifiedByUserId],[Status],[StatusCode])
				SELECT @VCC,@AppId,[IntentId],NEWID(),[Text],GETUTCDATE(),'system',GETUTCDATE(),'system',[Status],[StatusCode] 
					FROM Utterance 
					WHERE [AppId] = @SystemAppId
			END
        END

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Update complete.';


GO
