-- ARCHIVO CON LAS ACTUALIZACIONES DE DATA DE SQL PARA MIGRAR AL NUEVO BUILD DEL NOMBRE DE LA CARPETA
-- DECLARAMOS DOS VARIABLES, UNA CON LA VERSION DE LA QUE PARTIMOS Y OTRA CON LA NUEVA VERSION QUE ESTAMOS APUNTANDO
DECLARE @OLD_DATABASE_BUILD_VERSION VARCHAR(50) = '6.2.2'
DECLARE @NEW_DATABASE_BUILD_VERSION VARCHAR(50) = '6.3.0'

-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
BEGIN TRY
    -- VALIDAMOS QUE LA VERSION EXISTENTE COINCIDE CON NUESTRA NEW_DATABASE_BUILD_VERSION
    IF NOT EXISTS (
        SELECT 1 
            FROM [dbo].[Version] V 
            WHERE V.[BuildVersion] = @OLD_DATABASE_BUILD_VERSION
    )	
        -- LANZAMOS UN MENSAJE DE ERROR INDICANDO QUE LA VERSION ACTUAL NO COINCIDE CON LA OLD_DATABASE_BUILD_VERSION
        RAISERROR('DATABASE_ERROR_INCORRECT_TARGET_VERSION', 16, 16)
        
    -- INICIAMOS LA TRANSACCION
    BEGIN TRANSACTION




    -- AQUI EMPIEZA LA SECCION CON LOS INSERT/UPDATE/DELETE PARA LA NUEVA VERSION



        -- PERMISO PARA EL ENDPOINT DE TASK
        INSERT [dbo].[User] ([VCC], [ID], [Email], [Firstname], [Lastname], [Password], [Role], [Country], [Language], [TimeZone], [Preferences], [IsSystemUser], [LimitClients], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]) VALUES (N'system', N'ext_user', N'ext_user@inconcertcc.com', N'external', N'user', N'289128e9a91391c0198705308a88ea5c', N'external_user', N'PE', N'es', N'America/Mexico_City', N'{}', 1, 1, GETUTCDATE(), N'admin', GETUTCDATE(), N'admin', GETUTCDATE())
        INSERT [dbo].[Role] ([VCC], [ID], [Description], [Type], [SystemRole], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]) VALUES (N'system', N'external_user', N'external_user','SHARED','True', GETUTCDATE(), N'analytic', GETUTCDATE(), N'analytic', GETUTCDATE())
        INSERT [dbo].[RolePermission] ([VCC], [RoleId], [GroupId], [TimeStamp]) VALUES (N'system', N'external_user', N'PERM_GROUP_SPEECHMATICS', GETUTCDATE())
        INSERT [dbo].[RolePermissionsGroup] ([VCC],[GroupId],[Category], [TimeStamp],[Type]) VALUES (N'system', N'PERM_GROUP_SPEECHMATICS', N'CATEG_GROUP_SPEECHMATICS', GETUTCDATE(), 'SHARED')
        INSERT [dbo].[RoutePermission] ([VCC], [ID], [GroupId], [Route], [Level], [TimeStamp]) VALUES (N'system', NEWID(), N'PERM_GROUP_SPEECHMATICS', N'api/public/task/update_transcription_queue/', N'api', GETUTCDATE())

        

        
    -- AQUI TERMINA LA SECCION CON LOS INSERT/UPDATE/DELETE PARA LA NUEVA VERSION
    -- ACTUALIZAR LA DATA DE SENTIMIENTOS SI EXISTIERAN REGISTROS 
    

    

    -- TERMINAMOS LA ACTUALIZACION DE DATA ACTUALIZANDO EL BUILDVERSION
    UPDATE [dbo].[Version] 
        SET [BuildVersion] = @NEW_DATABASE_BUILD_VERSION, 
            [IsRegistered] = 0,
            [TimeStamp] = GETUTCDATE() 
        WHERE [BuildVersion] = @OLD_DATABASE_BUILD_VERSION
    PRINT 'UPDATED_DATABASE_BUILD_VERSION'

    -- COMPLETAMOS LA TRANSACCION
    COMMIT TRANSACTION
END TRY
BEGIN CATCH
    IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

    DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
    DECLARE @Severity integer = ERROR_SEVERITY()
    DECLARE @State integer = ERROR_STATE()

    RAISERROR(@Message, @Severity, @State)
    --RETURN -1
END CATCH
