GO
PRINT N'Altering Procedure [dbo].[GetI6AlreadyRegisteredCallInteractions]...';

GO
ALTER PROCEDURE [dbo].[GetI6AlreadyRegisteredCallInteractions] (@VCC VARCHAR(50) = NULL)
AS
BEGIN
	-- CRUZAMOS LA TABLA TEMPORAL CON LAS INTERACCIONES DE LA API CON LA TABLA AUDIO
	SELECT DISTINCT A.[VCC]														'vcc',
					CONCAT(A.[ID], '_', A.[Section], '_', A.[Part])				'ID',
					A.[ID]														'InteractionId',
					A.[Section]													'Secction',
					A.[Part]													'Part',
					'CALL'														'Channel',
					A.[Number]													'Number',
					A.[ContactAddress]											'ContactAdress',
					A.[Gender]													'Gender',
					A.[SilenceTime]												'SilenceTime',
					A.[DurationTime]											'DurationTime',
					A.[DurationTime]											'AttentionTime',
					1															'TotalParts',
					A.[Category1]												'Category1',
					A.[Category2]												'Category2',
					A.[Category3]												'Category3',
					A.[Description]												'Description',
					A.[DispositionCode]											'DispositionCode',
					A.[Campaign]												'Campaign',
					A.[Agent]													'Agent',
					A.[AgentName]												'agentName',
					A.[Type]													'Type',
					A.[StartDate]												'StartDate',
					A.[EndDate]													'EndDate',
					A.[Format]													'Format',
					ISNULL(A.[NeedI6Update], CAST(1 AS BIT))					'needI6Update',
					A.[Ender]													'ender',
					A.[ticket]													'ticket'
		FROM [#InteractionsTemp] IT
		INNER JOIN [dbo].[Audio] A (NOLOCK)
			ON A.[VCC] = IT.[VCC]
				AND  A.[ID] = IT.[InteractionId]
		WHERE IT.[VCC] = @VCC
		DROP TABLE #InteractionsTemp
END


GO
PRINT N'Altering Procedure [dbo].[GetI6AlreadyRegisteredTextInteractions]...';

GO
ALTER PROCEDURE [dbo].[GetI6AlreadyRegisteredTextInteractions] (@VCC VARCHAR(50) = NULL)
AS
BEGIN
	-- CRUZAMOS LA TABLA TEMPORAL CON LAS INTERACCIONES DE LA API CON LA TABLA ASYNCINTERACTION
	SELECT DISTINCT AI.[VCC]													'vcc',
					AI.[ID]														'id',
					AI.[ID]														'InteractionId',
					AI.[Folder]													'folder',
					AI.[ExportedContent]										'exportedContent',
					AI.[Channel]												'channel',
					AI.[Campaign]												'campaign',
					AI.[StartDate]												'startDate',
					AI.[EndDate]												'endDate',
					AI.[Account]												'account',
					AI.[Initiative]												'initiative',
					AI.[ContactName]											'contactName',
					AI.[ContactAddress]											'contactAdress',
					AI.[ContactId]												'contactId',
					AI.[FirstTakedAgent]										'firstTakedAgent',
					AI.[LastTakedAgent]											'lastTakedAgent',
					AI.[TotalMessages]											'totalMessages',
					AI.[DurationTime]											'durationTime',
					AI.[AttentionTime]											'attentionTime',
					AI.[DispositionCode]										'dispositionCode',
					AI.[DispositionTreePath]									'dispositionTreePath',
					AI.[RawChar]												'rawChar',
					ISNULL(AI.[NeedI6Update], CAST(1 AS BIT))					'needI6Update',
					AI.[Ender]													'ender',
					AI.[ticket]													'ticket'
		FROM [#InteractionsTemp] IT
		INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
			ON AI.[VCC] = IT.[VCC]
				AND  AI.[ID] = IT.[InteractionId]
				AND AI.[Folder] = IT.[Folder]
		WHERE IT.[VCC] = @VCC
		DROP TABLE #InteractionsTemp
END
GO
