GO
PRINT N'Creando [dbo].[GetHistoricAgents]...';


GO
CREATE PROCEDURE [dbo].[GetHistoricAgents] 
(
	@VCC					VARCHAR(50) = NULL
) 
AS
BEGIN
	WITH ResultAgent AS (
		SELECT 
			[AU].[Agent] AS 'id',
			[AU].[Agent] AS 'description'
		FROM [dbo].[Audio] AU (NOLOCK)
		WHERE [AU].[VCC] = @VCC
		UNION 
		SELECT 
			[IEP].[IdAgent] AS 'id',
			[IEP].[IdAgent] AS 'description'
		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		WHERE [IEP].[Instance] = @VCC
	)

	SELECT 
		R.id AS 'id', 
		R.description AS 'description' ,
		(
			SELECT STUFF((
				SELECT ',' + [idcampaign] + ''
				FROM (
					SELECT DISTINCT [AU2].[Campaign] AS 'idcampaign'
					FROM [dbo].[Audio] AU2 (NOLOCK)
					WHERE [AU2].[VCC] = @VCC AND [AU2].[Agent] = R.id

					UNION

					SELECT DISTINCT [IE2].[IdCampaign] AS 'idcampaign'
					FROM [dbo].[InteractionEvaluationPlan] IE2 (NOLOCK)
					WHERE [IE2].[Instance] = @VCC AND [IE2].[IdAgent] = R.id
				) campaigns
				FOR XML PATH(''), TYPE
			).value('.', 'NVARCHAR(MAX)'), 1, 1, '') 
		) AS 'campaigns'
	FROM ResultAgent R

	
END
GO
PRINT N'Creando [dbo].[GetHistoricCampaigns]...';


GO
CREATE PROCEDURE [dbo].[GetHistoricCampaigns]
(@VCC VARCHAR(50),
@EXCLUDESWORKGROUPSUP CHAR(1)
)
AS
BEGIN	
	
	
WITH ResultAgent AS (
		SELECT 
			[AU].[Campaign]  'id',
			[AU].[Campaign]  'campaign'
		FROM [dbo].[Audio] AU (NOLOCK)
		WHERE [AU].[VCC] = 'vccamcompleto'
		AND (@EXCLUDESWORKGROUPSUP = 0
				OR
			(@EXCLUDESWORKGROUPSUP = 1 AND [AU].[Campaign] NOT IN (SELECT CampaignId FROM dbo.WorkGroupSupervisor WKS (NOLOCK) WHERE WKS.VCC = 'vccamcompleto'))
			)
		UNION 
		SELECT 
			[IEP].[IdCampaign] AS 'id',
			[IEP].[IdCampaign] AS 'campaign'
		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		WHERE [IEP].[Instance] = 'vccamcompleto'
		AND (@EXCLUDESWORKGROUPSUP = 0
				OR
			(@EXCLUDESWORKGROUPSUP = 1 AND [IEP].[IdCampaign] NOT IN  (SELECT CampaignId FROM dbo.WorkGroupSupervisor WKS (NOLOCK) WHERE WKS.VCC = 'vccamcompleto'))
			)
	)

	SELECT 
		R.id  'id', 
		R.campaign  'campaign' ,
		(
			SELECT STUFF((
				SELECT ',' + [idagent] + ''
				FROM (
					SELECT DISTINCT [AU2].[Agent]  'idagent'
					FROM [dbo].[Audio] AU2 (NOLOCK)
					WHERE [AU2].[VCC] = 'vccamcompleto' AND [AU2].[Campaign] = R.id

					UNION

					SELECT DISTINCT [IE2].[IdAgent]  'idagent'
					FROM [dbo].[InteractionEvaluationPlan] IE2 (NOLOCK)
					WHERE [IE2].[Instance] = 'vccamcompleto' AND [IE2].[IdCampaign] = R.id
				) agents
				FOR XML PATH(''), TYPE
			).value('.', 'NVARCHAR(MAX)'), 1, 1, '') 
		) AS 'agents'
	FROM ResultAgent R




END
GO
PRINT N'Actualización completada.';


GO
