PRINT N'Altering Table [dbo].[Audio]...';


GO
ALTER TABLE [dbo].[Audio]
    ADD [RelativeFileName] VARCHAR (1000) NULL;


GO
PRINT N'Altering Table [dbo].[InteractionEvaluationPlan]...';


GO
ALTER TABLE [dbo].[InteractionEvaluationPlan]
    ADD [RelativeFileName] VARCHAR (1000) NULL;


GO
PRINT N'Altering Procedure [dbo].[BulkAudio]...';


GO
ALTER PROCEDURE [dbo].[BulkAudio]
AS
BEGIN
	-- DECLARAMOS UNA VARIABLE PARA DEFINIR EL VCC
	DECLARE @VCC VARCHAR(50) = NULL
	DECLARE @VCC_TYPE VARCHAR(50) = NULL

	-- ASIGNAMOS A LA VARIABLE EL NOMBRE DEL VCC
	SELECT TOP 1 @VCC = [VCC] FROM #AudioTemp (NOLOCK)
	-- BUSCAMOS EL TIPO DE VCC
	SELECT @VCC_TYPE = V.[Type] FROM [dbo].[VCC] V (NOLOCK) WHERE V.[VCC] = @VCC
-- ACTUALIZAR RELATIVE PATH
	UPDATE A
	SET A.[RelativeFileName] = ATE.[RelativeFileName]
	FROM dbo.[AUDIO] A
		INNER JOIN #AudioTemp ATE ON
			A.[VCC] = ATE.[VCC] 
			AND A.[ID] = ATE.[ID]
			AND A.[Section] = ATE.[Section] 
			AND A.[Part] = ATE.[Part]
		-- EMULAMOS UNA NUEVA TABLA EN BASE A #AudioTemp DONDE SE REMOVERAN TODOS LOS REGISTROS DUPLICADOS PARA EL PK DE LA TABLA Audio
	;WITH CTE AS (
		SELECT A.[VCC], A.[ID], A.[Section], A.[Part], A.[Number],
				A.[Gender], A.[SilenceTime], A.[DurationTime], A.[Category1], A.[Category2],
				A.[Category3], A.[Description], A.[Campaign], A.[Agent], ISNULL(A.[AgentName], AG.[Name]) 'AgentName',
				A.[Type], A.[Init], A.[StartDate], A.[EndDate], A.[DispositionCode], 
				A.[RelativePath], A.[FileName], A.[CreatedDate], A.[CreatedByUserId], A.[LastModifiedDate], 
				A.[LastModifiedByUserId], A.[ContactId], A.[ContactName], A.[ContactAddress],A.[NeedI6Update],A.[RelativeFileName], 
				RN = ROW_NUMBER() OVER(PARTITION BY A.[VCC], A.[ID], A.[Section], A.[Part] ORDER BY A.[ID])
			FROM #AudioTemp A (NOLOCK)
			LEFT JOIN [dbo].[Agent] AG (NOLOCK)
				ON AG.[VCC] = A.[VCC]
					AND AG.[AgentId] = A.[Agent]
	)
	-- LA TABLA TEMPORAL #AudioTemp LLEGA CON ALGUNOS REGISTROS DUPLICADOS DEBIDO A LOS CRUCES AL APLICAR LOR FILTROS, POR ELLO DEBEMOS 
	-- IDENTIFICAR LOS REPETIDOS, RN = ROW_NUMBER() OVER(PARTITION BY ...) <- NUMERA CADA REGISTRO SEGUN EL(LOS) VALOR(ES) DE ...

	-- EL CTE SOLO PUEDE SER INVOCADO UNA VEZ POR ESO LO PONEMOS EN EL SELECT FINAL DONDE EL CONTADOR(RN) ES 1
	--DELETE FROM CTE WHERE RN > 1
	

	INSERT INTO dbo.Audio(
			[VCC]
			,[ID]
			,[Section]
			,[Part]
			,[Number]
			,[Gender]
			,[SilenceTime]
			,[DurationTime]
			,[Category1]
			,[Category2]
			,[Category3]
			,[Description]
			,[Campaign]
			,[Agent]
			,[AgentName]
			,[Type]
			,[Init]
			,[NeedI6Update]
			,[StartDate]
			,[EndDate]
			,[DispositionCode]
			,[RelativePath]
			,[FileName]
			,[CreatedDate]
			,[CreatedByUserId]
			,[LastModifiedDate]
			,[LastModifiedByUserId]
			,[TimeStamp]
			,[ContactId]			
			,[ContactName]
			,[ContactAddress]
			,[RelativeFileName]
			) 
		SELECT
			 A.[VCC]
			,A.[ID]
			,A.[Section]
			,A.[Part]
			,A.[Number]
			,A.[Gender]
			,A.[SilenceTime]
			,A.[DurationTime]
			,A.[Category1]
			,A.[Category2]
			,A.[Category3]
			,A.[Description]
			,A.[Campaign]
			,A.[Agent]
			,A.[AgentName]
			,A.[Type]
			,A.[Init]
			,A.[NeedI6Update]
			,A.[StartDate]
			,A.[EndDate]
			,A.[DispositionCode]
			,A.[RelativePath]
			,A.[FileName]
			,A.[CreatedDate]
			,A.[CreatedByUserId]
			,A.[LastModifiedDate]
			,A.[LastModifiedByUserId]
			,GETUTCDATE()
			,A.[ContactId]		
			,A.[ContactName]
			,A.[ContactAddress]
			,A.[RelativeFileName]
		FROM CTE A (NOLOCK)
		WHERE A.RN = 1
			AND NOT EXISTS (
				SELECT * 
					FROM Audio B (NOLOCK)
					WHERE B.[VCC] = A.[VCC]
						AND B.[ID] = A.[ID]
						AND B.[Section] = A.[Section]
						AND B.[Part] = A.[Part]
			)
	




	-- EMULAMOS UNA NUEVA TABLA EN BASE A #AudioTemp DONDE SE REMOVERAN TODOS LOS REGISTROS DUPLICADOS PARA EL PK DE LA TABLA Audio
	;WITH CTE_PAT AS (
	   SELECT PAT.[VCC], PAT.[ProcessId], PAT.[AudioId], PAT.[Section], PAT.[Part]
			,PAT.[CreatedDate], PAT.[CreatedByUserId], PAT.[LastModifiedDate], PAT.[LastModifiedByUserId], RN = ROW_NUMBER() OVER(PARTITION BY PAT.[VCC], PAT.[ProcessId], PAT.[AudioId], PAT.[Section], PAT.[Part] ORDER BY PAT.[AudioId])
	   FROM #ProcessAudioTemp PAT (NOLOCK)
	)
	-- EL CTE_PAT SOLO PUEDE SER INVOCADO UNA VEZ POR ESO LO PONEMOS EN EL SELECT FINAL DONDE EL CONTADOR(RN) ES 1
	--DELETE FROM CTE_PAT WHERE RN > 1
		
	-- Insertamos registros en la tabla ProcessAudio
	INSERT INTO dbo.ProcessAudio
			([VCC]
			,[ProcessId]
			,[AudioId]
			,[Section]
			,[Part]
			,[CreatedDate]
			,[CreatedByUserId]
			,[LastModifiedDate]
			,[LastModifiedByUserId]
			,[TimeStamp]
			) 
		SELECT PAT.[VCC]
			,PAT.[ProcessId]
			,PAT.[AudioId]
			,PAT.[Section]
			,PAT.[Part]
			,PAT.[CreatedDate]
			,PAT.[CreatedByUserId]
			,PAT.[CreatedDate]
			,PAT.[CreatedByUserId]
			,GETUTCDATE()
		FROM CTE_PAT PAT (NOLOCK)
		WHERE PAT.RN = 1
			AND NOT EXISTS (
			SELECT * FROM ProcessAudio PA (NOLOCK)
			WHERE PA.[VCC] = PAT.[VCC]
			AND PA.[ProcessId] = PAT.[ProcessId]
			AND PA.[AudioId] = PAT.[AudioId]
			AND PA.[Section] = PAT.[Section]
			AND PA.[Part] = PAT.[Part]
		)
		GROUP BY 
			PAT.[VCC]
			,PAT.[ProcessId]
			,PAT.[AudioId]
			,PAT.[Section]
			,PAT.[Part]
			,PAT.[CreatedByUserId]
			,PAT.[CreatedDate]

		DROP TABLE #AudioTemp
		DROP TABLE #ProcessAudioTemp

END
GO
PRINT N'Altering Procedure [dbo].[GetAudio]...';


GO
ALTER PROCEDURE [dbo].[GetAudio] (
	@VCC Varchar(50) = NULL,
	@ProcessId Varchar(50) = NULL,
	@ID Varchar(100) = NULL,
	@Section NUMERIC(5, 0) NULL,
	@Part NUMERIC(5, 0) NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT TOP 1
		A.[ID]						'id',
		A.[Section]					'section',
		A.[Part]					'part',
		PA.[ProcessId]				'processId',
		A.[Number]					'number',
		A.[Gender]					'gender',
		A.[SilenceTime]				'silenceTime',
		A.[DurationTime]			'durationTime',
		A.[DurationLinguisticTime]	'durationLinguisticTime',
		A.[Category1]				'category1',
		A.[Category2]				'category2',
		A.[Category3]				'category3',
		A.[Description]				'description',
		A.[Campaign]				'campaign',
		A.[Agent]					'agent',
		A.[Type]					'type',
		A.[Init]					'init',
		A.[ChannelsChanged]			'channelsChanged',
		A.[IsTranscribed]			'isTranscribed',
		A.[RelativePath]			'relativePath',
		A.[FileName]				'fileName',
		P.[Retranscription]			'retranscription',
		A.[RelativeFileName]		'relativeFileName'
	FROM [Audio] A (NOLOCK)
	LEFT JOIN [ProcessAudio] PA (NOLOCK)
		ON PA.[VCC] = A.[VCC]
			AND A.ID = PA.AudioId 
			AND A.Section = PA.Section 
			AND A.Part = PA.Part
	LEFT JOIN [dbo].[Process] P (NOLOCK)
		ON P.[VCC] = A.[VCC]
			AND PA.[ProcessId] = P.[Name]
	WHERE A.[VCC] = @VCC
		AND (
			(@ProcessId IS NOT NULL AND P.[Name] = @ProcessId)
			OR 
			(@ProcessId IS NULL)
		)
		AND A.[ID] = @ID
		AND A.[Section] = @Section
		AND A.[Part] = @Part
		AND A.[IsTranscribed] = 1
		AND A.[IsCancel] IS NULL
		AND P.[Name] IS NOT NULL
	ORDER BY A.CreatedDate DESC, PA.[CreatedDate] DESC

	SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[GetProcessInteractionsTask]...';


GO
ALTER PROCEDURE [dbo].[GetProcessInteractionsTask]
(
	@VCC		VARCHAR(50),
	@ProcessId	VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	BEGIN
		-- ACTUALIZAMOS LOS REGISTROS DE INTERACCIONES SINCRONAS(CALL) Y RETORNAMOS LOS DETALLES DE LAS QUE SE VAN A TRANSCRIBIR

		-- Actualiza en el primer momento que se consulta a estos registros, con el valor 1 en el campo IsProcess. Indica que se encuentra utilizado por un proceso.
		UPDATE [dbo].[Audio] SET
			[dbo].[Audio].[IsProcess] = 1,	-- Indicar que se esta tomando como procesando para que ningun otro procesamiento en parelelo pueda utilizar el registro.
			[dbo].[Audio].[IsCancel] = null, -- Limpiamos el campo isCancel para retomar los audios que fallaron en procesos pasados
			[dbo].[Audio].[ErrorMessage] = NULL
		
		-- Retornamos todas las columnas a listar.
		OUTPUT INSERTED.[VCC]							'vcc',
				PA.[ProcessId]							'processId',
				'CALL'									'interactionType',
				INSERTED.[ID]							'id',
				INSERTED.[Section]						'section',
				INSERTED.[Part]							'part',
				INSERTED.[StartDate]					'startDate',
				INSERTED.[EndDate]						'endDate',
				INSERTED.[Campaign]						'campaign',
				INSERTED.[DispositionCode]				'dispositionCode',
				INSERTED.[Agent]						'agent',
				INSERTED.[Type]							'origin',
				INSERTED.[RelativePath]					'relativePath',
				INSERTED.[FileName]						'fileName',
				INSERTED.[Format]                       'format',
				INSERTED.[MediaInfoTime]                'mediaInfoTime',
				INSERTED.[NeedI6Update]					'needI6Update',
				0										'isDiariced',
				P.[Language]							'language',
				P.[DictionaryId]						'dictionaryId',
				P.Retranscription						'retranscription',
				P.Diarization							'diarization',
				P.ChannelChange							'channelchange',
				E.[Name]								'name',
				E.[Type]								'environmentType',
				E.[Description]							'description',
				E.[FTPDirectory]						'ftpDirectory',
				E.[ApiHost]								'apiHost',
				E.[ApiPort]								'apiPort',
				E.[ApiUser]								'apiUser',
				E.[ApiPassword]							'apiPassword',
				E.[DbDisabled]							'dbDisabled',
				E.[DbServer]							'dbServer',
				E.[DbPort]								'dbPort',
				E.[DbUser]								'dbUser',
				E.[DbPassword]							'dbPassword',
				E.[PbxDisabled]							'pbxDisabled',
				E.[PbxServer]							'pbxServer',
				E.[PbxPort]								'pbxPort',
				E.[PbxUser]								'pbxUser',
				E.[PbxPassword]							'pbxPassword',
				INSERTED.[DurationTime]					'durationTime',
				INSERTED.[RelativeFileName]				'relativeFileName'
		FROM [dbo].[ProcessAudio] PA (NOLOCK)
		INNER JOIN [dbo].[Audio] A (NOLOCK) 
			ON A.[VCC] = PA.[VCC]
				AND CONCAT(A.[ID], '_', A.[Section], '_', A.[Part]) = CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part])
		INNER JOIN [dbo].[Process] P (NOLOCK) 
			ON P.[VCC] = A.[VCC]
				AND PA.ProcessId = P.[Name]
		INNER JOIN [dbo].[Environment] E (NOLOCK) 
			ON E.[VCC] = PA.[VCC]
				AND P.[Environment] = E.[Name]
		WHERE A.[VCC] = @VCC
			AND PA.[ProcessId] = @ProcessId
			AND (
				(
					ISNULL(A.[IsProcess], 0) = 0				
					AND 
					ISNULL(A.[IsTranscribed], 0) = 0	-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
				)
				OR 
				(
					A.[IsProcess] = 1						
					AND 
					A.[IsCancel] = 1
				)
			
				
				
			)					-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS

		-- ACTUALIZAMOS LOS REGISTROS DE INTERACCIONES ASINCRONAS Y RETORNAMOS LOS DETALLES DE LAS QUE SE VAN A TRANSCRIBIR
		UPDATE [dbo].[AsyncInteraction] 
		SET [dbo].[AsyncInteraction].[IsProcess] = 1,
			[dbo].[AsyncInteraction].[IsCancel] = NULL,
			[dbo].[AsyncInteraction].[ErrorMessage] = NULL
		OUTPUT INSERTED.[VCC]														'vcc',
				P.[Name]															'processId',
				INSERTED.[Channel]													'interactionType',
				INSERTED.[ID]														'id',
				INSERTED.[EndDate]													'endDate',
				INSERTED.[Folder]													'folder',
				INSERTED.[Campaign]													'campaign',
				INSERTED.[DispositionCode]											'dispositionCode',
				ISNULL(INSERTED.[LastTakedAgent], INSERTED.[FirstTakedAgent])		'agent',
				INSERTED.[Initiative]												'origin',
				INSERTED.[TotalMessages]											'totalMessages',
				INSERTED.[RawChar]													'rawChar',
				INSERTED.[ExportedContent]											'exportedContent',
				P.[Language]														'language',
				INSERTED.[FileName]                                                 'fileName',
				'allegro'															'environmentType',
				P.Retranscription													'retranscription'
		FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
		INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
			ON AI.[ID] = PAI.[InteractionId]
				-- AND AI.[EndDate] = PAI.[EndDate]
				AND FORMAT (AI.[EndDate], 'yyyy-MM-dd') = FORMAT (PAI.[EndDate], 'yyyy-MM-dd')
		INNER JOIN [dbo].[Process] P (NOLOCK) 
			ON P.[Name] = PAI.[ProcessId] 
		WHERE AI.[VCC] = @VCC
			AND PAI.[ProcessId] = @ProcessId
			AND (
				(
					ISNULL(AI.[IsProcess], 0) = 0
					AND 
					ISNULL(AI.[IsTranscribed], 0) = 0)	-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
				OR 
				(
					AI.[IsProcess] = 1
					AND 
					AI.[IsCancel] = 1
				)

				
			)					-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS
	END

	SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[GetTeamPerformanceFromEvaluationPlan]...';


GO
ALTER PROCEDURE [dbo].[GetTeamPerformanceFromEvaluationPlan] (
	@VCC					VARCHAR(50) = NULL,
	@EvaluationFormatId		VARCHAR(50) = NULL,
	@EvaluationPlanIds		VARCHAR(MAX) = NULL,
	@AgentIds				VARCHAR(MAX) = NULL,
	@AbilityIds				VARCHAR(MAX) = NULL,
	@StartDate				DATETIME,
	@EndDate				DATETIME,
	@drilldownTarget		VARCHAR(50) = NULL,
	@drilldownId			VARCHAR(50) = NULL
)
AS
BEGIN

	DROP TABLE IF EXISTS #SEARCHED_INTERACTIONS
	CREATE TABLE #SEARCHED_INTERACTIONS
	(
		AgentId				VARCHAR(100),
		EvaluationPlanId	VARCHAR(50),
		InteractionId		VARCHAR(250)
	)
	
	IF(@drilldownTarget ='ABILITY')
	BEGIN
		SET @AbilityIds = @drilldownId
	
		INSERT INTO #SEARCHED_INTERACTIONS
			SELECT DISTINCT ER.[IdAgent]															'AgentId',
							ER.[IdEvaluationPlan]													'EvaluationPlanId',
							ER.[IdInteraction]														'InteractionId' 
		
				FROM [dbo].[EvaluationResult] ER (NOLOCK)				
				INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
					ON ER.[Instance] = EP.[Instance]
						AND ER.[IdEvaluationPlan] = EP.[ID]
				INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					ON EP.[Instance] = AEP.[Instance]
						AND EP.[ID] = AEP.[IdEvaluationPlan]
						AND (
							(
								EP.[Status] = 7 
								AND 
								EP.Evaluation_Mode = 'A'
							)
							OR
							(	
								AEP.[Completed] = 1 
								AND 
								EP.Evaluation_Mode IN ('X','M')
							)
						)
						AND ER.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
						AND ER.[IdInteraction] = AEP.[IdInteraction]
						AND ER.[IdAgent] = AEP.[IdAgent]
						AND ER.[IdAuditor] = AEP.[IdAuditor]
						AND AEP.[Completed] = 1
						AND AEP.[StatusDescription] NOT IN('INVALID') 
				WHERE ER.[Instance] = @VCC
					AND ER.[InteractionDatefin] BETWEEN @StartDate AND @EndDate
					AND ER.[IdEvaluationFormat] = @EvaluationFormatId
					AND (
						ISNULL(LEN(@EvaluationPlanIds), 0) = 0
						OR					
						ER.[IdEvaluationPlan]  IN (SELECT Value FROM [dbo].[split](@EvaluationPlanIds, ','))
					)	
					AND (
						ISNULL(LEN(@AgentIds), 0) = 0
						OR
						ER.[IdAgent]  IN (SELECT Value FROM [dbo].[split](@AgentIds, ','))
					)
					AND (
						ISNULL(LEN(@AbilityIds), 0) = 0
						OR 					
						(
							ER.[IdAbility] IN (SELECT Value FROM [dbo].[split](@AbilityIds, ','))
							AND
							(
								/* EXCEPCION PARA HABILIDADES CUALITATIVAS Y CUANTITATIVAS, LAS CUALITATIVAS TIENEN [MaxAbilityScore] = 0 */
								/* Y NO PUEDE DISTINGUIRSE CUAL ES EL SCORE SELECCIONADO, POR ESO COMPARAMOS CON [AbilityInnerScore]      */
								(
									ER.[MaxAbilityScore] <> 0
									AND
									ER.[Qualification] = ER.[MaxAbilityScore]
								)
								OR
								(
									ER.[MaxAbilityScore] = 0
									AND
									ER.[AbilityInnerScore] = 100
								)
							)
						)
					)

	END
	ELSE
	BEGIN
		INSERT INTO #SEARCHED_INTERACTIONS
			SELECT DISTINCT ER.[IdAgent]															'AgentId',
							ER.[IdEvaluationPlan]													'EvaluationPlanId',
							ER.[IdInteraction]														'InteractionId' 
				FROM [dbo].[EvaluationResult] ER (NOLOCK)
				INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
					ON ER.[Instance] = EP.[Instance]
						AND ER.[IdEvaluationPlan] = EP.[ID]
				INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					ON EP.[Instance] = AEP.[Instance]
						AND EP.[ID] = AEP.[IdEvaluationPlan]
						AND (
							(
								EP.[Status] = 7 
								AND 
								EP.Evaluation_Mode = 'A'
							)
							OR
							(
								AEP.[Completed] = 1 
								AND 
								EP.Evaluation_Mode IN ('X','M')
							)
						)
						AND ER.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
						AND ER.[IdInteraction] = AEP.[IdInteraction]
						AND ER.[IdAgent] = AEP.[IdAgent]
						AND ER.[IdAuditor] = AEP.[IdAuditor]
						AND AEP.[Completed] = 1
						AND AEP.[StatusDescription] NOT IN('INVALID') 

				WHERE ER.[Instance] = @VCC
					AND ER.[InteractionDatefin] BETWEEN @StartDate AND @EndDate
					AND ER.[IdEvaluationFormat] = @EvaluationFormatId
					AND (
						ISNULL(LEN(@EvaluationPlanIds), 0) = 0
						OR					
						ER.[IdEvaluationPlan]  IN(SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))
						)
					
					AND (
						ISNULL(LEN(@AgentIds), 0) = 0
						OR
						ER.[IdAgent]  IN(SELECT Value FROM [dbo].[split](@AgentIds,','))
						)
			
					AND (
						ISNULL(LEN(@AbilityIds), 0) = 0
						OR 
						(
						ER.[IdAbility] IN (SELECT Value FROM [dbo].[split](@AbilityIds, ','))
					
						)
					)

	END


   
	-- GENERAMOS EL LISTADO DE INTERACCIONES A BUSCAR
	
	
	--SELECT * FROM #SEARCHED_INTERACTIONS
	-- OBTENEMOS TOTAL DE INTERACCIONES POR AGENTE	
	DROP TABLE IF EXISTS #SEARCHED_INTERACTIONS_TOTALBYAGENT
	SELECT [AgentId],COUNT([InteractionId]) 'Total' 
		INTO #SEARCHED_INTERACTIONS_TOTALBYAGENT
		FROM #SEARCHED_INTERACTIONS 
		GROUP BY [AgentId]
	
	--SELECT * FROM #SEARCHED_INTERACTIONS_TOTALBYAGENT
	
	--OBTENENEMOS SUMATORIA DE NOTAS POR AGENTE
	--PARA EL CASO DE MIXTAS LOS RESULTADOS SE MULTIPLICAN SEGUN EL NUMERO DE AUDITORES ES POR ELL QUE SE DEBE TOMAR 
	
	DROP TABLE IF EXISTS #SEARCHED_INTERACTIONS_NOTAS
	SELECT ER.[IdAgent]					'AgentId',
			ER.[IdEvaluationPlan]		'EvaluationPlanId',	
			ER.[IdInteraction]			'InteractionId', 
			SUM(Qualification)			'NotaTotal'
		INTO  #SEARCHED_INTERACTIONS_NOTAS
		FROM [dbo].[EvaluationResult] ER (NOLOCK)
		INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
			ON ER.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
				AND ER.[IdInteraction] = AEP.[IdInteraction]
				AND ER.[IdAgent] = AEP.[IdAgent]
				AND ER.[IdAuditor] = AEP.[IdAuditor]
				AND AEP.[Completed] = 1
				AND AEP.[StatusDescription] NOT IN('INVALID')
		INNER JOIN #SEARCHED_INTERACTIONS SI
			ON ER.[IdAgent] =SI.[AgentId]
				AND ER.[IdEvaluationPlan] = SI.[EvaluationPlanId]
				AND  ER.[IdInteraction] = SI.[InteractionId]
		WHERE ER.[Instance] = @VCC
			AND ER.[IdEvaluationFormat] = @EvaluationFormatId
			AND (
				ISNULL(LEN(@EvaluationPlanIds), 0) = 0
				OR					
			    ER.[IdEvaluationPlan]  IN(SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))
			)
		GROUP BY ER.[IdAgent],
					ER.[IdEvaluationPlan],
					ER.[IdInteraction]
					
				
	--SELECT * FROM #SEARCHED_INTERACTIONS_NOTAS
	-- OBTENEMOS EL PROMEDIO DE NOTAS POR AGENTE PARA OBTENER CUARILTES
	DROP TABLE IF EXISTS #SEARCHED_INTERACTIONS_NOTAS_PROM
    SELECT [AgentId], CAST(AVG([NotaTotal]) AS DECIMAL(7,1)) 'PromNotaTotal'
	INTO #SEARCHED_INTERACTIONS_NOTAS_PROM
	FROM #SEARCHED_INTERACTIONS_NOTAS
	GROUP BY [AgentId]			

	--SELECT * FROM #SEARCHED_INTERACTIONS_NOTAS_PROM

	--OBTENEMOS CUARTILES
	--OBTENEMOS CUARTILES DE ACUERDO A LOS PROMEDIOS DE NOTAS POR AGENTE
	DROP TABLE IF EXISTS #CUARTILES
	SELECT DISTINCT CAST([PromNotaTotal] AS DECIMAL(7,1)) 'PromNotaTotal'
	INTO #CUARTILES
	FROM #SEARCHED_INTERACTIONS_NOTAS_PROM

	DROP TABLE IF EXISTS #CUARTILES_ENUM
	SELECT ROW_NUMBER() OVER(ORDER BY [PromNotaTotal] DESC) 'lux',[PromNotaTotal] 
	INTO #CUARTILES_ENUM
	FROM #CUARTILES
    
	DECLARE @CUARTIL_EL INT
	SELECT @CUARTIL_EL = COUNT(*) FROM #CUARTILES_ENUM
	
	DROP TABLE IF EXISTS #CUARTILES_FINAL
	SELECT
    CAST(CE.[PromNotaTotal] AS DECIMAL(7,1)) 'PromNotaTotal',
    IIF (A.PromNotaTotal IS NOT NULL AND @CUARTIL_EL>=4 , 1,
        IIF (B.[PromNotaTotal] IS NOT NULL AND @CUARTIL_EL>=4, 2, 
        IIF (C.[PromNotaTotal] IS NOT NULL AND @CUARTIL_EL>=4, 3, 
        IIF (D.[PromNotaTotal] IS NOT NULL AND @CUARTIL_EL>=4, 4, 1)))
    ) as quartile
	INTO #CUARTILES_FINAL
	FROM
    #CUARTILES_ENUM CE
    LEFT OUTER JOIN #CUARTILES_ENUM A on CE.PromNotaTotal = A.PromNotaTotal and A.lux > (SELECT COUNT(*)*0.00 FROM #CUARTILES_ENUM) and a.lux <= (SELECT COUNT(*)*0.25 FROM #CUARTILES_ENUM)
    LEFT OUTER JOIN #CUARTILES_ENUM B on CE.PromNotaTotal = B.PromNotaTotal and B.lux > (SELECT COUNT(*)*0.25 FROM #CUARTILES_ENUM) and b.lux <= (SELECT COUNT(*)*0.50 FROM #CUARTILES_ENUM)
    LEFT OUTER JOIN #CUARTILES_ENUM C on CE.PromNotaTotal = C.PromNotaTotal and C.lux > (SELECT COUNT(*)*0.50 FROM #CUARTILES_ENUM) and c.lux <= (SELECT COUNT(*)*0.75 FROM #CUARTILES_ENUM)
    LEFT OUTER JOIN #CUARTILES_ENUM D on CE.PromNotaTotal = D.PromNotaTotal and D.lux > (SELECT COUNT(*)*0.75 FROM #CUARTILES_ENUM)


	-- OBTENEMOS LOS TIEMPOS DE CADA AGENTE
	DROP TABLE IF EXISTS #AGENT_AUDIOS_TIME
	SELECT A.[Agent]								'AgentId',
			A.[AgentName]							'AgentName',
			AVG(A.[DurationLinguisticTime])			'AverageLinguisticTime',
			SUM(A.[DurationLinguisticTime])			'TotalLinguisticTime'
		INTO #AGENT_AUDIOS_TIME
		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		INNER JOIN #SEARCHED_INTERACTIONS SI
			ON SI.[InteractionId] = IEP.[IdInteraction]
			AND SI.[EvaluationPlanId] = IEP.[IdEvaluationPlan]
		INNER JOIN [dbo].[Audio] A (NOLOCK)
			ON A.[VCC] = IEP.[Instance]
				AND A.[ID] = IEP.[IdInteraction]
				AND A.[Section] = IEP.[InteractionSection]
				AND A.[Part] = IEP.[InteractionPart]
		WHERE IEP.[Instance] = @VCC
			AND (
			 ISNULL(LEN(@EvaluationPlanIds), 0) = 0
			 OR
			 IEP.[IdEvaluationPlan]  IN (SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))

			)
			
		GROUP BY A.[Agent], 
					A.[AgentName]
	
	--SELECT * FROM  #AGENT_AUDIOS_TIME	
	
	-- OBTENEMOS LAS INTEARACCIONES QUE TUVIERON SENTIMIENTO POSITVO O NEGATIVO
	-- OBTENEMOS LAS INTEARACCIONES QUE TUVIERON SENTIMIENTO POSITVO O NEGATIVO
	SELECT DISTINCT SI.[AgentId],IEP.[IdEvaluationPlan],SR.[InteractionId] ,SR.[SentimentId]
		INTO #SEARCHED_INTERACTIONS_SENTIMENTS
		FROM [dbo].[SentimentAnalysisResult] SR (NOLOCK)
				INNER JOIN [dbo].[InteractionEvaluationPlan] IEP
					ON SR.[InteractionId] = IEP.[IdInteraction]
					AND SR.[InteractionSection] = IEP.[InteractionSection] 
					AND SR.[InteractionPart] = IEP.[InteractionPart]
					AND ISNULL(SR.[EndDate],'') = ISNULL(IEP.[InteractionDateEnd],'')
					AND IEP.[Instance] = @VCC					
					AND (
						 ISNULL(LEN(@EvaluationPlanIds), 0) = 0
						 OR					
						 IEP.[IdEvaluationPlan]  IN(SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))
						 )
					 AND SR.[AnalysisType] = 'Client'
					 AND SR.[Score] > 0
					 AND SR.[MaxScore] = 1
					 AND SR.[SentimentId] IN ('Positive','Negative') 
				
					INNER JOIN 
					#SEARCHED_INTERACTIONS SI 
					ON 	SR.[InteractionId] = SI.[InteractionId]
						AND IEP.[IdEvaluationPlan] = SI.[EvaluationPlanId]
						AND IEP.[IdAgent] = SI.[AgentId]
			 WHERE SR.VCC = @VCC
				AND SR.[AnalysisType] = 'Client'
				AND SR.[Score] > 0
				AND SR.[SentimentId] IN ('Positive','Negative')

		--SELECT * FROM #SEARCHED_INTERACTIONS_SENTIMENTS
			





	-- OBTENEMOS TOTAL DE INTERACCIONES POR AGENTE 
	DROP TABLE IF EXISTS #TOTALINTERACTION_SR_BY_AGENT
	SELECT [AgentId], COUNT([InteractionId]) 'TotalSentiments'
	INTO #TOTALINTERACTION_SR_BY_AGENT
	FROM  #SEARCHED_INTERACTIONS_SENTIMENTS
	GROUP BY [AgentId]


	

	DROP TABLE IF EXISTS #SENTIMENT_RESULT
	SELECT SIR.[AgentId]												'AgentId', 
		SIR.[SentimentId]												'SentimentId',
		COUNT(SIR.[InteractionId])										'Matches' ,
		CAST ((COUNT(SIR.[InteractionId])*100
		/
		CONVERT(DECIMAL(10,2),SRA.TotalSentiments)) AS DECIMAL(7,1))		'MatchesPercentage',
		SRA.[TotalSentiments]											'TotalSentiments',
	    SRAT.[Total]													'Total'
		
		INTO #SENTIMENT_RESULT
		FROM #SEARCHED_INTERACTIONS_SENTIMENTS SIR 
		INNER JOIN  #TOTALINTERACTION_SR_BY_AGENT SRA
		ON SIR.[AgentId] = SRA.[AgentId]
		INNER JOIN #SEARCHED_INTERACTIONS_TOTALBYAGENT SRAT
		ON SRAT.[AgentId] = SIR.[AgentId]
			
		GROUP BY SIR.[AgentId], SIR.[SentimentId], SRA.[TotalSentiments],[Total]	
		
    

	-- OBTENEMOS LAS HABILIDADES PARA NOMBRAR LAS COLUMNAS
		DECLARE @HABILITY_COLUMNS VARCHAR(MAX)
		SET @HABILITY_COLUMNS = STUFF(
				(
					/*
					SELECT DISTINCT ', ROUND(AVG(CAST(q.' + QUOTENAME(Ability) + ' AS float)), 2) As [' + Ability + ' Promedio]'
						FROM #TempEvaluationResult
					*/
					SELECT DISTINCT ',' + QUOTENAME(HA.[Id])
						FROM [dbo].[HistoricAbility] HA (NOLOCK) 
						WHERE HA.[VCC] = @VCC
							AND
                            (
                                ISNULL(LEN(@EvaluationPlanIds), 0) = 0
                                OR
                                HA.[EvaluationPlanId]  IN(SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))

                            ) 
                            
						FOR xml PATH (''), TYPE
				).value('.', 'VARCHAR(MAX)'), 
				1, 
				1, 
				''
		)

		DECLARE @HABILITY_COLUMNS_ISNULL VARCHAR(MAX)
		SET @HABILITY_COLUMNS_ISNULL = STUFF(
				(
					/*
					SELECT DISTINCT ', ROUND(AVG(CAST(q.' + QUOTENAME(Ability) + ' AS float)), 2) As [' + Ability + ' Promedio]'
						FROM #TempEvaluationResult
					*/
					SELECT DISTINCT ',' +'ISNULL('+ QUOTENAME(HA.[Id]) +',0) AS' + QUOTENAME(HA.[Id]) + ' '
						FROM [dbo].[HistoricAbility] HA (NOLOCK) 
						WHERE HA.[VCC] = @VCC
							AND
                            (
                                ISNULL(LEN(@EvaluationPlanIds), 0) = 0
                                OR
                                HA.[EvaluationPlanId]  IN(SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))

                            ) 
                            
						FOR xml PATH (''), TYPE
				).value('.', 'VARCHAR(MAX)'), 
				1, 
				1, 
				''
		)
		DECLARE @SENTIMENT_COLUMNS VARCHAR(100)
		DECLARE @ALL_COLUMNS VARCHAR(MAX)
		DECLARE @ALL_COLUMNS_ISNULL VARCHAR(MAX)
		SET @SENTIMENT_COLUMNS =',[Positive],[Negative]'
		SET @ALL_COLUMNS =  @HABILITY_COLUMNS + @SENTIMENT_COLUMNS
		SET @HABILITY_COLUMNS_ISNULL = @HABILITY_COLUMNS_ISNULL  +',ISNULL([Positive],0) AS [Positive],ISNULL([Negative],0) AS [Negative]'

		

		



	-- GENERAMOS EL RESUMEN DE RESULTADOS POR HABILIDAD Y MATCH POSITIVO
	DROP TABLE IF EXISTS #RESULTS_SUMMARY
	SELECT ER.[IdAgent]																	'AgentId',
			ER.[IdAbility]																'AbilityId',
			HA.[Title]																	'AbilityTitle',
			/*
			COUNT(IIF(ER.[Qualification] = ER.[MaxAbilityScore], 1, NULL))				'Matches',
			*/
			/* EXCEPCION PARA HABILIDADES CUALITATIVAS Y CUANTITATIVAS, LAS CUALITATIVAS TIENEN [MaxAbilityScore] = 0 */
			/* Y NO PUEDE DISTINGUIRSE CUAL ES EL SCORE SELECCIONADO, POR ESO COMPARAMOS CON [AbilityInnerScore]      */
			/*
			CASE WHEN ER.[MaxAbilityScore] <> 0
					THEN COUNT(IIF(ER.[Qualification] = ER.[MaxAbilityScore], 1, NULL))	
					ELSE COUNT(IIF(ER.[AbilityInnerScore] = 100, 1, NULL))
				END																		'Matches',
			*/
			COUNT(
				CASE WHEN ER.[MaxAbilityScore] <> 0
						THEN IIF(ER.[Qualification] = ER.[MaxAbilityScore], 1, NULL)
						ELSE IIF(ER.[AbilityInnerScore] = 100, 1, NULL)
					END
			)																			'Matches',
			/*
			CAST(COUNT(IIF(ER.[Qualification] = ER.[MaxAbilityScore], 1, NULL))*100
			/
			CONVERT(DECIMAL(4,2),SIT.Total) AS DECIMAL(7,1))							'MatchesPercentage',
			*/
			/* EXCEPCION PARA HABILIDADES CUALITATIVAS Y CUANTITATIVAS, LAS CUALITATIVAS TIENEN [MaxAbilityScore] = 0 */
			/* Y NO PUEDE DISTINGUIRSE CUAL ES EL SCORE SELECCIONADO, POR ESO COMPARAMOS CON [AbilityInnerScore]      */
			/*
			CASE WHEN ER.[MaxAbilityScore] <> 0
					THEN CAST(COUNT(IIF(ER.[Qualification] = ER.[MaxAbilityScore], 1, NULL)) * 100
							/
							CONVERT(DECIMAL(4, 2), SIT.Total) AS DECIMAL(7, 1))
					ELSE CAST(COUNT(IIF(ER.[AbilityInnerScore] = 100, 1, NULL)) * 100
							/
							CONVERT(DECIMAL(4, 2), SIT.Total) AS DECIMAL(7, 1))
				END																		'MatchesPercentage',

			*/
			CAST(
				COUNT(
					CASE WHEN ER.[MaxAbilityScore] <> 0
							THEN IIF(ER.[Qualification] = ER.[MaxAbilityScore], 1, NULL)
							ELSE IIF(ER.[AbilityInnerScore] = 100, 1, NULL)
						END
				) 
				* 
				100 
				/ 
				CONVERT(DECIMAL(10, 2), SIT.Total) AS DECIMAL(7, 1)
			)																			'MatchesPercentage',
			SIT.Total																	'Total'
			
			
		INTO #RESULTS_SUMMARY
		FROM [dbo].[EvaluationResult] ER (NOLOCK)
		INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
			ON ER.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
				AND ER.[IdInteraction] = AEP.[IdInteraction]
				AND ER.[IdAgent] = AEP.[IdAgent]
				AND ER.[IdAuditor] = AEP.[IdAuditor]
				AND AEP.[Completed] = 1
				AND AEP.[StatusDescription] NOT IN('INVALID')

		INNER JOIN [dbo].[HistoricAbility] HA (NOLOCK)
			ON HA.[EvaluationPlanId] = ER.[IdEvaluationPlan]
				AND HA.[ID] = ER.[IdAbility]
		INNER JOIN #SEARCHED_INTERACTIONS SI 
			ON SI.[AgentId] = ER.[IdAgent]
				AND SI.[EvaluationPlanId] =ER.[IdEvaluationPlan]
				AND SI.[InteractionId] = ER.[IdInteraction]
       INNER JOIN #SEARCHED_INTERACTIONS_TOTALBYAGENT (NOLOCK) SIT 
		ON ER.[IdAgent] =SIT.[AgentId]			
		WHERE ER.[Instance] = @VCC
			AND (
				ISNULL(LEN(@EvaluationPlanIds), 0) = 0
				OR
				ER.[IdEvaluationPlan]  IN(SELECT Value FROM [dbo].[split](@EvaluationPlanIds,','))
			)
		GROUP BY ER.[IdAgent],
					ER.[IdAbility],
					HA.[Title],
					SIT.[Total]

	 UNION ALL
	 SELECT [AgentId],[SentimentId],[SentimentId],[Matches],[MatchesPercentage],[Total]
		    FROM #SENTIMENT_RESULT
	
	  --SELECT * FROM 	#RESULTS_SUMMARY
	 -- OBTENEMOS LAS COLUMANS DINAMICAS(HABILIDADES,SENTIMIENTOS) Y ESTATICAS(TOTAL, AGENTE) PARA EL GRID 
	-- OBTENEMOS LAS COLUMANS DINAMICAS(HABILIDADES,SENTIMIENTOS) Y ESTATICAS(TOTAL, AGENTE) PARA EL GRID 
	 SELECT 'HEADER_QUARTILE' 'headerName', 'quartile' 'field', 'quartile' 'customtype'	 
	 UNION ALL
	 SELECT 'HEADER_AGENT' 'headerName','AgentId' 'field', 'agent' 'customtype'
	 UNION ALL
	 SELECT 'HEADER_TOTAL_INTERACTIONS' 'headerName', 'TotalInteractions' 'field', 'totalInteractions' 'customtype'
	 UNION ALL
	 SELECT DISTINCT AbilityTitle 'headerName',AbilityId 'field', 
     CASE WHEN HA.IsNegative = 1 AND AC.ID IS NOT NULL  THEN 'negativeAbility' 
          WHEN HA.IsNegative = 0 AND AC.ID IS NOT NULL THEN  'positiveAbility'
          ELSE 'normalAbility' END  'customtype'
	 FROM #RESULTS_SUMMARY RS
		INNER JOIN HistoricAbility HA 
		ON RS.AbilityId = HA.ID 
        LEFT JOIN AbilityScoreCard AC 
        ON HA.ID = AC.ID
        AND AC.DegradeScoreCard = 1 
        

	 WHERE AbilityId NOT IN('Positive','Negative')
	 UNION ALL
	 SELECT 'HEADER_PROM_NOTA_TOTAL' 'headerName','PromNotaTotal' 'field', 'finalnote' 'customtype'
	 UNION ALL
	 SELECT DISTINCT AbilityId 'headerName',AbilityTitle 'field','sentiment' 'customtype' FROM #RESULTS_SUMMARY
	 WHERE AbilityId IN('Positive','Negative')
	 UNION ALL
	 SELECT 'TMO' 'headerName','TMO' 'field', 'TMO' 'customtype'



	 

	-- ARMAR DRILLDOWN PARA SETEAR UN NUEVO TOTAL A LA TABLA RESULTANTE
	-- REQUERIMOS LOS DATOS DE AGENTEID, DRILLDOWNTARGET= HABILIDAD O SENTIMIENTO, DRILLDOWNID=IDABILIDAD O IDSENTIMIENTO.
	DECLARE @QUERY VARCHAR(MAX)

      
		SET @QUERY  = '
        
		SELECT P.[AgentId],
				' + @ALL_COLUMNS + ',
				P.[Total],
				INNER_AAT.[AverageLinguisticTime],
				INNER_AAT.[TotalLinguisticTime]


			INTO #RESULT_SUMMARY_PIVOT
			FROM (
				SELECT [AgentId],
						[AbilityId],
						[MatchesPercentage],
						[Total]
					FROM #RESULTS_SUMMARY
			)
			X
			PIVOT (
				MAX([MatchesPercentage]) FOR [AbilityId] IN (' + @ALL_COLUMNS + ')
			) P
			
			INNER JOIN #AGENT_AUDIOS_TIME INNER_AAT
				ON   INNER_AAT.[AgentId] = P.[AgentId]
                
			ORDER BY P.[Total] DESC ' + '

			
			
			SELECT	RSP.[AgentId],' + @HABILITY_COLUMNS_ISNULL+ ',					
					SIP.[PromNotaTotal],
					CF.[quartile] AS quartile,
					RSP.[Total] AS TotalInteractions,
					CAST (RSP.[AverageLinguisticTime] AS DECIMAL(7,1)) AS TMO
					
				
			
			FROM  #RESULT_SUMMARY_PIVOT RSP
			INNER JOIN #SEARCHED_INTERACTIONS_NOTAS_PROM SIP
                ON RSP.[AgentId] = SIP.[AgentId]
               
				
			INNER JOIN #CUARTILES_FINAL CF ON 
				CF.PromNotaTotal = SIP.PromNotaTotal

			ORDER BY SIP.[PromNotaTotal] DESC
			
	    '


	-- EJECUTAMOS EL QUERY ARMADO

	
	--PRINT (@QUERY)
	EXECUTE (@QUERY)

	

	DROP TABLE IF EXISTS #AGENT_AUDIOS_TIME
	DROP TABLE IF EXISTS #RESULTS_SUMMARY
END
GO
PRINT N'Altering Procedure [dbo].[BulkInteractionEvaluationPlan]...';


GO
ALTER PROCEDURE [dbo].[BulkInteractionEvaluationPlan]
AS
BEGIN
	SET NOCOUNT ON

	-- DECLARAMOS UNA VARIABLE PARA DEFINIR EL VCC
	DECLARE @VCC VARCHAR(50) = NULL
	DECLARE @VCC_TYPE VARCHAR(50) = NULL
	DECLARE @NEED_I6_UPDATE BIT = 0 

	-- ASIGNAMOS A LA VARIABLE EL NOMBRE DEL VCC
	SELECT TOP 1 @VCC = [VCC] FROM [#InteractionEvaluationPlanTemp] (NOLOCK)

	-- BUSCAMOS EL TIPO DE VCC
	SELECT @VCC_TYPE = V.[Type] FROM [dbo].[VCC] V (NOLOCK) WHERE V.[VCC] = @VCC

	-- CAMBIAMOS EL VALOR DEL FLAG
	IF @VCC_TYPE = 'I6' SET @NEED_I6_UPDATE = 1

	-- INSERTAMOS LA DATA DE LA TABLA TEMPORAL
	INSERT INTO [dbo].[InteractionEvaluationPlan] (
			[Instance], [IdEvaluationPlan], [IdAgent],
			[AgentName], [IdCampaign], [IdInteraction], 
			[FormattedEndDate], [InteractionSection], [InteractionPart], 
			[InteractionDateStart], [InteractionDateEnd], [InteractionType], 
			[InteractionMessages], [InteractionDuration], [InteractionOrigin], 
			[ManagementResult], [RelativePath], [FileName],
			[ContactId], [ContactAddress], [ContactName], 
			[InteractionFormat], 
			[NeedI6Update],
			[CreatedByUserId], [CreatedDate], [TimeStamp],[RelativeFileName])
		SELECT IEP.[VCC], IEP.[IdEvaluationPlan], IEP.[IdAgent],
				IEP.[AgentName], IEP.[IdCampaign], IEP.[IdInteraction], 
				IEP.[InteractionFolder], IEP.[InteractionSection], IEP.[InteractionPart], 
				IEP.[InteractionDateStart], IEP.[InteractionDateEnd], IEP.[InteractionType], 
				IEP.[TotalMessages], IEP.[InteractionDuration], IEP.[InteractionOrigin], 
				IEP.[InteractionManagementResult], IEP.[RelativePath], IEP.[FileName],
				IEP.[InteractionContactId], IEP.[InteractionContactAddress], IEP.[InteractionContactName],
				IEP.[InteractionFormat], 
				CASE WHEN @VCC_TYPE = 'OCC'
					THEN IIF(IEP.[InteractionType] = 'CALL', 0 , 1) 
					ELSE @NEED_I6_UPDATE
					END,
				IEP.[CreatedByUserId], GETUTCDATE(), GETUTCDATE(),[RelativeFileName]
			FROM [#InteractionEvaluationPlanTemp] IEP (NOLOCK)
			/*
			LEFT JOIN [dbo].[Agent] A (NOLOCK)
				ON A.[VCC] = IEP.[VCC]
					AND A.[AgentId] = IEP.[IdAgent]
			*/

	-- ELIMINAMOS LA TABLA TEMPORAL 
	DROP TABLE [#InteractionEvaluationPlanTemp]
	
	SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[GetEvaluationPlanByInteractionId]...';


GO
ALTER PROCEDURE [dbo].[GetEvaluationPlanByInteractionId] (
	@VCC VARCHAR(50) = NULL,
	@InteractionId VARCHAR(250) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

 	SELECT TOP 1
		EP.[ID]									'id',
		EP.[Modality]							'modality',
		EP.[DateFin]							'dateFin',
		EP.[CreatedDate]						'createdDate',
		EP.[CreatedByUserId]					'createdByUserId',
		EP.[LastModifiedDate]					'lastModifiedDate',
		EP.[LastModifiedByUserId]				'lastModifiedByUserId',
		EP.[Description]						'description',
		EP.[IdEvaluationFormat]					'idEvaluationFormat',
		EP.[EnvironmentId]						'environmentId',
		EP.[Enabled]							'enabled',
		EP.[Status]								'status',
        EP.[Evaluation_Mode]					'evaluation_mode',
        EP.[processId]    						'processId',
        EP.FilterByContent						'filterByContent',
        EP.EvaluatePercentage					'evaluatePercentage',
        EP.ProcessAndEvaluate    				'processAndEvaluate',
		IEP.[RelativePath]						'relativePath',
		IEP.[FileName]							'fileName',	
		IEP.[RelativeFileName]					'relativeFileName'
	FROM EvaluationPlan EP (NOLOCK) 
	INNER JOIN [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		ON IEP.[IdEvaluationPlan] = EP.[ID]
	WHERE EP.[Instance] = @VCC
		AND IEP.[IdInteraction] = @InteractionId
	GROUP BY EP.[ID], EP.[Modality], EP.[DateFin], EP.[CreatedDate], EP.[CreatedByUserId],
			 EP.[LastModifiedDate], EP.[LastModifiedByUserId], EP.[Description], EP.[IdEvaluationFormat], EP.[EnvironmentId], 
			 EP.[Enabled], EP.[Status], EP.[Evaluation_Mode], EP.[processId], EP.[FilterByContent], 
			 EP.[EvaluatePercentage], EP.[ProcessAndEvaluate], IEP.[RelativePath], IEP.[FileName], IEP.[RelativeFileName]
	ORDER BY EP.[CreatedDate] DESC

 	SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[GetAllegroInteractions]...';


GO
ALTER PROCEDURE [dbo].[GetAllegroInteractions] (
	@Ip						VARCHAR(50),
	@VCC					VARCHAR(50),
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@StartHour				VARCHAR(50),
	@EndHour				VARCHAR(50),
	@Campaign				VARCHAR(MAX),
	@Agent					VARCHAR(MAX),
	@ResultCode				VARCHAR(MAX),
	@Type					INT,
	@Origin					VARCHAR(MAX),
	@MinDuration			INT,
	@MaxDuration			INT,
	@Format					VARCHAR(50) = NULL, 
	@InteractionIds         VARCHAR(MAX) = NULL, 
	@Evaluated              VARCHAR(MAX) = NULL,
	-- @UniqueIds				BIT = 0,							-- ESTE FLAG TIENE COMO PROPOSITO RETORNAR LA LISTA CONSOLIDAD POR IDS O EL TOTAL DEL LISTADO (AUDIOS/INTERACTIONS)
	@ResultType				VARCHAR(50) = NULL,						-- VARIABLE PARA DETERMINAR SI LA BUSQUEDA SERA SOBRE SOBRE DETALLES O ID (DETAILED, SUMMARIZED)
	@ContactAddress			VARCHAR(300) = NULL
) AS
BEGIN
	-- SETTEAMOS UN VALOR POR DEFECTO AL FORMAT
	IF @Format IS NULL OR @Format = '' SET @Format = 'mp3,wav'

	-- SETTEAMOS VALORES MINIMOS PARA LAS HORAS DE INICIO Y FIN
	IF (@StartHour IS NOT NULL AND @StartHour = '') SET @StartHour = '00:00:00'
	IF (@EndHour IS NOT NULL AND @EndHour = '') SET @EndHour = '23:59:59'

	-- DECLARAMOS UNA VARIABLE PARA IDENTIFICAR SI EL SP ES LLAMADO DEL SISTEMA O POR OTRO SP
	DECLARE @IS_NESTED BIT = 0

	-- CREAMOS LAS VARIABLES QUE HARAN REFERENCIA A LAS TABLAS QUE PUEDEN SER EXTERNAS
	DECLARE @TABLE_HISTORICAL_DATA VARCHAR(50) = ''
	DECLARE @TABLE_MMPRODAT VARCHAR(50) = ''

	-- DECLARAMOS CADENAS PARA EL QUERY FINAL
	--DECLARE @SQL_SELECT_0 VARCHAR(MAX) = ''
	DECLARE @SQL_SELECT_1 VARCHAR(MAX) = ''
	DECLARE @SQL_FROM VARCHAR(MAX) = ''
	DECLARE @SQL_EXTRA VARCHAR(MAX) = ''
    DECLARE @FILTERS_OPTIONAL_PART VARCHAR(MAX) = ''
    DECLARE @FILTERS_EXCLUDING_PART VARCHAR(MAX) = ''
    DECLARE @FILTERS_FIXED_PART     VARCHAR(MAX) = ''
	
	DECLARE @Sql NVARCHAR(MAX)

	-- EL TYPE 0 INDICA QUE LAS TABLAS SE ENCUENTRAN EN UN SERVIDOR EXTERNO
	IF(@Type = 0)  
	BEGIN  
		SET @TABLE_HISTORICAL_DATA = '[' + @Ip + ']' + '.[HistoricalData].[dbo].'
		SET @TABLE_MMPRODAT = '[' + @Ip + ']' + '.[MMProDat].[dbo].'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @TABLE_HISTORICAL_DATA = '[HistoricalData].[dbo].'
		SET @TABLE_MMPRODAT = '[MMProDat].[dbo].'
	END
	
	IF(@Type = 0 OR @Type = 1)  
	BEGIN  
		-- ARMAMOS EL QUERY PARA HACER LA CONSULTA DE RESUMEN
		/*SET @SQL_SELECT_0 += '
			SET NOCOUNT ON
			SELECT COUNT(DISTINCT ID.[Id])								''totalInteractions'',
					COUNT(*)											''totalAudios'',
					SUM(ID.[AttentionTime])								''totalAttentionTime'' 
				'*/

		-- ARMAMOS EL QUERY PARA HACER LA CONSULTA DE CONTENIDO
		SET @SQL_SELECT_1 += '
			SET NOCOUNT ON
			SELECT ID.[Id] + ''_'' + CONVERT(VARCHAR(10), IMP.[Section]) + ''_'' + CONVERT(VARCHAR(10), IMP.Part)			''ID'',
					ID.[Id]																									''InteractionId'',
					IMP.[Section]																							''Section'',
					IMP.[Part]																								''Part'',
					''CALL''																								''Channel'',
					CASE WHEN ID.Direction = ''E'' THEN CID.CallerId ELSE CID.CalledId END									''Number'',
					''''																									''Gender'',
					ID.[HoldTime]																							''SilenceTime'',
					ID.[AttentionTime]																						''DurationTime'', -- ESTO SE DEBE CORREGIR
					ID.[AttentionTime]																						''AttentionTime'', -- SE AGREGO CAMPO PARA AMBOS EXISTAN
					ISNULL(CGRM.[Category1], '''')																			''Category1'',
					ISNULL(CGRM.[Category2], '''')																			''Category2'',
					ISNULL(CGRM.[Category3], '''')																			''Category3'',
					ISNULL(CGRM.[Description], '''')																		''Description'',
					ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), '''')															''DispositionCode'',
					ID.[Campaign]																							''Campaign'',
					ID.[LastAgent]																							''Agent'',
					IAD.[ActorName]																							''agentName'',
					ID.[Direction]																							''Type'',
					CONVERT(VARCHAR, ID.[StartDate], 120)																	''StartDate'',
					CONVERT(VARCHAR, ID.[EndDate], 120)																		''EndDate'',
					IMP.[Format]																							''Format'',
					CASE WHEN ID.Direction = ''E'' THEN CID.CallerId ELSE CID.CalledId END									''ContactAddress'',
					CASE WHEN ID.Direction = ''E'' THEN CID.CallerId ELSE CID.CalledId END									''ContactId'',
					ID.[ContactName]																						''ContactName'',
					IMP.[RelativePath]+''/''+ IMP.[FileName]															    ''RelativeFileName'',
					RNA = ROW_NUMBER() OVER(PARTITION BY (ID.[Id] + ''_'' + CONVERT(VARCHAR(10), IMP.[Section]) + ''_'' + CONVERT(VARCHAR(10), IMP.Part)) ORDER BY ID.[Id]) -- ROW NUMBER AUDIO
				'

		-- ARMAMOS LA PARTE DE TABLAS 
		SET @SQL_FROM += '
				FROM ' + @TABLE_HISTORICAL_DATA + '[InteractionMultimediaParts] IMP (NOLOCK)
				LEFT JOIN ' + @TABLE_HISTORICAL_DATA + '[InteractionDetail] ID (NOLOCK) 
					ON ID.Id = IMP.Id
				LEFT JOIN ' + @TABLE_HISTORICAL_DATA + '[InteractionActorDetail] IAD (NOLOCK)
					ON IAD.[Id] = ID.[Id]
						AND IAD.[Section] = IMP.[Section]
						AND IAD.[Part] = IMP.[Part]
				LEFT JOIN (
					SELECT VCC, CampaignID, [Order], [Code], 
									[Description], Category1, Category2, Category3 
						FROM ' + @TABLE_MMPRODAT + '[CampaignGoalResultManagement] (NOLOCK)
						WHERE VCC = ''' + @VCC + '''
				) CGRM  
					ON CGRM.VCC = ID.VirtualCC 
						AND CGRM.CampaignId = ID.Campaign 
						AND CGRM.[Description] = ID.ManagementResult
				INNER JOIN ' + @TABLE_HISTORICAL_DATA + '[CallInteractionDetail] CID (NOLOCK) 
					ON ID.Id = CID.Id 
				'

		-- ARMAMOS LA PARTE BASE DE FILTROS
		SET @FILTERS_FIXED_PART = '
				WHERE ID.[VirtualCC] = ''' + @VCC + '''
					AND ID.Id IS NOT NULL '
					
		SET @FILTERS_OPTIONAL_PART = 'AND id.[EndDate] BETWEEN ''' + (SELECT CONVERT(VARCHAR(21), @StartDate, 127)) + ''' 
					AND ''' + (SELECT CONVERT(VARCHAR(21), @EndDate, 127)) + '''
					AND IMP.[Format] IN (SELECT Value FROM [dbo].[split](''' + @Format + ''','',''))
					'

		IF (CAST(@StartHour AS TIME) <= CAST(@EndHour AS TIME)) SET @FILTERS_OPTIONAL_PART += 'AND CAST(ID.[EndDate] AS TIME) BETWEEN ''' + @StartHour + ''' AND ''' + @EndHour + ''' '
		IF (CAST(@StartHour AS TIME) > CAST(@EndHour AS TIME)) SET @FILTERS_OPTIONAL_PART += 'AND CAST(ID.[EndDate] AS TIME) NOT BETWEEN ''' + @EndHour + ''' AND ''' + @StartHour + ''' '
		
		IF(@Campaign IS NOT NULL AND @Campaign <> '') SET @FILTERS_OPTIONAL_PART += 'AND ID.[Campaign] IN (SELECT Value FROM [dbo].[split](''' + @Campaign + ''','','')) '

		IF(@Agent IS NOT NULL AND @Agent <> '') SET @FILTERS_OPTIONAL_PART += 'AND ID.[FirstAgent] IN (SELECT Value FROM [dbo].[split](''' + @Agent + ''','','')) '

		IF(@Origin IS NOT NULL AND @Origin <> '') SET @FILTERS_OPTIONAL_PART += 'AND ID.[Direction] IN (SELECT Value FROM [dbo].[split](''' + @Origin + ''','','')) '

		IF(@MinDuration IS NOT NULL) SET @FILTERS_OPTIONAL_PART += 'AND ID.[AttentionTime] >= ' + (SELECT CONVERT(varchar(10), @MinDuration)) + ' '

		IF(@MaxDuration IS NOT NULL) SET @FILTERS_OPTIONAL_PART += 'AND ID.[AttentionTime] <= ' + (SELECT CONVERT(varchar(10), @MaxDuration)) + ' '
		
		IF(@ContactAddress IS NOT NULL)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND ID.ContactId LIKE ''%' + @ContactAddress + '%''
			'
		END	

		IF(@ResultCode IS NOT NULL AND @ResultCode <> '') 
			SET @FILTERS_OPTIONAL_PART += 'AND (
									(CONCAT(ID.Campaign, ''_'', ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), '''')) IN (SELECT Value FROM [dbo].[split](''' + @ResultCode + ''','','')))
									OR
									(ID.[ManagementResult] IN (SELECT Value FROM [dbo].[split](''' + @ResultCode + ''','',''))) 
								) '
	   
		IF @InteractionIds IS NOT NULL AND @InteractionIds <> ''
		BEGIN
			SET @FILTERS_OPTIONAL_PART = '';
			SET @FILTERS_EXCLUDING_PART = ' AND ID.[Id] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) '
		END 

		SET @SQL_EXTRA = '
			SET NOCOUNT OFF '

		-- UNIMOS LAS PARTES DEL QUERY
		--SET @SQL_SELECT_0 += @SQL_FROM + @FILTERS_FIXED_PART + @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART + @SQL_EXTRA
		SET @SQL_SELECT_1 += @SQL_FROM + @FILTERS_FIXED_PART + @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART + @SQL_EXTRA

		-- VERIFICAMOS SI EXISTE LA TABLA TEMPORAL #TMP_HD_INTERACTIONS
		IF OBJECT_ID('TEMPDB..#TMP_HD_INTERACTIONS') IS NULL
		BEGIN
			-- CREAMOS UNA TABLA TEMPORAL PARA INSERTAR LOS REGISTROS DE LA HDI6
			CREATE TABLE #TMP_HD_INTERACTIONS
			(
				[ID] VARCHAR(150),
				[InteractionId] VARCHAR(100),
				[Section] INT,
				[Part] INT,
				[Channel] VARCHAR(50),
				[Number] VARCHAR(100),
				[Gender] VARCHAR(50),
				[SilenceTime] INT,
				[DurationTime] INT,
				[AttentionTime] INT,
				[Category1] VARCHAR(100),
				[Category2] VARCHAR(100),
				[Category3] VARCHAR(100),
				[Description] VARCHAR(150),
				[DispositionCode] INT,
				[Campaign] VARCHAR(150),
				[Agent] VARCHAR(100),
				[AgentName] VARCHAR(100),
				[Type] VARCHAR(100),
				[StartDate] VARCHAR(100),
				[EndDate] VARCHAR(100),
				[Format] VARCHAR(50),
				[ContactAddress] VARCHAR(300),
				[ContactId]  VARCHAR(50),
				[ContactName] VARCHAR(300),
				[RelativeFileName] VARCHAR(1000),
				[RNA] INT
			)

			-- REAFIRMAMOS QUE EL SP NO ESTA ANIDADO EN OTRO
			SET @IS_NESTED = 0
		END
		ELSE
		BEGIN
			-- SI LA TABLA TEMPORAL YA EXISTIA, EL SP ESTA ANIDADO EN OTRO (P.E.: [dbo].[GetAsyncBillingInteractions])
			SET @IS_NESTED = 1
		END 
		
		-- EJECUTAMOS EL QUERY Y DEPOSITAMOS EL RESULTADO EN UNA TABLA TEMPORAL
		INSERT INTO #TMP_HD_INTERACTIONS
			-- EJECUTAMOS LA CONSULTA
			EXEC (@SQL_SELECT_1)

		-- VARIABLES PARA TRABAJAR CON LA TABLA TEMPORAL AL FINAL DEL SP
		DECLARE @QUERY_SUMMARY VARCHAR(MAX) = ''
		DECLARE @QUERY_DETAIL VARCHAR(MAX) = ''
		DECLARE @QUERY VARCHAR(MAX) = ''
		DECLARE @QUERY_FILTER VARCHAR(MAX) = ''
		DECLARE @QUERY_JOIN VARCHAR(MAX) = ''
	
		-- FILTRO POR INTERACCIONES EVALUADAS O NO
		IF(@Evaluated IS NOT NULL AND @Evaluated <> '')
		BEGIN 
			DECLARE @EvaluatedTable TABLE (Val BIT)
			INSERT INTO @EvaluatedTable SELECT Value FROM [dbo].[split]( @Evaluated ,',')
			-- SOLAMENTE SI ES SI O NO
			IF((SELECT COUNT(Val) FROM @EvaluatedTable) = 1 )
			BEGIN
				IF((SELECT Val FROM @EvaluatedTable WHERE Val = 1) IS NOT NULL) -- Si  es Si
				BEGIN 
					SET @QUERY_JOIN = ' JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) ON (AEP.[IdInteraction] = HDI.[InteractionId] AND AEP.[Completed] = 1) '
				END
				ELSE  --Si es No
				BEGIN
					SET @QUERY_JOIN += ' LEFT JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) ON (AEP.[IdInteraction] = HDI.[InteractionId] AND AEP.[Completed] = 1) '
					SET @QUERY_FILTER = ' AND AEP.[IdInteraction] IS NULL '
				END
			END
		END
		-- FIN FILTRO INTERACCIONES EVALUADAS

		-- SI EL SP NO ESTA ANIDADO, HACEMOS SELECT AL RESULTADO A MOSTRAR
		IF @IS_NESTED = 0
		BEGIN
			-- EN AMBOS CASOS SE REQUIERE EL RESUMEN
			SET @QUERY_SUMMARY = '
				SELECT HDI.[channel]										AS ''interactionType'',
						COUNT(DISTINCT (HDI.[InteractionId]))				AS ''interactions'',
						COUNT(DISTINCT (HDI.[ID]))							AS ''details'',
						SUM(HDI.[AttentionTime])							AS ''attentionTime''
					FROM #TMP_HD_INTERACTIONS HDI '
			SET @QUERY +=  @QUERY_SUMMARY + @QUERY_JOIN
			SET @QUERY += ' WHERE HDI.[RNA] = 1 ' + @QUERY_FILTER + ' GROUP BY HDI.[channel] '

			-- HACEMOS EL SELECT SEGUN EL TIPO DE BUSQUEDA SETTEADO
			--IF @ResultType = 'SUMMARIZED'
			--BEGIN
			-- END
			-- ELSE 
			IF @ResultType = 'DETAILED'
			BEGIN
				SET @QUERY_DETAIL = '
					SELECT HDI.* 
						FROM #TMP_HD_INTERACTIONS HDI ' 
				SET @QUERY += @QUERY_DETAIL + @QUERY_JOIN 
				SET @QUERY += ' WHERE HDI.[RNA] = 1 ' + @QUERY_FILTER + ' '
			END

			-- EJECUTAMOS LA CONSULTA
			EXEC (@QUERY)
    
			-- ELIMINAMOS LA TABLA TEMPORARL
			DROP TABLE #TMP_HD_INTERACTIONS
		END
	END
	ELSE
	BEGIN
		SET @Sql = 'SELECT 1 AS ''result'''		
		EXEC (@Sql)
	END

END

GO
PRINT N'Altering Procedure [dbo].[GetTemplateThemeModels]...';


GO
ALTER PROCEDURE [dbo].[GetTemplateThemeModels] (
	@VCC Varchar(50) = NULL, 
	@TemplateId Varchar(50) = NULL,
	@TemplateThemeId Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- DECLARAMOS UNA VARIABLE PARA DETERMINAR SI ES UN FORMATO O PLANTILLA
	DECLARE @TEMPLATE_TYPE VARCHAR(50) = NULL

	-- BUSCAMOS POR EL ID SI SE TRATA DE UNA PLANTILLA O FORMATO
	IF EXISTS (
		SELECT 1 
			FROM [dbo].[Template] T (NOLOCK)
			INNER JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
				ON EF.[Instance] = T.[VCC]
					AND EF.[templateId] = T.[Name]
			WHERE T.[VCC] = @VCC
				AND T.[Name] = @TemplateId
	)
		SET @TEMPLATE_TYPE = 'EVALUATION_FORMAT'
	ELSE 
		SET @TEMPLATE_TYPE = 'TEMPLATE'

	-- SELECCIONAMOS LOS ITEMS INMEDIATOS RELACIONADOS AL TEMPLATE
	SELECT DISTINCT A.[VCC]												'vcc',	
					A.[TemplateId]										'templateId',
					A.[TemplateThemeId]									'templateThemeId',
					A.[ID]												'id',
					-- CASE WHEN ISNULL(GQ.[Query],'') = ISNULL(NULL,'') THEN A.[ID] ELSE GQ.[Query] END	'query',
					--A.[ID]												'query',
					CASE WHEN @TEMPLATE_TYPE = 'EVALUATION_FORMAT' 
						THEN A.[ID]
						ELSE 
							CASE WHEN NI.[nluId] IS NOT NULL 
								THEN NI.[nluId] + '|' + NI.[intentId]
								ELSE A.[ID]
								END
						END												'query',
					TT.[AnalysisType]									'analysisType',
					@TEMPLATE_TYPE										'templateType',
					A.[AcceptancePercentage]							'acceptancePercentage',
					ISNULL(A.[AcceptancePercentage],0) * 100			'acceptanceInteger',
					A.[CreatedDate]										'createdDate',
					A.[CreatedByUserId]									'createdByUserId',
					A.[LastModifiedDate]								'lastModifiedDate',
					A.[LastModifiedByUserId]							'lastModifiedByUserId'
		INTO #TEMPLATE_MODELS 
		FROM [TemplateThemeItem] A (NOLOCK)
		INNER JOIN [dbo].[TemplateTheme] TT (NOLOCK)
			ON TT.[VCC] = A.[VCC]
				AND TT.[TemplateId] = A.[TemplateId]
				AND TT.[ID] = A.[TemplateThemeId]
		LEFT JOIN [dbo].[GenericQuery] GQ (NOLOCK) 
			ON A.[ID] = GQ.[Name] 
				AND A.[VCC] = GQ.[VCC]
		LEFT JOIN (
			SELECT DISTINCT
					INNER_N.[VCC]								'vcc'
					,INNER_N.[Name] + '|'+ INNER_I.[Name]		'cognitiveId'
					,INNER_N.[Name]								'nluId'
					,INNER_N.[AppId]							'appId'
					,INNER_I.[IntentId]							'intentId'
					,INNER_I.[Name]
				FROM [dbo].[NLU] INNER_N (NOLOCK)
				INNER JOIN [dbo].[Intent] INNER_I (NOLOCK) 
					ON INNER_N.[VCC] = INNER_I.[VCC]
						AND INNER_N.AppId = INNER_I.[AppId] 
				WHERE INNER_N.[VCC] = @VCC
		) NI 
			ON NI.[vcc] = A.[VCC]
				AND NI.[cognitiveId] = A.[ID]
		WHERE A.[VCC] = @VCC
			AND A.[TemplateId] = CASE WHEN ISNULL(@TemplateId, '') = '' THEN A.[TemplateId] ELSE @TemplateId END
			AND A.[TemplateThemeId] = CASE WHEN ISNULL(@TemplateThemeId, '') = '' THEN A.[TemplateThemeId] ELSE @TemplateThemeId END
			AND GQ.[Name] IS NULL

	-- PARA TEMPLATES DE UN FORMATO, AGREGAMOS LAS QUERY_ID (INTENTS) DE LAS TIPIFICACIONES DE 1ER NIVEL
	IF @TEMPLATE_TYPE = 'EVALUATION_FORMAT'
	BEGIN
		INSERT INTO #TEMPLATE_MODELS 
			SELECT DISTINCT EFASTQ.[VCC],
							EF.[templateId],
							'',
							EFASTQ.[QueryId],
							EFASTQ.[QueryId],
							A.[AnalysisType],
							@TEMPLATE_TYPE,
							EFASTQ.[AcceptancePercentage],
							EFASTQ.[AcceptancePercentage] * 100, 
							NULL,
							NULL,
							NULL,
							NULL
				FROM [dbo].[EvaluationFormatAbilityScoreTipificationQuery] EFASTQ (NOLOCK)
				INNER JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
					ON EF.[Instance] = EFASTQ.[VCC]
						AND EF.[ID] = EFASTQ.[EvaluationFormatId]
				INNER JOIN [dbo].[Score] S (NOLOCK)
					ON S.[Instance] = EFASTQ.[VCC]
						AND S.[ID] = EFASTQ.[ScoreId]
				INNER JOIN [dbo].[Ability] A (NOLOCK)
					ON A.[Instance] = EFASTQ.[VCC]
						AND A.[ID] = S.[IdAbility]
				WHERE EFASTQ.[VCC] = @VCC
					AND EF.[templateId] = @TemplateId

	END
	--select * FROM [dbo].[EvaluationFormatAbilityScoreTipificationQuery] EFASTQ (NOLOCK)
	--SELECT * FROM Score (NOLOCK)
	-- CONSULTAMOS EL TOTAL DE LA TABLA TEMPORAL
	SELECT * FROM #TEMPLATE_MODELS (NOLOCK)

	SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[SaveEvaluationResult]...';


GO

ALTER PROCEDURE [dbo].[SaveEvaluationResult] (
	@Instance Varchar(50) = NULL,
	@Id Varchar(250) = NULL,
	@IdCampaign Varchar(50) = NULL,
	@IdInteraction Varchar(250) = NULL,
	@IdAgent Varchar(50) = NULL,
	@IdEvaluationFormat Varchar(50) = NULL,
	@MinQualificationAcceptable numeric(5,2) = NULL,
	@IdGroup Varchar(50) = NULL,
	@IdSubGroup Varchar(50) = NULL,
	@IdAbility Varchar(50) = NULL,
	@Qualification numeric(5,2) = NULL,
	@OwnScore NUMERIC(5,2) = NULL,
	@InheritedScore NUMERIC(5,2) = NULL,
	@IdEvaluator Varchar(50) = NULL,
	@EvaluationDate Datetime = NULL,
	@MaxAbilityScore numeric(5,2) = NULL,
	@AbilityInnerScore NUMERIC(5,2) = NULL,
	@IdEvaluationPlan Varchar(50) = NULL,
	@Comment Varchar(1000) = NULL,
	@NotApplies bit = NULL,
	@ScoreDescription varchar(100) = NULL,
	@CampaignDescription varchar(100) = NULL,
	@AgentDescription varchar(100) = NULL,
	@InteractionDateini [datetime] = NULL,
	@InteractionDatefin [datetime] = NULL,
	@InteractionAddress VARCHAR(200) = NULL,
	@InteractionType varchar(50) = NULL,
	@AbilityOrder numeric(4,0) = NULL,
	@CreatedDate Datetime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId Varchar(50) = NULL,
	@Conditional varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	DECLARE @IdAbilityEvaluationFormat Varchar(50) = NULL

	-- RECUPERAMOS EL IDABILITYEVALUATIONFORMAT
	SELECT @IdAbilityEvaluationFormat = ID
		FROM [AbilityEvaluationFormat] (NOLOCK)
		WHERE [Instance] = @Instance
			AND [IdEvaluationFormat] = @IdEvaluationFormat
			AND [IdGroup] = @IdGroup
			AND [IdSubGroup] = @IdSubGroup
			AND [IdAbility] = @IdAbility
			AND isNull([Conditional],'') = isNull(@Conditional,'')

	-- BUSCAMOS SI YA EXISTE UN REGISTRO EN LA BASE DE DATOS PARA LA EVALUACION
	DECLARE @SAVED_QUALIFICATION NUMERIC(5, 2) = NULL
	DECLARE @SAVED_COMMENT       VARCHAR(1000) = NULL

	SELECT @SAVED_QUALIFICATION = ER.[Qualification],
	       @SAVED_COMMENT = ER.[Comment]
		FROM [dbo].[EvaluationResult] ER (NOLOCK)
		WHERE ER.[Instance] = @Instance
			AND ER.[IdEvaluationPlan] = @IdEvaluationPlan
			AND ER.[IdEvaluationFormat] = @IdEvaluationFormat
			AND ER.[IdAbility] = @IdAbility
			AND ER.[IdAbilityEvaluationFormat] = @IdAbilityEvaluationFormat
			AND ER.[IdInteraction] = @IdInteraction
			AND ER.[IdAuditor] = @IdEvaluator

	-- 
	IF @SAVED_QUALIFICATION IS NULL 
	BEGIN
	   
		-- INSERTAMOS EL NUEVO RESULT
		INSERT INTO [dbo].[EvaluationResult]
			   ([Instance]
			   ,[IdCampaign]
			   ,[IdInteraction]
			   ,[IdAgent]
			   ,[IdEvaluationFormat]
			   ,[MinQualificationAcceptable]
			   ,[IdGroup]
			   ,[IdSubGroup]
			   ,[IdAbility]
			   ,[Qualification]
			   ,[OwnScore]
			   ,[InheritedScore]
			   ,[IdEvaluator]
			   ,[IdAuditor]
			   ,[EvaluationDate]
			   ,[MaxAbilityScore]
			   ,[AbilityInnerScore]
			   ,[IdEvaluationPlan]
			   ,[Comment]
			   ,[NotApplies]
			   ,[ScoreDescription]
				,[CampaignDescription]
				,[AgentDescription]
				,[InteractionDateini]
				,[InteractionDatefin]
				,[InteractionAddress]
				,[InteractionType]
				,[AbilityOrder]
			   ,[CreatedDate]
			   ,[CreatedByUserId]
			   ,[LastModifiedDate]
			   ,[LastModifiedByUserId]
			   ,[IdAbilityEvaluationFormat]
			   ,[Conditional]
			   ,[TimeStamp]
			   )
		 VALUES
			   (
			   @Instance,
			   @IdCampaign,
				@IdInteraction,
				@IdAgent,
				@IdEvaluationFormat,
				@MinQualificationAcceptable ,
				@IdGroup, @IdSubGroup, @IdAbility,
				@Qualification,
				@OwnScore,
				@InheritedScore,
				@IdEvaluator,
				@IdEvaluator,
				@EvaluationDate,
				@MaxAbilityScore,
				@AbilityInnerScore,
				@IdEvaluationPlan,
				@Comment,
				@NotApplies,
				@ScoreDescription,
				@CampaignDescription,
				@AgentDescription,
				@InteractionDateini,
				@InteractionDatefin,
				@InteractionAddress,
				@InteractionType,
				@AbilityOrder,
				@CreatedDate,@CreatedByUserId,@LastModifiedDate,@LastModifiedByUserId,
				@IdAbilityEvaluationFormat,
				@Conditional,
			   GETUTCDATE())

	END
	ELSE
	BEGIN

		-- PRINT CONCAT('SAVED: ', @SAVED_QUALIFICATION)
		-- PRINT CONCAT('INPUT: ', @Qualification)

		-- ACTUALIZAMOS LA CALIFICACION EN CASO SEA DIFERENTE
		UPDATE [dbo].[EvaluationResult] 
			SET [Qualification] = @Qualification,
				[OwnScore] = @OwnScore,
				[InheritedScore] = @InheritedScore,
				[AbilityInnerScore] = @AbilityInnerScore,
				[ScoreDescription] = @ScoreDescription,
				[IdEvaluator] = @IdEvaluator,
				[LastModifiedByUserId] = @LastModifiedByUserId,
				[LastModifiedDate] = @LastModifiedDate,
				[TimeStamp] = GETUTCDATE(),
				[NotApplies] = @NotApplies
			WHERE [Instance] = @Instance
				AND [IdEvaluationPlan] = @IdEvaluationPlan
				AND [IdEvaluationFormat] = @IdEvaluationFormat
				AND [IdAbility] = @IdAbility
				AND [IdAbilityEvaluationFormat] = @IdAbilityEvaluationFormat
				AND [IdInteraction] = @IdInteraction
				AND [IdAuditor] = @IdEvaluator
		
		--ACTUALIZAR EL COMENTARIO
		IF @Comment <> ISNULL(@SAVED_COMMENT,'') 
		BEGIN 
			UPDATE [dbo].[EvaluationResult] 
					SET	[Comment] = @Comment
					WHERE [Instance] = @Instance
						AND [IdEvaluationPlan] = @IdEvaluationPlan
						AND [IdEvaluationFormat] = @IdEvaluationFormat
						AND [IdAbility] = @IdAbility
						AND [IdAbilityEvaluationFormat] = @IdAbilityEvaluationFormat
						AND [IdInteraction] = @IdInteraction
						AND [IdAuditor] = @IdEvaluator

		END
		
		
	END

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[SaveInteractionEvaluationPlanResult]...';


GO

ALTER PROCEDURE [dbo].[SaveInteractionEvaluationPlanResult] (
	@VCC VARCHAR(50),
	@IdEvaluationPlan VARCHAR(50),
	@IdAuditor VARCHAR(50),
	@IdInteraction VARCHAR(250),
	@InteractionType VARCHAR(50),
	@Score NUMERIC(5,2),
	@AutomaticScore NUMERIC(5,2),
	@ManualScore NUMERIC(5,2),
	@IsDraft BIT
) AS
BEGIN
	SET NOCOUNT ON

	IF @IsDraft IS NULL
		SET @IsDraft = 0

 	UPDATE [dbo].[AuditorEvaluationPlan] 
		SET [Completed] = IIF (@IsDraft = 1, 0, 1), 
			[Score] = @Score, 
			[AutomaticScore] = @AutomaticScore,
			[ManualScore] = @ManualScore,
			[StatusDescription] = IIF (@IsDraft = 1, 'DRAFT', 'COMPLETED'),
			[LastModifiedDate] = GETUTCDATE(),
			[TimeStamp] = GETUTCDATE()
		WHERE [Instance] = @VCC
			AND [IdEvaluationPlan] = @IdEvaluationPlan
			AND [IdInteraction] = @IdInteraction
			AND [InteractionType] = @InteractionType
			AND [IdAuditor] = @IdAuditor

	-- ACTUALIZAMOS LAS NOTAS FINALES TENIENDO EN CUENTA LAS PENALIZACIONES
	
	IF (@IsDraft  = 0)
	BEGIN
		;WITH CTEFP AS (
			SELECT DISTINCT 
					ER.[Instance],
					ER.[IdInteraction],
					ER.[IdEvaluationPlan],
					ER.[IdEvaluationFormat],
					ER.[IdAbility],
					CASE WHEN ER.[AbilityInnerScore] = 0 AND HAEF.[Penalizes] <> 'NO' THEN 1 ELSE 0 END 'Penalized',
					HAEF.[Penalizes],
					CASE HAEF.[Penalizes]
						WHEN 'INT' THEN ER.[IdInteraction] 
						WHEN 'GRP' THEN ER.[IdGroup] 
						WHEN 'SGR' THEN ER.[IdSubGroup] 
					END 'PenalizedOn',
					RN = ROW_NUMBER() OVER(PARTITION BY ER.[IdInteraction], CASE WHEN ER.[Qualification] = 0 THEN 1 ELSE 0 END 
						ORDER BY CASE HAEF.[Penalizes]
						WHEN 'INT' THEN 1 
						WHEN 'GRP' THEN 2 
						WHEN 'SGR' THEN 3 
					END)
				FROM [EvaluationResult] ER (NOLOCK) 
				LEFT JOIN [HistoricAbilityEvaluationFormat] HAEF (NOLOCK) 
					ON HAEF.[VCC] = ER.[Instance]
						AND HAEF.[EvaluationPlanId] = ER.[IdEvaluationPlan]
						AND HAEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
						AND HAEF.[IdAbility] = ER.[IdAbility]
				WHERE ER.[IdEvaluationPlan] IN (@IdEvaluationPlan) 
					AND ER.[IdInteraction] = @IdInteraction
					AND ER.[IdAuditor] = @IdAuditor
					AND ER.[AbilityInnerScore] = 0
					AND HAEF.[Penalizes] <> 'NO'
				-- WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EPA.[EvaluationPlanId] FROM [DummyEvaluationPlanAbility] EPA (NOLOCK) WHERE EPA.[EvaluationPlanId] IS NOT NULL)

		),

		CTEFS AS (
			SELECT ER.[Instance],
					ER.[IdEvaluationPlan],
					ER.[IdInteraction],
					ER.[IdAuditor],
					SUM(ER.[Qualification])															'TOTAL_SCORE',
					SUM(IIF(HA.[Type] = 'MANUAL_AUTOMATIC', ER.[Qualification], 0))					'TOTAL_AUTOMATIC_SCORE',
					SUM(IIF(HA.[Type] = 'MANUAL', ER.[Qualification], 0))							'TOTAL_MANUAL_SCORE',
					--SUM(ER.[Qualification] * CASE WHEN FP2.[Penalized] IS NULL THEN 1 ELSE 0 END) 'PENALIZED_SCORE',
					SUM(ER.[Qualification] * (
						CASE WHEN (
							CASE FP2.[Penalizes]
								WHEN 'INT' THEN ER.[IdInteraction] 
								WHEN 'GRP' THEN ER.[IdGroup] 
								WHEN 'SGR' THEN ER.[IdSubGroup] 
							END = FP2.[PenalizedOn]
							AND FP2.[Penalized] = 1) THEN 0 ELSE 1 END
					))																				'PENALIZED_SCORE',
					SUM(IIF(HA.[Type] = 'MANUAL_AUTOMATIC',
						ER.[Qualification] * (
						CASE WHEN (
							CASE FP2.[Penalizes]
								WHEN 'INT' THEN ER.[IdInteraction] 
								WHEN 'GRP' THEN ER.[IdGroup] 
								WHEN 'SGR' THEN ER.[IdSubGroup] 
							END = FP2.[PenalizedOn]
							AND FP2.[Penalized] = 1
						) THEN 0 ELSE 1 END),
						0) 
					)																				'PENALIZED_AUTOMATIC_SCORE',
					SUM(IIF(HA.[Type] = 'MANUAL',
						ER.[Qualification] * (
						CASE WHEN (
							CASE FP2.[Penalizes]
								WHEN 'INT' THEN ER.[IdInteraction] 
								WHEN 'GRP' THEN ER.[IdGroup] 
								WHEN 'SGR' THEN ER.[IdSubGroup] 
							END = FP2.[PenalizedOn]
							AND FP2.[Penalized] = 1
						) THEN 0 ELSE 1 END),
						0) 
					)																				'PENALIZED_MANUAL_SCORE'
				FROM EvaluationResult ER (NOLOCK) 
				LEFT JOIN (
					-- HACEMOS UN CRUCE CON LA TABLA VARIABLE Y TOMAMOS SOLO UNA DE LAS PENALIZACIONES POR INTERACCION, EMPEZANDO 
					--  POR LA MAS PRIORITARIA (FP.[RN])
					SELECT DISTINCT FP.[Instance],
									FP.[IdEvaluationPlan], 
									FP.[IdInteraction], 
									FP.[Penalized],
									FP.[Penalizes], 
									FP.[PenalizedOn]
						FROM CTEFP FP (NOLOCK)
						WHERE FP.[Penalizes] <> 'NO'
							AND FP.[RN] = 1
				) FP2

					ON FP2.[Instance] = ER.[Instance]
						AND ER.[IdEvaluationPlan] = FP2.[IdEvaluationPlan]
						AND ER.[IdInteraction] = FP2.[IdInteraction]
						/*
						AND CASE FP2.[Penalizes]
								WHEN 'INT' THEN ER.[IdInteraction] 
								WHEN 'GRP' THEN ER.[IdGroup] 
								WHEN 'SGR' THEN ER.[IdSubGroup] 
							END = FP2.[PenalizedOn]
						AND FP2.[Penalized] = 1
						*/
				INNER JOIN dbo.[HistoricAbility] HA (NOLOCK)
					ON HA.[VCC] = ER.[Instance]
						AND HA.[EvaluationPlanId] = ER.[IdEvaluationPlan]
						AND HA.[ID] = ER.[IdAbility]
				--WHERE ER.[Instance] = 'multisalud'
				WHERE -- ER.[Instance] = FP2.[Instance] -- ESTA LINEA CAUSA QUE NO SE ACTUALICEN LOS SCORES LAS EVALUACIONES QUE NO PENALIZAN
					-- AND 
					ER.[IdEvaluationPlan] IN (@IdEvaluationPlan) 
					AND ER.[IdInteraction] = @IdInteraction
					AND ER.[IdAuditor] = @IdAuditor
					--AND ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM DummyEvaluationPlanAbility)
				GROUP BY ER.[Instance],
					ER.[IdEvaluationPlan],
					ER.[IdInteraction],
					ER.[IdAuditor]
		)
		--SELECT * FROM CTEFS

		-- ACTUALIZAMOS LOS REGISTROS DE EVALUACION CON LA NOTA PENALIZADA OBTENIDA EN LOS PASOS ANTERIORES
		UPDATE AEP 
			SET AEP.[Score] = FS.[PENALIZED_SCORE],
				AEP.[AutomaticScore] = FS.[PENALIZED_AUTOMATIC_SCORE],
				AEP.[ManualScore] = FS.[PENALIZED_MANUAL_SCORE],
				AEP.[LastModifiedDate] = GETUTCDATE(),
				AEP.[TimeStamp] = GETUTCDATE()
			FROM AuditorEvaluationPlan AEP (NOLOCK)
			LEFT JOIN CTEFS FS (NOLOCK) 
				ON FS.[Instance] = AEP.[Instance] 
					AND FS.[IdEvaluationPlan] = AEP.[IdEvaluationPlan] 
					AND FS.[IdInteraction] = AEP.[IdInteraction]
					AND FS.[IdAuditor] = AEP.[IdAuditor]
			WHERE FS.[Instance] IS NOT NULL
	END

    SELECT 1 AS 'result'

 	SET NOCOUNT OFF
END
GO
PRINT N'Creating Procedure [dbo].[GetInteractionsEvaluationPlan]...';


GO
CREATE PROCEDURE [dbo].[GetInteractionsEvaluationPlan] (
	@Instance Varchar(50) = NULL, 
	@IdEvaluationPlan Varchar(50) = NULL/*,
	@IdAuditor Varchar(50) = NULL*/
	)
AS
BEGIN
	SET NOCOUNT ON
	SELECT
		IEP.[IdInteraction]					'id',
		IEP.[IdCampaign]					'idCampaign',
		IEP.[IdCampaign]					'descriptionCampaign',
		IEP.[IdAgent]						'idAgent',
		IEP.[IdAgent]						'descriptionAgent',
		IEP.[InteractionDateStart]			'dateIni',
		IEP.[InteractionDateEnd]			'dateFin',
		IEP.[InteractionDuration]			'interactionTime',
		/*IEP.[Evaluated]					'evaluated',*/
		IEP.[InteractionType]				'interactionType',
		IEP.[ManagementResult]				'dispositionCode',
		IEP.[ContactId]						'contactName',
		IEP.[InteractionOrigin]				'origin',
		IEP.[ContactAddress]				'contactAddress'
	FROM [InteractionEvaluationPlan] IEP (NOLOCK)
	WHERE [Instance] = @Instance
		AND [IdEvaluationPlan] = @IdEvaluationPlan
	ORDER BY IEP.[CreatedDate],
				IEP.[InteractionDateEnd] DESC,
				IEP.[IdEvaluationPlan],
				IEP.[IdInteraction]

	SET NOCOUNT OFF
END
GO
PRINT N'Refreshing Procedure [dbo].[BulkInteractionProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionProcess]';


GO
PRINT N'Refreshing Procedure [dbo].[BulkInteractionQueryStudy]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionQueryStudy]';


GO
PRINT N'Refreshing Procedure [dbo].[BulkProcessI6Update]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkProcessI6Update]';


GO
PRINT N'Refreshing Procedure [dbo].[BulkProcessInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkProcessInteraction]';


GO
PRINT N'Refreshing Procedure [dbo].[CloseI6InteractionAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[CloseI6InteractionAudio]';


GO
PRINT N'Refreshing Procedure [dbo].[DeleteI6InteractionAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteI6InteractionAudio]';


GO
PRINT N'Refreshing Procedure [dbo].[DeleteInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteInteraction]';


GO
PRINT N'Refreshing Procedure [dbo].[EvaluateProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[EvaluateProcessStatus]';


GO
PRINT N'Refreshing Procedure [dbo].[GetAllegroBillingInteractionsForEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAllegroBillingInteractionsForEvaluationPlan]';


GO
PRINT N'Refreshing Procedure [dbo].[GetAudioNavigatorInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudioNavigatorInteractions]';


GO
PRINT N'Refreshing Procedure [dbo].[GetAudios]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudios]';


GO
PRINT N'Refreshing Procedure [dbo].[GetAudiosByProcessId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosByProcessId]';


GO
PRINT N'Refreshing Procedure [dbo].[GetAudiosProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosProcess]';


GO
PRINT N'Refreshing Procedure [dbo].[GetBillingInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetBillingInteractions]';


GO
PRINT N'Refreshing Procedure [dbo].[GetCleanerData]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetCleanerData]';


GO
PRINT N'Refreshing Procedure [dbo].[GetCognitiveAnalysisProcessValidDurationTime]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetCognitiveAnalysisProcessValidDurationTime]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationPlanCognitiveInteractionTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveInteractionTask]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationPlanCognitiveTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveTask]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationPlanInteractionByTypeAndId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanInteractionByTypeAndId]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationPlanTipificationInteractionTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanTipificationInteractionTask]';


GO
PRINT N'Refreshing Procedure [dbo].[GetExecuteTemplateProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetExecuteTemplateProcess]';


GO
PRINT N'Refreshing Procedure [dbo].[GetGlobalSearchFilters]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetGlobalSearchFilters]';


GO
PRINT N'Refreshing Procedure [dbo].[GetGlobalSearchInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetGlobalSearchInteractions]';


GO
PRINT N'Refreshing Procedure [dbo].[GetI6AlreadyRegisteredCallInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetI6AlreadyRegisteredCallInteractions]';


GO
PRINT N'Refreshing Procedure [dbo].[GetI6InteractionAudios]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetI6InteractionAudios]';


GO
PRINT N'Refreshing Procedure [dbo].[GetInteractionAgents]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionAgents]';


GO
PRINT N'Refreshing Procedure [dbo].[GetInteractionCampaigns]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionCampaigns]';


GO
PRINT N'Refreshing Procedure [dbo].[GetInteractionsCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsCognitive]';


GO
PRINT N'Refreshing Procedure [dbo].[GetInteractionsResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsResult]';


GO
PRINT N'Refreshing Procedure [dbo].[GetInteractionTranscription]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionTranscription]';


GO
PRINT N'Refreshing Procedure [dbo].[GetLinguisticProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetLinguisticProcessStatus]';


GO
PRINT N'Refreshing Procedure [dbo].[GetPendingAudios]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetPendingAudios]';


GO
PRINT N'Refreshing Procedure [dbo].[GetProcessFiltersData]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessFiltersData]';


GO
PRINT N'Refreshing Procedure [dbo].[GetProcessI6InteractionsToUpdate]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessI6InteractionsToUpdate]';


GO
PRINT N'Refreshing Procedure [dbo].[GetProcessInteractionsByProcessId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessInteractionsByProcessId]';


GO
PRINT N'Refreshing Procedure [dbo].[GetProcessInteractionsHistory]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessInteractionsHistory]';


GO
PRINT N'Refreshing Procedure [dbo].[GetProcessSummary]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessSummary]';


GO
PRINT N'Refreshing Procedure [dbo].[GetProcessValidDurationTime]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessValidDurationTime]';


GO
PRINT N'Refreshing Procedure [dbo].[GetStudiesInProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudiesInProcess]';


GO
PRINT N'Refreshing Procedure [dbo].[GetStudyCognitiveInteractionsTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyCognitiveInteractionsTask]';


GO
PRINT N'Refreshing Procedure [dbo].[GetStudyResultSummary]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyResultSummary]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveAudio]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveAudioLinguisticProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveAudioLinguisticProcess]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveEvaluationBaseResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationBaseResult]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveProcess]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveStudyBaseResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveStudyBaseResult]';


GO
PRINT N'Refreshing Procedure [dbo].[BulkAbilityCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkAbilityCognitive]';


GO
PRINT N'Refreshing Procedure [dbo].[BulkEvaluationPlanAbility]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkEvaluationPlanAbility]';


GO
PRINT N'Refreshing Procedure [dbo].[BulkInteractionCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionCognitive]';


GO
PRINT N'Refreshing Procedure [dbo].[BulkEvaluationPlanQuery]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkEvaluationPlanQuery]';


GO
PRINT N'Refreshing Procedure [dbo].[CleanFailedBatchData]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[CleanFailedBatchData]';


GO
PRINT N'Refreshing Procedure [dbo].[CleanFailedEvaluationPlanData]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[CleanFailedEvaluationPlanData]';


GO
PRINT N'Refreshing Procedure [dbo].[DeleteEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationPlan]';


GO
PRINT N'Refreshing Procedure [dbo].[DeleteEvaluationPlanInteractionByTypeAndId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationPlanInteractionByTypeAndId]';


GO
PRINT N'Refreshing Procedure [dbo].[GetAuditorEvaluationPlanEvaluation]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAuditorEvaluationPlanEvaluation]';


GO
PRINT N'Refreshing Procedure [dbo].[GetCognitiveInteractionIntents]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetCognitiveInteractionIntents]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationResultsFromAuditorEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationResultsFromAuditorEvaluationPlan]';


GO
PRINT N'Refreshing Procedure [dbo].[GetI6InteractionMessages]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetI6InteractionMessages]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveEvaluationEfectivitySample]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationEfectivitySample]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveI6InteractionAsyncInteractionForEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveI6InteractionAsyncInteractionForEvaluationPlan]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveI6InteractionSyncInteractionForEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveI6InteractionSyncInteractionForEvaluationPlan]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveInteractionEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveInteractionEvaluationPlan]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveInteractionEvaluationPlanSample]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveInteractionEvaluationPlanSample]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveI6InteractionAsyncInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveI6InteractionAsyncInteraction]';


GO
PRINT N'Refreshing Procedure [dbo].[BulkProgress]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkProgress]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveI6InteractionAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveI6InteractionAudio]';


GO
PRINT N'Update complete.';


GO
